      SUBROUTINE AVGCON (IOUT,IDONE)
C
C     PROGRAM READS A BINARY AVERAGE FILE FROM AN AIRSHED SIM AND
C     WRITES IT OUT IN ASCII FORMAT.
C
C     UNITS FOR ALL CONCENTRATIONS ARE PPM
C
C     FILE 8: DIAGNOSTIC OUTPUT
C     FILE 5: INPUT, ASCII AIRSHED AVERAGE CONCENTRATION FILE
C     FILE 9: OUTPUT, BINARY AIRSHED AVERAGE CONCENTRATION FILE
C
      include 'nampar.cmd'
      COMMON /LCM/ CONC(MXX,MXY)
C
C     ***  READ THE FOUR HEADER RECORDS
C
      IDONE=1
      READ (7)ifile,note,NOSEG,NOSPEC,IDATB,TIMBEG,JDATE,TIMEND
      WRITE(9,1000) ifile,note,NOSEG,NOSPEC,IDATB,TIMBEG,JDATE,TIMEND
      WRITE(IOUT,1001) ifile,note,IDATB,TIMBEG,JDATE,TIMEND
C
      READ (7) XREF,YREF,IUTM,XORG,YORG,DELTAX,DELTAY,NOXG,
     $ NOYG,NOZG,NCELL1,NCELL2,SURFHT,HTMIN1,HTMIN2
      WRITE(9,2001) XREF,YREF,IUTM,XORG,YORG,DELTAX,DELTAY,NOXG,
     $ NOYG,NOZG,NCELL1,NCELL2,SURFHT,HTMIN1,HTMIN2
C
      READ  (7) ILOCX,ILOCY, NOX,NOY
      WRITE(9,1002) ILOCX,ILOCY, NOX,NOY
C
      IF (NOSPEC .GT. MXSPC .OR. NOX .GT. MXX .OR. NOY .GT. MXY) THEN
        WRITE(*,'(A,/,A)') ' PROGRAM ARRAY DIMENSIONS EXCEEDED',
     $                     ' CHECK GRID SIZE'
        STOP
      ENDIF
C
      READ  (7) ((MSPEC(I,J),I=1,10),J=1,NOSPEC)
      WRITE(9,1003) ((MSPEC(I,J),I=1,10),J=1,NOSPEC)
C
      IF(NOSEG.NE.1) STOP 6
C     IF NOSEG>1 PROGRAM NEEDS TO LOOP OVER SEGMENTS.
C
C     ***  WRITE THE HEADER RECORDS FOR THE ASCII FILE
C
200   CONTINUE
C
C     ***  READ AND WRITE THE TIME VARYING DATA FOR 24 HRS
C
      IBHR = TIMBEG + 1
      IEHR = TIMEND
       DO 500 LL=1,9999
          READ(7,END=999) IBGDAT, BEGTIM, IENDAT, ENDTIM
          WRITE(9,1005) IBGDAT, BEGTIM, IENDAT, ENDTIM
          WRITE(IOUT,1005) IBGDAT,BEGTIM,IENDAT,ENDTIM
C
C   LOOP OVER SPECIES, ORDER OF SPECIES IS ESTABLISHED IN CHEMPARAM FILE
C
          DO 400 ISPEC=1,NOSPEC
C
C    LOOP OVER NUMBER OF VERTICAL LEVELS IN SIMULATION GRID
C
             DO 401 IZ=1,NOZG
                READ (7) ISEG, ifile, ((CONC(I,J),I=1,NOX),J=1,NOY)
                WRITE (9,1006) ISEG, ifile
                WRITE (9,1007) ((CONC(I,J),I=1,NOX),J=1,NOY)
401          CONTINUE
400       CONTINUE
500    CONTINUE
C
C
  999 RETURN
 1000 FORMAT(10A1,60A1,/,I2,1X,I2,1X,I6,F6.0,I6,F6.0)
 1001 FORMAT(10X,10A1/5X,60A1/5X,I10,F10.2,I10,F10.2//)
 1002 FORMAT(4I5)
 1003 FORMAT(10A1)
 1005 FORMAT(5X,2(I10,F10.2))
 1006 FORMAT(I4,10A1)
 1007 FORMAT(9E14.9)
 2001 FORMAT(F10.1,1X,F10.1,1X,I3,F10.1,1X,F10.1,1X,2F6.0,5I4,3F7.0)
      END
