       SUBROUTINE EMICON (IOUT,IDONE)
C
C  ** PROGRAM EMISCON.F
C
C      PROGRAM READS THE BINARY EMISSIONS FILE THAT IS INPUT INTO
C      THE SAI AIRSHED MODEL AND REFORMATS THIS FILE SO
C      IT IS IN ASCII FORMAT
C   INPUT:
C         FT05F001  -  BINARY FILE
C   OUTPUT:
C         FT09F001  -  ASCII FORMATTED FILE
C         FT08F001  -  OUTPUT HOURS
C
      INCLUDE 'nampar.cmd'
      COMMON /LCM/ EMOB(MXX,MXY)
C
C    THE ORDER IS (NO, NO2, OLE, PAR, ARO, ETH, CARB, SO2, CO AERO)
C
C**       CALL ERRSET(187,256,-1,1,1,1)
C
C   READ AND WRITE OUT FILE HEADER INFORMATION
C
      IDONE=1
      READ (7)IFILE,NOTE,NSEG,NSPECS,IDATE,BEGTIM,JDATE,ENDTIM
2100  FORMAT(10A1,60A1,/,I2,1X,I2,1X,I6,F6.0,I6,F6.0)
      WRITE (IOUT,1005) IDATE, BEGTIM, JDATE, ENDTIM
      READ  (7) ORGX,ORGY,IZONE,UTMX,UTMY,DELTAX,DELTAY,NX,NY,
     $ NZ,NZLOWR,NZUPPR,HTSUR,HTLOW,HTUPP
 2001  FORMAT(F10.1,1X,F10.1,1X,I3,F10.1,1X,F10.1,1X,2F6.0,5I4,3F7.0)
      IF (NSPECS .GT. MXSPC .OR. NX .GT. MXX .OR. NY .GT. MXY) THEN
        WRITE(*,'(A,/,A)') ' PROGRAM ARRAY DIMENSIONS EXCEEDED',
     $                     ' CHECK GRID SIZE'
        STOP
      ENDIF
      READ  (7) IX,IY,NXCLL,NYCLL
 1002 FORMAT(4I5)
      READ  (7) ((MSPEC(I,J),I=1,10),J=1,NSPECS)
 1003  FORMAT(10A1)
      WRITE (9,2100) IFILE,NOTE,NSEG,NSPECS,IDATE,BEGTIM,JDATE,ENDTIM
      WRITE (9,2001) ORGX, ORGY, IZONE, UTMX, UTMY, DELTAX, DELTAY,
     $          NX, NY, NZ, NZLOWR, NZUPPR, HTSUR, HTLOW, HTUPP
      WRITE (9,1002) IX, IY, NXCLL, NYCLL
      WRITE (9,1003) ((MSPEC(M,L),M=1,10),L=1,NSPECS)
C*
C
C    LARGE LOOP FOR 24 HOURS OF EMISSIONS
C
      DO 1000 IH = 1,9999
          READ  (7,END=999) IBGDAT, BEGTIM, IENDAT, ENDTIM
          WRITE (9,1005) IBGDAT,BEGTIM,IENDAT,ENDTIM
          WRITE(IOUT,1005) IBGDAT,BEGTIM,IENDAT,ENDTIM
1005      FORMAT(5X,2(I10,F10.2))
C
C    LOOP ON INDIVIDUAL SPECIES -  READ AND WRITE OUT IN ASCII
C
          DO 400 L = 1,NSPECS
             READ (7) ISEG, (MSPEC(M,L),M = 1,10), ((EMOB(I,J),
     $          I=1,NX),J=1,NY)
              WRITE (9,1006) ISEG, (MSPEC(M,L),M=1,10)
 1006            FORMAT(I4,10A1)
              WRITE (9,1007) ((EMOB(I,J),I=1,NX),J=1,NY)
 1007            FORMAT(9E14.7)
  400     CONTINUE
 1000 CONTINUE
  999 RETURN
       END
