       SUBROUTINE TERFRM (IOUT,IDONE)
C
C
C      PROGRAM READS THE BINARY TERRAIN FILE THAT WILL BE INPUT INTO
C      THE SAI AIRSHED MODEL AND REFORMATS THIS FILE
C
      INCLUDE 'nampar.cmd'
      COMMON /LCM/ ROUGH(MXX,MXY)
Ctcm  DIMENSION TNAME(10,MXSPC)
      character*4 TNAME(10,MXSPC)
C
C
C   READ AND WRITE OUT FILE HEADER INFORMATION
C
      IDONE=1
      READ(7) IFILE,NOTE,NSEG,NSPECS, IDATE, BEGTIM, JDATE, ENDTIM
C*    WRITE(9,2100) IFILE,NOTE,NSEG,NSPECS,IDATE,BEGTIM,JDATE,ENDTIM
      WRITE (IOUT,1005) IDATE, BEGTIM, JDATE, ENDTIM
C  REGION DESCRIPTOR HEADER
      READ(7) ORGX, ORGY, IZONE, UTMX, UTMY, DELTAX, DELTAY,
     $          NX, NY, NZ, NZLOWR, NZUPPR, HTSUR, HTLOW, HTUPP
C*    WRITE (9,2001) ORGX,ORGY,IZONE,UTMX,UTMY,DELTAX,DELTAY,NX,NY,
C*   $ NZ,NZLOWR,NZUPPR,HTSUR,HTLOW,HTUPP
      IF (NSPECS .GT. MXSPC .OR. NX .GT. MXX .OR. NY .GT. MXY) THEN
        WRITE(*,'(A,/,A)') ' PROGRAM ARRAY DIMENSIONS EXCEEDED',
     $                     ' CHECK GRID SIZE'
        STOP
      ENDIF
C  SEGMENT ORIGIN AND SEGMENT SIZE
      READ (7) IX, IY, NXCLL, NYCLL
C*    WRITE (9,1002) IX,IY,NXCLL,NYCLL
      IBHR=BEGTIM +1
      IEHR=ENDTIM
  10  CONTINUE
C
      NPANL = (NX-1)/18 + 1
C*
C
C  TIME INVARIANT DATA
C
      IF (NSEG.EQ.0) GO TO 31
C
C  TIME INVARIANT DATA - SURFACE ROUGHNESS AND VEGFACTOR
C
         READ (7) ISEGM,(TNAME(II,1),II=1,10),
     &      ((ROUGH(II,JJ),II=1,NX),JJ=1,NY)
      DO 50 NN=1,NPANL
         I1 = (NN-1)*18 + 1
         I2 = MIN(NX,I1+17)
         WRITE (9,1021) (TNAME(II,1),II=1,10)
         WRITE(9,1030) (I,I=I1,I2)
         WRITE(9,1035)
         DO 40 J=NY,1,-1
           WRITE(9,1040) J, (ROUGH(I,J),I=I1,I2)
   40    CONTINUE
   50 CONTINUE
C
         READ (7)      ISEGM,(TNAME(II,2),II=1,10),
     &      ((ROUGH(II,JJ),II=1,NX),JJ=1,NY)
      DO 70 NN=1,NPANL
         I1 = (NN-1)*18 + 1
         I2 = MIN(NX,I1+17)
         WRITE (9,1021) (TNAME(II,2),II=1,10)
         WRITE(9,1030) (I,I=I1,I2)
         WRITE(9,1035)
         DO 60 J=NY,1,-1
           WRITE(9,1040) J, (ROUGH(I,J),I=I1,I2)
   60    CONTINUE
   70 CONTINUE
  31  CONTINUE
  999 RETURN
 1002 FORMAT(4I5)
 1003 FORMAT(10A1)
 1005 FORMAT(5X,2(I10,F10.2))
 1006 FORMAT(I4,10A1)
 1021 FORMAT(///,1X,10A1)
 1030 FORMAT(/,6X,18I7)
 1035 FORMAT(/)
 1040 FORMAT(1X,I5,18F7.4)
 2001 FORMAT(F10.1,1X,F10.1,1X,I3,F10.1,1X,F10.1,1X,2F6.0,5I4,3F7.0)
 2100 FORMAT(10A1,60A1,/,I2,1X,I2,1X,I6,F6.0,I6,F6.0)
       END
