      SUBROUTINE WNDCON (IOUT,IDONE)
C
C            THIS PROGRAM READS THE FORMATTED ASCII AIRSHED WIND FILE
C            AND REWRITES THE FILE INTO A BINARY FILE.
C
C       THIS PROGRAM IS USED TO TRANSFER THE 3-D WIND FILES
C       INTO FILES THAT CAN BE WRITTEN ON
C       TAPE AND TRANSFERRED
C
C    THIS PROGRAM USED TO CREATE ONE WIND FILE:
C         1) WIND.26.ASCII
C      FROM THE BINARY AIRSHED INPUT WIND FILES USED IN THE
C      ACTUAL SIMULATIONS.
C
C     WIND COMPONENT UNITS ARE METERS/HOUR
C
      INCLUDE 'nampar.cmd'
      COMMON /LCM/ WX(MXX,MXY)
      REAL*8     WWX(MXX,MXY)
Ctcm  DIMENSION  WINDX(10), WINDY(10)
      character*4  WINDX(10), WINDY(10)
C
C     READ WIND FILE HEADER INFO AND WRITE TO NEW FILE
C
      IDONE=1
      READ (7) IFILE, NOTE, NSEG, NSPECS, JDATE, BEGTIM, IDATE,
     $ ENDTIM
      WRITE (9,1000) IFILE,NOTE,NSEG,NSPECS,JDATE,BEGTIM,IDATE,ENDTIM
      WRITE (IOUT,1000) IFILE, NOTE, NSEG, NSPECS, JDATE, BEGTIM, IDATE
     1 , ENDTIM
      READ(7) ORGX, ORGY, IZONE, UTMX, UTMY, DELTAX, DELTAY,
     1          NX, NY, NZ, NZLOWR, NZUPPR, HTSUR, HTLOW, HTUPP
      WRITE (9,1001) ORGX, ORGY, IZONE, UTMX, UTMY, DELTAX, DELTAY,
     1          NX, NY, NZ, NZLOWR, NZUPPR, HTSUR, HTLOW, HTUPP
      IF (NSPECS .GT. MXSPC .OR. NX .GT. MXX .OR. NY .GT. MXY) THEN
        WRITE(*,'(A,/,A)') ' PROGRAM ARRAY DIMENSIONS EXCEEDED',
     $                     ' CHECK GRID SIZE'
        STOP
      ENDIF
 1001  FORMAT(F10.2,F10.2,I3,F10.2,F10.2,2F6.0,5I4,3F7.0)
      READ (7) IX, IY, NXCLL, NYCLL
      WRITE (9,1002) IX, IY, NXCLL, NYCLL
C
C     MAJOR LOOP FOR 24 HOURS
C
      IBHR = BEGTIM + 1
      IEHR = ENDTIM
      DO 100 ITM = 1,9999
         READ  (7,END=999) IDATE, TDATA, JDATE, TNEXT
         WRITE(IOUT, 5000) IDATE, TDATA, JDATE, TNEXT
         WRITE (9,1003) IDATE, TDATA, JDATE, TNEXT
       READ  (7) ISEG, REF, XMX, YMX, WEST, EAST, SOUTH, ORTH
       WRITE(IOUT,2345) XMX,YMX
 2345   FORMAT(4X,F10.3,3X,F10.3)
       WRITE (9,1004) ISEG, REF, XMX, YMX, WEST, EAST, SOUTH, ORTH
C
C       LOOP FOR N NUMBER OF LEVELS
C
       DO 90 K = 1,NZ
C
C
C     WRITE OUT U AND V COMPONENT WIND VECTORS TO FORMATTED FILE
C
         READ (7) ISEG, WINDX, ((WX(I,J),I=1,NX),J=1,NY)
         DO 70 I=1,NX
            DO 70 J=1,NY
               WWX(I,J)=WX(I,J)
   70       CONTINUE
         WRITE (9,1005) ISEG, WINDX
         WRITE (9,1006)  ((WWX(I,J), I = 1,NX), J =1, NY)
C
         READ (7) JSEG, WINDY, ((WX(I,J),I=1,NX),J=1,NY)
         DO 71 I=1,NX
            DO 71 J=1,NY
               WWX(I,J)=WX(I,J)
   71       CONTINUE
         WRITE (9,1005) JSEG, WINDY
         WRITE (9,1006) ((WWX(I,J),I=1,NX),J=1, NY)
         WRITE(IOUT, 5000) IDATE, TDATA, JDATE, TNEXT
   90    CONTINUE
  100 CONTINUE
  999 RETURN
 1000 FORMAT(10A1,2X,60A1,/,I2,1X,I2,1X,I6,1X,F6.2,1X,I6,1X,F6.2)
 1002 FORMAT(4I5)
 1003 FORMAT(I6,F7.0,I6,F7.0)
 1004  FORMAT(I4,7F8.1)
 1005 FORMAT(I4,10A1)
 1006 FORMAT(7D16.9)
 5000 FORMAT(1X, I5, 5X, F6.2, 5X, I5, 5X, F6.2)
      END
