      SUBROUTINE WNDCON (IOUT,IDONE)
C
C            THIS PROGRAM READS THE FORMATTED ASCII AIRSHED WIND FILE
C            AND REWRITES THE FILE INTO A BINARY FILE.
C
C       THIS PROGRAM IS USED TO TRANSFER THE 3-D WIND FILES
C       FOR THE 26-27 JULY 1974 AIRSHED SIMULATIONS IN THE
C       LOS ANGELES BASIN INTO FILES THAT CAN BE WRITTEN ON
C       TAPE AND TRANSFERRED
C
C    THIS PROGRAM USED TO CREATE ONE WIND FILE:
C         1) WIND.26.ASCII
C      FROM THE BINARY AIRSHED INPUT WIND FILES USED IN THE
C      ACTUAL SIMULATIONS.
C
C     WIND COMPONENT UNITS ARE METERS/HOUR
C
      INCLUDE 'nampar.cmd'
      COMMON /LCM/ WX(MXX,MXY,5) , WY(MXX,MXY,5), EM1(MXX,MXY,20)
      REAL*8     WWX(MXX,MXY,5) , WWY(MXX,MXY,5)
Ctcm  DIMENSION  WINDX(10), WINDY(10)
      character*4  WINDX(10), WINDY(10)
C
C     READ WIND FILE HEADER INFO AND WRITE TO NEW FILE
C
      IDONE=1
      READ (7,1000) IFILE, NOTE, NSEG, NSPECS, JDATE, BEGTIM, IDATE,
     $ ENDTIM
      WRITE (9) IFILE, NOTE, NSEG, NSPECS, JDATE, BEGTIM, IDATE, ENDTIM
      WRITE (IOUT,1000) IFILE, NOTE, NSEG, NSPECS, JDATE, BEGTIM, IDATE
     1 , ENDTIM
      READ(7,1001)ORGX, ORGY, IZONE, UTMX, UTMY, DELTAX, DELTAY,
     1          NX, NY, NZ, NZLOWR, NZUPPR, HTSUR, HTLOW, HTUPP
      WRITE (9)       ORGX, ORGY, IZONE, UTMX, UTMY, DELTAX, DELTAY,
     1          NX, NY, NZ, NZLOWR, NZUPPR, HTSUR, HTLOW, HTUPP
 1001  FORMAT(F10.2,F10.2,I3,F10.2,F10.2,2F6.0,5I4,3F7.0)
      READ (7,1002) IX, IY, NXCLL, NYCLL
      WRITE  (9) IX, IY, NXCLL, NYCLL
C
C     MAJOR LOOP FOR 24 HOURS
C
      IBHR = BEGTIM + 1
      IEHR = ENDTIM
      DO 100 ITM = 1,9999
         READ  (7,1003,END=999) IDATE, TDATA, JDATE, TNEXT
         WRITE(IOUT, 5000) IDATE, TDATA, JDATE, TNEXT
         WRITE (9) IDATE, TDATA, JDATE, TNEXT
       READ  (7,1004) ISEG, REF, XMX, YMX, WEST, EAST, SOUTH, ORTH
C**      XMX = XMX * 3600.
C**       YMX = YMX * 3600.
       WRITE(IOUT,2345) XMX,YMX
 2345   FORMAT(4X,F10.3,3X,F10.3)
       WRITE (9) ISEG, REF, XMX, YMX, WEST, EAST, SOUTH, ORTH
C
C       LOOP FOR N NUMBER OF LEVELS
C
         DO 90 K = 1,NZ
C
C
C     WRITE OUT U AND V COMPONENT WIND VECTORS TO FORMATTED FILE
C
      READ (7,1005) ISEG, WINDX
      READ (7,1006)  ((WWX(I,J,K), I = 1,NX), J =1, NY)
      READ (7,1005) JSEG, WINDY
      READ (7,1006) ((WWY(I,J,K),I=1,NX),J=1, NY)
         KK=K
         DO 70 I=1,NX
            DO 70 J=1,NY
               WX(I,J,K)=WWX(I,J,KK)
               WY(I,J,K)=WWY(I,J,KK)
   70       CONTINUE
            WRITE(9) ISEG, WINDX, ((WX(I,J,K),I=1,NX),J=1,NY)
            WRITE(9) JSEG, WINDY, ((WY(I,J,K),I=1,NX),J=1,NY)
         WRITE(IOUT, 5000) IDATE, TDATA, JDATE, TNEXT
   90    CONTINUE
  100 CONTINUE
  999 RETURN
 1000 FORMAT(10A1,2X,60A1,/,I2,1X,I2,1X,I6,1X,F6.2,1X,I6,1X,F6.2)
 1002 FORMAT(4I5)
 1003 FORMAT(I6,F7.0,I6,F7.0)
 1004  FORMAT(I4,7F8.1)
 1005 FORMAT(I4,10A1)
 1006 FORMAT(7D16.9)
 5000 FORMAT(1X, I5, 5X, F6.2, 5X, I5, 5X, F6.2)
      END
