      program terrprc
c
c       COPYRIGHT 1999
c
c       SYSTEMS APPLICATIONS INTERNATIONAL, INC.
c
c     makes a dummy terrain file for utm system
c     (See Programmer note below to set terrain to genuine values.)
c
       parameter (mxx = 120)
       parameter (mxy = 120)
       real zht(mxx,mxy),xx(mxx,mxy),yy(mxx,mxy)
       character*80 ipath
       character*10 filhdr
       character*80 note
c
c  header data
c
      data filhdr /'TERRAIN   '/
      data note   /'Terrain file from uamvterr'/
      data ivers /0/
      data icoord /1/
      data nspec /0/
      data idat, timbeg, iend, timend /0,0.,0,0./
      data nz /1/
c
        write(*,*)'ENTER OUTPUT FILE:'
        read(*,'(a)')ipath
        open(12,file=ipath,form='unformatted')
        write(*,*)'ENTER NX,NY,UTMX,UTMY,DX,DY,ZONE of output file'
        read(*,*)nx,ny,utmx,utmy,dx,dy,izone
        do 100 i = 1,nx
          do 100 j = 1,ny
            xx(i,j) = utmx + dx*(float(i)-0.5)
            yy(i,j) = utmy + dy*(float(j)-0.5)
            call maputg(xx(i,j),yy(i,j),izone,alon,alat)
            xx(i,j) = alon
            yy(i,j) = alat
 100    continue
c
c   write file headers
c
      write(12) filhdr, note
      write(12) ivers, icoord, nspec, idat, timbeg, iend, timend
      write(12) utmx, utmy, dx, dy, nx, ny, nz, izone
c
c  ******** PROGRAMMER NOTE:
c  if actual terrain data is available, modify the lines below
c  to set the array zht below to the actual terrain values
c
      do j=1,ny
        do i=1,nx
          zht(i,j) = 0.
        enddo
      enddo
c
  130   write(12)((zht(i,j),i=1,nx),j=1,ny)
        write(12)((xx(i,j),i=1,nx),j=1,ny)
        write(12)((yy(i,j),i=1,nx),j=1,ny)
c       write(*,*)'ZHT = ',
c    &       ((zht(i,j),i=1,nx),j=1,ny)
        write(*,*)
        write(*,*)'CTLON = ',((xx(i,j),i=1,nx),j=1,ny)
        write(*,*)
        write(*,*)'CTLAT = ',((yy(i,j),i=1,nx),j=1,ny)
        write(*,*)
        end 
CDECK MAPUTG *********************************************************
      SUBROUTINE MAPUTG (UTMX,UTMY,IZONE,ALON,ALAT)
      SAVE
C
C     *** CONVERTS UTM COORDINATES TO LATITUDE AND LONGITUDE
C         THIS IS A MODIFICATION OF THE US GEOLOGICAL SURVEY
C         PROGRAM NO J380  (TOPOGRAPHIC DIVISION)
C             GW LUNDBERG/SAI  APR 79
C
C         UTMX    EASTING IN KILOMETERS
C         UTMY    NORTHING IN KILOMETERS
C         IZONE   UTM ZONE NUMBER
C         ALON    LONGITUDE IN DEGREES
C         ALAT    LATITUDE IN DEGREES
C
C     MODIFIED 9/23/87 FOR IBM PC LAHEY FORTRAN      RGJ
C
C     MODIFIED 8/26/88 FOR MULTIFLOW COMPUTER   RGJ
C
      DIMENSION B(12)
      COMMON /VVUTM/ A(16)
C
      X = UTMX*1000.
      Y = UTMY*1000.
C
C     *** COMPUTE CONVERSION COEFFICIENTS IF NEEDED
      CALL VVGTU1
C
C     *** COMPUTE CENTRAL MERIDIAN IN SECONDS FROM IZONE INPUT
   10 UTZ = 30.0 - IABS (IZONE)
      A(9) = ((UTZ*6.0) + 3.0) * 3600.0
C
C     *** CONVERT UTM COORDINATES TO GEODETIC
      B(9)=((A(5)-X)*1.0E-6)/A(8)
      IF (ABS(B(9))-1.0E-7*A(15)*2.0)30,30,20
   20 SLAT=0.0
      SLON=0.0
      GO TO 99
   30 B(10)=((Y-A(6))/A(8)+A(7))/A(10)
      IF(ABS(B(10))-1.47E0)40,40,20
   40 SINW=SIN(B(10))
      COSW=COS(B(10))
      B(12)=COSW*COSW
      B(11)=(((A(14)*B(12)+A(13))*B(12)+A(12))*B(12)+A(11))*SINW*COSW
     $ +B(10)
      SINW=SIN(B(11))
      COSW=COS(B(11))
      RN=SQRT(1.0-A(16)*SINW*SINW)*1.0E6/A(15)
      T=SINW/COSW
      TS=T*T
      B(12)=COSW*COSW
      ETAS=A(16)*B(12)/(1.0-A(16))
      B(1)=RN/COSW
      B(2)=-T*(1.0+ETAS)*RN*RN/2.0
      B(3)=-(1.0+2.0*TS+ETAS)*B(1)*RN*RN/6.0
      B(4)=(((-6.0-ETAS*9.0)*ETAS+3.0)*TS+(6.0-ETAS*3.0)*ETAS
     $ +5.0)*T*RN**4/24.0
      B(5)=((TS*24.0+ETAS*8.0+28.0)*TS+ETAS*6.0+5.0)*B(1)*
     $ RN**4/120.0
      B(6)=(((ETAS*45.0-45.0)*TS+ETAS*162.0-90.0)*TS
     $ -ETAS*107.0-61.0)*T*RN**6/720.0
      B(7)=-(((TS*720.0+1320.0)*TS+662.0)*TS+61.0)*B(1)*RN**6/
     $ 5040.0
      B(8)=(((TS*1575.0+4095.0)*TS+3633.0)*TS+1385.0)*T*RN**8/
     $ 40320.0
      B(10)=B(9)*B(9)
      SLAT=((((B(8)*B(10)+B(6))*B(10)+B(4))*B(10)+B(2))*B(10)+B(11))*
     $ 206264.80624709
      SLON= (((B(7)*B(10)+B(5))*B(10)+B(3))*B(10)+B(1))*B(9)*
     $ 206264.80624709 + A(9)
C
C     *** CONVERT SECONDS OF ARC TO DEGREES AND RETURN
   99 ALAT = SLAT/3600.
      ALON = -SLON/3600.
C
      RETURN
      END
CDECK VVGTU1 ***********************************************************
      SUBROUTINE VVGTU1
      SAVE
C
C     *** SETS UP COEFFICIENTS FOR CONVERTING GEODETIC TO
C         RECTIFYING LATITUDE AND CONVERSELY
C
C         A1-A4 COEFFICIENTS FOR CONVERTING GEODITIC TO RECTIFYING LATITUDE
C         A5    FALSE EASTING
C         A6    FALSE NORTHING
C         A8    SCALE FACTOR AT CENTRAL MERIDIAN
C         A9    CENTRAL MERIDIAN IN SECONDS
C         A10   RADIUS OF SPHERE HAVING GREAT CIRCLE LENGTH EQUAL TO
C               SPHEROID MERIDIAN LENGTH
C         A11-A14  COEFFICIENTS FOR CONVERTING RECTIFYING LATITUDE TO
C                  GEODETIC LATITUDE
C         A15   SEMIMAJOR AXIS OF SPHERIOD
C         A16   ECCENTRICITY SQUARED
C
C
C     MODIFIED 9/23/87 FOR IBM PC LAHEY FORTRAN      RGJ
C
C     MODIFIED 8/26/88 FOR MULTIFLOW COMPUTER   RGJ
C
      COMMON /VVUTM/ A(16)
      DATA IFRST/1/
C
C     *** CONPUTE COEFFICIENTS ON FIRST PASS ONLY
      IF (IFRST .NE. 1) RETURN
      IFRST = 0
C
      A(5)=5.0E5
      A(6)=0.0
      A(7)=0.0
      A(8)=0.9996
C
C     *** CLARKE 1866 ELLIPSOID AXES LENGTHS
      A(15)=6378206.4
      B = 6356583.80
C
      A(16)= ((A(15)-B)/A(15))*((A(15)+B)/A(15))
      A(10)=(((A(16)*(7.0/3.2E1)+(5.0/1.6E1))*A(16)+0.5)*A(16)
     $ +1.0)*A(16)*0.25
      A(1)=-(((A(10)*(1.95E2/6.4E1)+3.25)*A(10)+3.75)*A(10)+3.0)*
     $ A(10)
      A(2)=(((1.455E3/3.2E1)*A(10)+(7.0E1/3.0))*A(10)+7.5)*A(10)**2
      A(3)=-((7.0E1/3.0)+A(10)*(9.45E2/8.0))*A(10)**3
      A(4)=(3.15E2/4.0)*A(10)**4
      A(11)=(((7.75-(6.57E2/6.4E1)*A(10))*A(10)-5.25)*A(10)+3.0)*
     $ A(10)
      A(12)=(((5.045E3/3.2E1)*A(10)-(1.51E2/3.0))*A(10)+10.5)*
     $ A(10)**2
      A(13)=((1.51E2/3.0)-(3.291E3/8.0)*A(10))*A(10)**3
      A(14)=(1.097E3/4.0)*A(10)**4
      FAC=A(10)*A(10)
      A(10)=(((2.25E2/6.4E1)*FAC+2.25)*FAC+1.0)*(1.0-FAC)*
     $ (1.0-A(10))*A(15)
      RETURN
      END
