      subroutine alloc(nscrtc, nsclft, xscrtc, nvals, kptr, lerr)
c
c$Log: alloc.f,v $
c  Revision 1.3  1998/11/17  18:04:26  ara
c  *** empty log message ***
c
c  Revision 1.2  1998/11/17  17:30:17  ara
c  Included file errlog.cmd to introduce ierrlg variable
c  Directed warning message to diag file and to log file (ierrlg)
c
c  Revision 1.1  1994/07/26  17:12:59  tcm
c  Initial revision
c
c
c  alloc allocates memory from the scratch array xscrtcc
c  
c      nscrtc - original dimension of xscrtc
c      nsclft - space still available in xscrtc
c      xscrtc - scratch array
c      nvals  - number of elements to be allocated
c      kptr   - pointer to beginning of array allocated
c      lerr   - error flag, in case available space exhausted
c
c  alloc acts like a dimension statement.  
c  nsclft will be reduced by nvals
c  kptr will be set to the first available element in xscrtc
c  lerr will be set to .true. if available space is exceeded, 
c       otherwise it will be .false.
c
      dimension xscrtc(nscrtc)
      logical lerr
      include 'errlog.cmd'
c
      lerr = .false.
c
c
c  check amount of space available
c
      if (nvals .gt. nsclft) then
        write(*,*) 'Available space exceeded.'
        write(*,*) 'Amount requested is ', nvals
        write(*,*) 'Amount available is ', nsclft
        write(8,*) 'Available space exceeded.'
        write(8,*) 'Amount requested is ', nvals
        write(8,*) 'Amount available is ', nsclft
        write(ierrlg,'(i3,1x,a)') 210,'Available space exceeded.'
        write(ierrlg,*) 'Amount requested is ', nvals
        write(ierrlg,*) 'Amount available is ', nsclft 
        lerr = .true.
        return
      endif
c
c  set pointer and reset remaining space
c
      kptr = nscrtc - nsclft + 1
      nsclft = nsclft - nvals
c
c  write message to como file
c
      write(*,'(a,i10,a,i10,a,i10,a)') 'Allocating ',nvals,
     &      ' words.  kptr = ',kptr,'.  ',nsclft,
     &      ' words left.'
c
c  initialize array just allocated to 0.
c
      do 10 i=kptr,kptr+nvals-1
        xscrtc(i) = 0.
   10 continue
c
      return
      end
