      subroutine averag(m,deltat,time,ndate,tmo3,no3pt,co3av)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: averag.f,v $
c  Revision 1.7  1999/12/21  19:27:07  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.6  1998/11/17  18:04:51  ara
c  *** empty log message ***
c
c  Revision 1.5  1998/11/17  17:35:53  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed warning message to diag file and to log file (ierrlg)
c
c  Revision 1.4  1998/11/04  01:04:23  tcm
c  Removed max o3 average calculation
c
c  Revision 1.3  94/07/27  09:10:46  tcm
c  Added code to optionally calculate rolling o3 average and keep 
c  track of maximum hourly average o3.
c  
c  Revision 1.2  94/02/10  20:50:28  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
      save
c
      include 'parm.cmd'
      include 'parfin.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
      include 'comchem.cmd'
      include 'comd3.cmd'
      include 'ppmcon.cmd'
      include 'avo3con.cmd'
      include 'errlog.cmd'
      dimension tmo3(nsteps), no3pt(nsteps), co3av(nox,noy,nsteps)
c
c
c  subroutine average computes the average concentrations using
c  the rectangle rule for the time integrations.
c
c  when  m=1 we begin the time average
c        m=2 we continue to generate the average
c        m=3 we conclude the averaging
c
      write(*,4000) time,ndate,deltat,m
      if (m.eq.1) then
        avgtme=0.0
        do 10 k=1,nospc1
          do 9 j=1,noy
            do 8 i=1,nox
              avcong(i,j,k)=0.0
    8       continue
    9     continue
   10   continue
      endif
c
c     add in cold arrays to avcon arrays
c
      if (m .gt. 1) then
        avgtme=avgtme+deltat
        do 115 k=1,nospc1
          do 110 j=1,noy
            if (istr(j).gt.nox) go to 110
            i1=istr(j) + 1
            i2=iend(j) - 1
            do 105 i=i1,i2
              avcong(i,j,k)=avcong(i,j,k)+0.5*deltat*coldg(i,j,k)
  105       continue
  110     continue
  115   continue
c
c     add in current instantenous concentrations
c
        do 295 k=1,nospc1
          do 290 j=1,noy
            if (istr(j).gt.nox) go to 290
            i1=istr(j) + 1
            i2=iend(j) - 1
            do 285 i=i1,i2
              avcong(i,j,k)=avcong(i,j,k)+0.5*deltat*conc(i,j,k,1)*
     &                      temper(i,j,1)*cpfac/(press(i,j,1)*273.)
  285       continue
  290     continue
  295   continue
      endif
c
c     close out averaging
c
      if (m.eq.3) then
        do 315 k=1,nospc1
          do 310 j=1,noy
            if (istr(j).gt.nox) go to 310
            i1=istr(j) + 1
            i2=iend(j) - 1
            do 305 i=i1,i2
              avcong(i,j,k)=avcong(i,j,k)/avgtme
  305       continue
  310     continue
  315   continue
      endif
c
c
c     load conc into cold arrays for next time step
c
      do 350 k=1,nospc1
        do 340 j=1,noy
          do 330 i=1,nox
            coldg(i,j,k) = conc(i,j,k,1)*
     &                     temper(i,j,1)*cpfac/(press(i,j,1)*273.)
  330     continue
  340   continue
  350 continue
c
c  keep track of o3 concs for running average
c
      if (lmxo3) then
        thrs = aint(time/100.) + amod(time,100.)/60.
        write(*,*) 'thrs, time = ', thrs, time
c
c  save current o3 concs in array for future averages
c
        if (no3stp .gt. 0) then
          tt1 = tmo3(no3stp)
        else
          tt1 = -1.
        endif
        if (thrs-tt1 .ge. dtavg/60.) then
          no3stp = no3stp + 1
          if (no3stp .gt. nsteps) then
            write(*,*) '***WARNING***:  exceeded o3 steps, skipping'
            write(8,*) '***WARNING***:  exceeded o3 steps, skipping'
           write(ierrlg,'(i3,1x,a,a)') 211,'***WARNING***:  exceeded ',
     &           'o3 steps, skipping'  
            go to 485
          else
            tmo3(no3stp) = thrs
          endif
          write(*,*) 'Placing o3 av concs in location ',no3stp
          do 480 j=1,noy
            do 470 i=1,nox
              co3av(i,j,no3stp) = coldg(i,j,ko3)
  470       continue
  480     continue
        endif
c
  485   continue
c
      endif
c
c     write(*,4100)
 4000 format(' ENTER AVERAG ',f10.1,i10,f10.2,'  m = ',i3)
 4100 format(' LEAVE AVERAG')
      return
      end
