      subroutine bdrfil(ifine,nxf,nyf,nzf,htt)
C
C     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: bdrfil.f,v $
c  Revision 1.3  1995/04/26  00:36:08  tcm
c  	rewritten to allow more complex horizontal and vertical nesting.  uses igloc,
c  	jhloc, and fhloc to determine adjacent grids and interpolation factors.
c
c  Revision 1.2  94/02/10  20:50:36  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c   fills in boundary concentrations for a single fine
c   grid from the coarse grid concentrations surrounding
c   the fine grid (tcm, 10/2/90)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'shrfin.cmd'
      include 'deffin.cmd'
      include 'comuam.cmd'
      include 'com1f.cmd'
      include 'ngmap.cmd'
c
      dimension htt(nxf,nyf,nzf)
c
c  fill in north boundary
c
      iedg = 1
      do 50 i=2,nxf-1
        if (igloc(i,iedg,ifine) .ne. 0) go to 50
        jc = jhloc(i,iedg,ifine)
        ic = int(fhloc(i,iedg,ifine)+.0005)+1
        do 40 n=1,nospec
          kget = 1
          do 30 k=1,nzf
            if (jend(ic) .le. jc) then
              bcf(i,iedg,n,k,ifine) = bc(ic,iedg,n,kget)
            else
              bcf(i,iedg,n,k,ifine) = conc(ic,jc,n,kget)
            endif
            if (htt(i,nyf,k) .ge. 
     &          h(ic,jc,kget)-.0005) kget = kget + 1
   30     continue
c
   40   continue
   50 continue
c
c  fill in south boundary
c
      iedg = 2
      do 150 i=2,nxf-1
        if (igloc(i,iedg,ifine) .ne. 0) go to 150
        jc = jhloc(i,iedg,ifine)
        ic = int(fhloc(i,iedg,ifine)+.0005)+1
        do 140 n=1,nospec
          kget = 1
          do 130 k=1,nzf
            if (jstr(ic) .ge. jc) then
              bcf(i,iedg,n,k,ifine) = bc(ic,iedg,n,kget)
            else
              bcf(i,iedg,n,k,ifine) = conc(ic,jc,n,kget)
            endif
            if (htt(i,1,k) .ge. 
     &          h(ic,jc,kget)-.0005) kget = kget + 1
  130     continue
c
  140   continue
  150 continue
c
c  fill in east boundary
c
      iedg = 3
      do 250 j=2,nyf-1
        if (igloc(j,iedg,ifine) .ne. 0) go to 250
        ic = jhloc(j,iedg,ifine)
        jc = int(fhloc(j,iedg,ifine)+.0005)+1
        do 240 n=1,nospec
          kget = 1
          do 230 k=1,nzf
            if (iend(jc) .le. ic) then
              bcf(j,iedg,n,k,ifine) = bc(jc,iedg,n,kget)
            else
              bcf(j,iedg,n,k,ifine) = conc(ic,jc,n,kget)
            endif
            if (htt(nxf,j,k) .ge. 
     &          h(ic,jc,kget)-.0005) kget = kget + 1
  230     continue
c
  240   continue
  250 continue
c
c  fill in west boundary
c
      iedg = 4
      do 350 j=2,nyf-1
        if (igloc(j,iedg,ifine) .ne. 0) go to 350
        ic = jhloc(j,iedg,ifine)
        jc = int(fhloc(j,iedg,ifine)+.0005)+1
        do 340 n=1,nospec
          kget = 1
          do 330 k=1,nzf
            if (istr(jc) .ge. ic) then
              bcf(j,iedg,n,k,ifine) = bc(jc,iedg,n,kget)
            else
              bcf(j,iedg,n,k,ifine) = conc(ic,jc,n,kget)
            endif
            if (htt(1,j,k) .ge. 
     &          h(ic,jc,kget)-.0005) kget = kget + 1
  330     continue
c
  340   continue
  350 continue
c
      return
      end
