      subroutine bndry(ustar,rb,nospec)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: bndry.f,v $
c  Revision 1.6  1999/05/14  16:10:24  dfg
c  Remove dratio in save statement due to the move of dratio array to comchme.cmd.
c
c  Revision 1.5  1999/05/13  17:30:18  dfg
c  Moved DRATIO data statement to AQBDAT block data, carry DRATIO in COMCHEM.
c
c  Revision 1.4  1999/04/12  22:40:44  tcm
c  Updated dratio values.  Made loop ranges consistent with dimensioning.
c
c  Revision 1.3  1996/06/14  22:54:07  tcm
c  data for ispd added by hpd
c
c  Revision 1.2  1994/02/10  20:50:49  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c**********************************************************************
c
c-----This program estimates the boundary (laminar) layer resistance
c-----for dry deposition using the standard relations
c
c-----The inputs to this program are:
c-----ustar = the friction velocity
c
c-----The outputs from this routine are:
c-----rb = array of bulk resistances
c
c-----The program was written by GEM May 1990
c
c     Modified by CAE 3/29/95 to ensure proper species mapping in DRATIO
c
c-----moved DRATIO data statement to AQBDAT block data, carry DRATIO in COMCHEM.
c     5/12/1999, dfg
c
c**********************************************************************
c
c
c******   inserts the parameter file
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comchem.cmd'
c
c     dimension rb(mxspec),dratio(mxxspc),dfac(mxxspc)
      dimension rb(mxspec),dfac(mxxspc)
      logical lfirst
c
      save lfirst,dfac,dfacdf
c
c
      data d1,d2,dair,vk,dh2o/2.0,0.666,1.5e-05,0.40,2.3e-05/
      data lfirst /.true./
c
c
c-----first time through, calculate  a single factor for each species
c     dfacdf is default value for dfac (same as air)
c
      if (lfirst) then
        do 10 i=1,nspint
          dfac(i) = d1*(dair*dratio(i)/dh2o)**d2/vk
   10   continue
        dfacdf = d1*(dair*1.3/dh2o)**d2/vk
        lfirst = .false.
      endif
c
c-----set all rb's to default initially
c
      do 20 ikd = 1,nospec
        rb(ikd) = dfacdf/ustar
   20 continue
c
c-----now estimate the resistance
c
      do 30 i = 1,nspint
        ikd = kind(i)
        if (ikd .gt. 0) rb(ikd) = dfac(i)/ustar
   30 continue
      return
      end
