      subroutine chem2a2f(nospec,nors,hh,hr,rate,rp,lerror)
c
c   *** Generated from DFG's VBChemG software, Dongfen Gao, 5/18/1999
c
c
c$Log: chem2a2_fst.f,v $
c Revision 1.3  2002/06/26  20:44:13  tcm
c revised +- syntax to +(-  ) for better portability
c
c Revision 1.2  2000/07/03  21:43:42  tcm
c Added hh array to diagnostic output.
c
c Revision 1.1  1999/06/23  23:45:01  dfg
c Initial revision
c
c

      include  'parchm.cmd'
      include  'comchem.cmd'
      logical lerror,lin
      DIMENSION  rate(mxspec), rp(mxspec,mxspec)
      dimension  hh(mxspec), hr(mxrads)
      common /idcell/icell,jcell,kcell,tmchm
      REAL NO, NO2, O3, OLE, PAR, TOL, XYL, HCHO, ACET, ETH, 
     & CRES, MGLY, OPEN, PNA, PAN, CO, HNO2, H2O2, HNO3, ISOP, 
     & SO2, SULF, MEOH, ETOH, MTBE, NPHN, ALDX, IOLE, PANX, CH4, 
     & NTR, ISPD, PHCHO, PACET, O1D, O, NO3, N2O5, HO2, OH, C2O3, 
     & CXO3, XO2, XO2N, TO2, ROR, CRO
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      MEOH = 0.
      ETOH = 0.
      ISOP = 0.
      ISPD = 0.
      MTBE = 0.
      NPHN = 0.
      NO2 = HH(kNO2)
      O3 = HH(kO3)
      OLE = HH(kOLE)
      PAR = HH(kPAR)
      TOL = HH(kTOL)
      XYL = HH(kXYL)
      HCHO = HH(kHCHO)
      ACET = HH(kACET)
      ETH = HH(kETH)
      CRES = HH(kCRES)
      MGLY = HH(kMGLY)
      OPEN = HH(kOPEN)
      PNA = HH(kPNA)
      PAN = HH(kPAN)
      CO = HH(kCO)
      HNO2 = HH(kHNO2)
      H2O2 = HH(kH2O2)
      HNO3 = HH(kHNO3)
      IF (LISOP) ISOP = HH(kISOP)
      IF (LSO2) SO2 = HH(kSIV)
      IF (LSO2) SULF = HH(kSULF)
      IF (LMEOH) MEOH = HH(kMEOH)
      IF (LETOH) ETOH = HH(kETOH)
      IF (LMTBE) MTBE = HH(KMTBE)
      IF (LNPHN) NPHN = HH(KNPHN)
      ALDX = HH(kALDX)
      IOLE = HH(kIOLE)
      PANX = HH(kPANX)
      CH4 = HH(kCH4)
      IF (LNITR) NTR = HH(kNITR)
      IF (LISOP) ISPD = HH(kISPD)
      PHCHO = 0.
      PACET = 0.
      If (LPHCH) Then
        PHCHO = HH(KPHCH)
        HCHO = HCHO + PHCHO
        PACET = HH(KPACT)
        ACET = ACET + PACET
      End If
      FPF = PHCHO / HCHO
      FSF = 1. - FPF
      FPA = PACET / ACET
      FSA = 1. - FPA
      NO3 = HR(kNO3)
      N2O5 = HR(kN2O5)
      HO2 = HR(kHO2)
      OH = HR(kOH)
      C2O3 = HR(kC2O3)
      CXO3 = HR(kCXO3)
      XO2 = HR(kXO2)
      XO2N = HR(kXO2N)
      ROR = HR(kROR)
      CRO = HR(kCRO)
      kso2 = ksiv
      kntr = knitr
c
c This is radical solver routine and coded by Dongfen Gao, SAI, July 1998.
c  In this routine, the radical will be solved and the rate and
c    Jacobian for fast species will be calculated.
c
      nitmax = 50
      xtol = 0.01
      lss=.true.
c
c
c---- the radical solver now------
c
c
c    Solver NO3 and N2O5 Next.
c
      liter = 0
      xxtol = xtol
 100  continue
      lerror=.false.
      liter = liter + 1
c
      ibeg=kno3
      iend=kn2o5
      call radjrat_2a2f(nospec,hh,hr,rate,rp)
      call colpivot (ibeg,iend,mxspec,rp,rate,ier)
c
      if (ier.eq.0) then
        lerror=.true.
        write(*,*) 'error in radical concentration calculation'
        write(*,*) 'in colpivot, matrix of equations is singular'
        write(*,*) 'solve N2O5 & NO3'
        write(*,*) 'ier,liter,nitmax= ',ier,liter,nitmax
        call flush(6)
        Stop
      endif
      tmpmax = 0.
      do 200 l = ibeg,iend
        tmphr = hr(l)
        if (hr(l).gt.1.0e-9) then
           err=abs(rate(l)/hr(l))
        else
           err=abs(rate(l))
        endif
        hr(l) = tmphr - Rate(l)
        if (err.gt.tmpmax) Then
          tmpmax = err
          itmp = l
        endif
         if (hr(l).le. 0.0) hr(l)=tmphr/10.
 200  continue
c
      if (tmpmax.gt.xxtol) then
        if (liter .eq. 5) xxtol = xxtol*10.
        if (liter.le.nitmax) go to 100
        write(*,*) 'error in radical calculation in chem --'
        write(*,*) 'increase nitmax'
        write(*,*) 'ier,liter,nitmax= ',ier,liter,nitmax
        write(*,1200) (n,hh(n),n=1,nors)
        write(*,1300) (n,hr(n),n=1,mxrads)
        write(*,1400) (n,rk(n),n=1,94)
        write(*,*) 'icell,jcell,kcell,tmchm'
        write(*,*) icell,jcell,kcell,tmchm
        call flush(6)
        lerror =.true.
        Stop
      endif
c
      no3 = hr(kno3)
      n2o5 = hr(kn2o5)
c
c---- radicals NO3 and N2O5 converged.
c     now Solve HO2, OH, C2O3, XO2, XO2N together
c
      liter = 0
      xxtol = xtol
 210  continue
      lerror=.false.
      liter = liter + 1
c
      ibeg=kho2
      iend=kxo2n
      call radjrat_2a2f(nospec,hh,hr,rate,rp)
      call colpivot (ibeg,iend,mxspec,rp,rate,ier)
c
      if (ier.eq.0) then
        lerror=.true.
        write(*,*) 'error in radical concentration calculation'
        write(*,*) 'in colpivot, matrix of equations is singular'
        write(*,*) 'HO2,OH,C2O3,CXO3,XO2,XO2N'
        write(*,*) 'ier,liter,nitmax= ',ier,liter,nitmax
        call flush(6)
        Stop
      endif
      tmpmax = 0.
      do 220 l = ibeg,iend
        tmphr = hr(l)
        if (hr(l).gt.1.0e-9) then
           err=abs(rate(l)/hr(l))
        else
           err=abs(rate(l))
        endif
        hr(l) = tmphr - Rate(l)
        if (err.gt.tmpmax) Then
          tmpmax = err
          itmp = l
        endif
         if (hr(l).le. 0.0) hr(l)=tmphr/10.
 220  continue
c
      if (tmpmax.gt.xxtol) then
        if (liter .eq. 5) xxtol = xxtol*10.
        if (liter.le.nitmax) go to 210
        write(*,*) 'error in radical calculation in chem --'
        write(*,*) 'increase nitmax'
        write(*,*) 'ier,liter,nitmax= ',ier,liter,nitmax
        write(*,1200) (n,hh(n),n=1,nors)
        write(*,1300) (n,hr(n),n=1,mxrads)
        write(*,1400) (n,rk(n),n=1,94)
        write(*,*) 'icell,jcell,kcell,tmchm'
        write(*,*) icell,jcell,kcell,tmchm
        call flush(6)
        lerror =.true.
        Stop
      endif
c
      ho2 = hr(kho2)
      oh = hr(koh)
      c2o3 = hr(kc2o3)
      cxo3 = hr(kcxo3)
      xo2 = hr(kxo2)
      xo2n = hr(kxo2n)
c
c---- radicals HO2, OH, C2O3, XO2, XO2N converged.
c   and now Solve ROR,TO2,and CRO separately
c
      Sink =   - 0.98*rk(53)  - rk(54)  - rk(55)*NO2
      Source = .76*rk(52)*PAR*OH
      hr(kror) = -Source/Sink
      ror = hr(kror)
c
      Sink =   - rk(68)*NO2
      Source = .4*rk(66)*OH*CRES +1.*rk(67)*CRES*NO3
      hr(kcro) = -Source/Sink
      cro = hr(kcro)
c
c---- all radicals have been solved and now we calculate
c      rate and Jacobian for fast species.
c
      call fastrate_2a2f(nospec,hh,hr,rate)
      call fastjac_2a2f(nospec,hh,hr,rp)
c
c
c---------formats------------------------------------------------------
 1000 format(1x,
     1         '*** error in radical concentration calculations in chem',
     2    //,2x,'       ier     liter    nitmax',/,2x,3i10)
 1200 format(1x,' In chem2a2_fst, hh   ',/,(1x,i4,e12.5))
 1300 format(1x,'    hr   ',/,(1x,i4,e12.5))
 1400 format(1x,'    rk   ',/,(1x,i4,e12.5))
 1500 format(1x,' jac--for i=  ',i3,/,(6e12.5))
c----------------------------------------------------------------------
c
      return
      end
      SUBROUTINE RADJRAT_2a2f(NOSPEC,HH,HR,RATE, JAC)
      INCLUDE  'parchm.cmd'
      INCLUDE  'comchem.cmd'
      DIMENSION  RATE(MXSPEC), HH(MXSPEC), HR(MXRADS)
      DIMENSION  JAC(MXSPEC,MXSPEC)
      REAL JAC
      REAL NO, NO2, O3, OLE, PAR, TOL, XYL, HCHO, ACET, ETH, 
     & CRES, MGLY, OPEN, PNA, PAN, CO, HNO2, H2O2, HNO3, ISOP, 
     & SO2, SULF, MEOH, ETOH, MTBE, NPHN, ALDX, IOLE, PANX, CH4, 
     & NTR, ISPD, PHCHO, PACET, O1D, O, NO3, N2O5, HO2, OH, C2O3, 
     & CXO3, XO2, XO2N, TO2, ROR, CRO
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      MEOH = 0.
      ETOH = 0.
      ISOP = 0.
      ISPD = 0.
      MTBE = 0.
      NPHN = 0.
      NO2 = HH(KNO2)
      O3 = HH(KO3)
      OLE = HH(KOLE)
      PAR = HH(KPAR)
      TOL = HH(KTOL)
      XYL = HH(KXYL)
      HCHO = HH(KHCHO)
      ACET = HH(KACET)
      ETH = HH(KETH)
      CRES = HH(KCRES)
      MGLY = HH(KMGLY)
      OPEN = HH(KOPEN)
      PNA = HH(KPNA)
      PAN = HH(KPAN)
      CO = HH(KCO)
      HNO2 = HH(KHNO2)
      H2O2 = HH(KH2O2)
      HNO3 = HH(KHNO3)
      IF (LISOP) ISOP = HH(KISOP)
      IF (LSO2) SO2 = HH(KSIV)
      IF (LSO2) SULF = HH(KSULF)
      IF (LMEOH) MEOH = HH(KMEOH)
      IF (LETOH) ETOH = HH(KETOH)
      IF (LMTBE) MTBE = HH(KMTBE)
      IF (LNPHN) NPHN = HH(KNPHN)
      ALDX = HH(KALDX)
      IOLE = HH(KIOLE)
      PANX = HH(KPANX)
      CH4 = HH(KCH4)
      IF (LNITR) NTR = HH(KNITR)
      IF (LISOP) ISPD = HH(KISPD)
      PHCHO = 0.
      PACET = 0.
      If (LPHCH) Then
        PHCHO = HH(KPHCH)
        PACET = HH(KPACT)
      End If
      NO3 = HR(KNO3)
      N2O5 = HR(KN2O5)
      HO2 = HR(KHO2)
      OH = HR(KOH)
      C2O3 = HR(KC2O3)
      CXO3 = HR(KCXO3)
      XO2 = HR(KXO2)
      XO2N = HR(KXO2N)
      ROR = HR(KROR)
      CRO = HR(KCRO)
      kso2 = ksiv
      kntr = knitr
c
c     *** zero out rate and jac for radical species
c 
       do 200 i=1,nospec
         rate(i) = 0. 
         do 100 j=1,nospec
           jac(i, j) = 0. 
 100     continue
 200   continue
c
c      Calculating the Jacobian for rad Species
c
      Sink =   - rk(16)*NO2  - rk(17)*NO2  - rk(41)*HCHO
     &   - rk(44)*ACET  - rk(59)*OLE  - rk(67)*CRES
     &   - rk(78)*ISOP  - rk(83)*ETOH  - rk(85)*MEOH
     &   - rk(92)*ALDX  - rk(97)*IOLE  - rk(107)*ISPD
      Source = 1.*rk(7)*NO2*O3 +1.*rk(19)*N2O5
     &  +1.*rk(27)*OH*HNO3
      Rate(kNO3) = Source + Sink*NO3
      Sink =   - rk(18)*H2O  - rk(19)
      Source = 1.*rk(17)*NO3*NO2
      Rate(kN2O5) = Source + Sink*N2O5
      Sink =   - rk(13)*O3  - rk(29)*NO2  - rk(32)*HO2
     &   - rk(32)*HO2  - rk(33)*HO2*H2O  - rk(33)*HO2*H2O
     &   - rk(50)*C2O3  - rk(86)*XO2  - rk(87)*XO2N
     &   - rk(102)*CXO3  - rk(104)*OH
      Source = 1.*rk(12)*O3*OH +1.*rk(30)*PNA
     &  +1.*rk(35)*OH*H2O2 +1.*rk(36)*OH*CO
     &  +1.*rk(37)*HCHO*OH +1.*rk(41)*HCHO*NO3
     &  +2.*rk(49)*C2O3*C2O3 +1.*rk(51)*CH4*OH
     &  +.11*rk(52)*PAR*OH +.94*rk(53)*ROR
     &  +1.*rk(54)*ROR +1.*rk(57)*OH*OLE
     &  +.44*rk(58)*O3*OLE +1.*rk(61)*OH*ETH
     &  +.12*rk(62)*O3*ETH +1.*rk(63)*TOL*OH
     &  +.6*rk(66)*OH*CRES +2.*rk(70)*OPEN*OH
     &  +.76*rk(71)*OPEN*O3 +1.*rk(72)*OH*XYL
     &  +.912*rk(76)*OH*ISOP +.066*rk(77)*O3*ISOP
     &  +.8*rk(78)*NO3*ISOP +1.*rk(82)*ETOH*OH
     &  +1.*rk(83)*ETOH*NO3 +1.*rk(84)*MEOH*OH
     &  +1.*rk(85)*MEOH*NO3 +1.*rk(95)*IOLE*OH
     &  +.5*rk(96)*IOLE*O3 +1.*rk(97)*IOLE*NO3
     &  +2.*rk(101)*CXO3*C2O3 +.503*rk(105)*OH*ISPD
     &  +.154*rk(106)*O3*ISPD +.925*rk(107)*NO3*ISPD
     &  +.8*rk(109)*NO2*ISOP +.98*rk(110)*MTBE*OH
     &  +1.*rk(111)*SO2*OH
      Rate(kHO2) = Source + Sink*HO2
      Sink =   - rk(12)*O3  - rk(24)*HNO2  - rk(26)*NO2
     &   - rk(27)*HNO3  - rk(31)*PNA  - rk(35)*H2O2
     &   - rk(36)*CO  - rk(37)*HCHO  - rk(43)*ACET
     &   - rk(51)*CH4  - rk(52)*PAR  - rk(57)*OLE
     &   - rk(61)*ETH  - rk(63)*TOL  - rk(66)*CRES
     &   - rk(70)*OPEN  - rk(72)*XYL  - rk(73)*MGLY
     &   - rk(76)*ISOP  - rk(82)*ETOH  - rk(84)*MEOH
     &   - rk(91)*ALDX  - rk(95)*IOLE  - rk(103)*PANX
     &   - rk(104)*HO2  - rk(105)*ISPD  - rk(110)*MTBE
     &   - rk(111)*SO2
      Source = 1.*rk(13)*O3*HO2 +.1*rk(58)*O3*OLE
     &  +.08*rk(71)*OPEN*O3 +.266*rk(77)*O3*ISOP
     &  +.5*rk(96)*IOLE*O3 +.268*rk(106)*O3*ISPD
      Rate(kOH) = Source + Sink*OH
      Sink =   - rk(47)*NO2  - rk(49)*C2O3  - rk(49)*C2O3
     &   - rk(50)*HO2  - rk(101)*CXO3
      Source = 1.*rk(43)*ACET*OH +1.*rk(44)*ACET*NO3
     &  +1.*rk(48)*PAN +1.*rk(70)*OPEN*OH
     &  +.62*rk(71)*OPEN*O3 +1.*rk(73)*OH*MGLY
     &  +.21*rk(105)*OH*ISPD +.114*rk(106)*O3*ISPD
      Rate(kC2O3) = Source + Sink*C2O3
      Sink =   - rk(99)*NO2  - rk(101)*C2O3  - rk(102)*HO2
      Source = .2*rk(77)*O3*ISOP +1.*rk(91)*ALDX*OH
     &  +1.*rk(92)*ALDX*NO3 +1.*rk(100)*PANX
     &  +.288*rk(105)*OH*ISPD +.075*rk(107)*NO3*ISPD
      Rate(kCXO3) = Source + Sink*CXO3
      Sink =   - rk(80)*XO2  - rk(80)*XO2  - rk(86)*HO2
     &   - rk(89)*XO2N
      Source = 2.*rk(49)*C2O3*C2O3 +1.*rk(51)*CH4*OH
     &  +.87*rk(52)*PAR*OH +.96*rk(53)*ROR
     &  +1.*rk(57)*OH*OLE +.22*rk(58)*O3*OLE
     &  +.91*rk(59)*NO3*OLE +1.*rk(61)*OH*ETH
     &  +.08*rk(63)*TOL*OH +.6*rk(66)*OH*CRES
     &  +1.*rk(70)*OPEN*OH +.03*rk(71)*OPEN*O3
     &  +.5*rk(72)*OH*XYL +1.*rk(73)*OH*MGLY
     &  +.991*rk(76)*OH*ISOP +.2*rk(77)*O3*ISOP
     &  +1.*rk(78)*NO3*ISOP +.05*rk(82)*ETOH*OH
     &  +1.*rk(95)*IOLE*OH +2.*rk(101)*CXO3*C2O3
     &  +.713*rk(105)*OH*ISPD +.064*rk(106)*O3*ISPD
     &  +.075*rk(107)*NO3*ISPD +1.*rk(109)*NO2*ISOP
     &  +1.37*rk(110)*MTBE*OH
      Rate(kXO2) = Source + Sink*XO2
      Sink =   - rk(87)*HO2  - rk(88)*XO2N  - rk(88)*XO2N
     &   - rk(89)*XO2
      Source = .13*rk(52)*PAR*OH +.04*rk(53)*ROR
     &  +.09*rk(59)*NO3*OLE +.088*rk(76)*OH*ISOP
     &  +.02*rk(110)*MTBE*OH
      Rate(kXO2N) = Source + Sink*XO2N
      Sink =   - rk(53)  - rk(54)  - rk(55)*NO2
      Source = .76*rk(52)*PAR*OH +.02*rk(53)*ROR
      Rate(kROR) = Source + Sink*ROR
      Sink =   - rk(68)*NO2
      Source = .4*rk(66)*OH*CRES +1.*rk(67)*CRES*NO3
      Rate(kCRO) = Source + Sink*CRO
c
c--------Now calculate the Jacobian for radicals.
c
      JAC(kNO3, kNO3) =  - rk(16)*NO2 - rk(17)*NO2
     $  - rk(41)*HCHO - rk(44)*ACET
     $  - rk(59)*OLE - rk(67)*CRES
     $  - rk(78)*ISOP - rk(83)*ETOH
     $  - rk(85)*MEOH - rk(92)*ALDX
     $  - rk(97)*IOLE - rk(107)*ISPD
      JAC(kNO3, kN2O5) =  +1.*rk(19)
      JAC(kNO3, kOH) =  +1.*rk(27)*HNO3
      JAC(kN2O5, kNO3) =  +1.*rk(17)*NO2
      JAC(kN2O5, kN2O5) =  - rk(18)*H2O - rk(19)
      JAC(kHO2, kNO3) =  +1.*rk(41)*HCHO +.8*rk(78)*ISOP
     $  +1.*rk(83)*ETOH +1.*rk(85)*MEOH
     $  +1.*rk(97)*IOLE +.925*rk(107)*ISPD
      JAC(kHO2, kHO2) =  - rk(13)*O3 - rk(29)*NO2
     $  - rk(32)*HO2 - rk(32)*HO2
     $  - rk(32)*HO2 - rk(32)*HO2
     $  - rk(33)*HO2*H2O - rk(33)*HO2*H2O
     $  - rk(33)*HO2*H2O - rk(33)*HO2*H2O
     $  - rk(50)*C2O3 - rk(86)*XO2
     $  - rk(87)*XO2N - rk(102)*CXO3
     $  - rk(104)*OH
      JAC(kHO2, kOH) =  - rk(104)*HO2 +1.*rk(12)*O3
     $  +1.*rk(35)*H2O2 +1.*rk(36)*CO
     $  +1.*rk(37)*HCHO +1.*rk(51)*CH4
     $  +.11*rk(52)*PAR +1.*rk(57)*OLE
     $  +1.*rk(61)*ETH +1.*rk(63)*TOL
     $  +.6*rk(66)*CRES +2.*rk(70)*OPEN
     $  +1.*rk(72)*XYL +.912*rk(76)*ISOP
     $  +1.*rk(82)*ETOH +1.*rk(84)*MEOH
     $  +1.*rk(95)*IOLE +.503*rk(105)*ISPD
     $  +.98*rk(110)*MTBE +1.*rk(111)*SO2
      JAC(kHO2, kC2O3) =  - rk(50)*HO2 +2.*rk(49)*C2O3
     $  +2.*rk(49)*C2O3 +2.*rk(101)*CXO3
      JAC(kHO2, kCXO3) =  - rk(102)*HO2 +2.*rk(101)*C2O3
      JAC(kHO2, kXO2) =  - rk(86)*HO2
      JAC(kHO2, kXO2N) =  - rk(87)*HO2
      JAC(kHO2, kROR) =  +.94*rk(53) +1.*rk(54)
      JAC(kOH, kHO2) =  - rk(104)*OH +1.*rk(13)*O3
      JAC(kOH, kOH) =  - rk(12)*O3 - rk(24)*HNO2
     $  - rk(26)*NO2 - rk(27)*HNO3
     $  - rk(31)*PNA - rk(35)*H2O2
     $  - rk(36)*CO - rk(37)*HCHO
     $  - rk(43)*ACET - rk(51)*CH4
     $  - rk(52)*PAR - rk(57)*OLE
     $  - rk(61)*ETH - rk(63)*TOL
     $  - rk(66)*CRES - rk(70)*OPEN
     $  - rk(72)*XYL - rk(73)*MGLY
     $  - rk(76)*ISOP - rk(82)*ETOH
     $  - rk(84)*MEOH - rk(91)*ALDX
     $  - rk(95)*IOLE - rk(103)*PANX
     $  - rk(104)*HO2 - rk(105)*ISPD
     $  - rk(110)*MTBE - rk(111)*SO2
      JAC(kC2O3, kNO3) =  +1.*rk(44)*ACET
      JAC(kC2O3, kHO2) =  - rk(50)*C2O3
      JAC(kC2O3, kOH) =  +1.*rk(43)*ACET +1.*rk(70)*OPEN
     $  +1.*rk(73)*MGLY +.21*rk(105)*ISPD
      JAC(kC2O3, kC2O3) =  - rk(47)*NO2 - rk(49)*C2O3
     $  - rk(49)*C2O3 - rk(49)*C2O3
     $  - rk(49)*C2O3 - rk(50)*HO2
     $  - rk(101)*CXO3
      JAC(kC2O3, kCXO3) =  - rk(101)*C2O3
      JAC(kCXO3, kNO3) =  +1.*rk(92)*ALDX +.075*rk(107)*ISPD
      JAC(kCXO3, kHO2) =  - rk(102)*CXO3
      JAC(kCXO3, kOH) =  +1.*rk(91)*ALDX +.288*rk(105)*ISPD
      JAC(kCXO3, kC2O3) =  - rk(101)*CXO3
      JAC(kCXO3, kCXO3) =  - rk(99)*NO2 - rk(101)*C2O3
     $  - rk(102)*HO2
      JAC(kXO2, kNO3) =  +.91*rk(59)*OLE +1.*rk(78)*ISOP
     $  +.075*rk(107)*ISPD
      JAC(kXO2, kHO2) =  - rk(86)*XO2
      JAC(kXO2, kOH) =  +1.*rk(51)*CH4 +.87*rk(52)*PAR
     $  +1.*rk(57)*OLE +1.*rk(61)*ETH
     $  +.08*rk(63)*TOL +.6*rk(66)*CRES
     $  +1.*rk(70)*OPEN +.5*rk(72)*XYL
     $  +1.*rk(73)*MGLY +.991*rk(76)*ISOP
     $  +.05*rk(82)*ETOH +1.*rk(95)*IOLE
     $  +.713*rk(105)*ISPD +1.37*rk(110)*MTBE
      JAC(kXO2, kC2O3) =  +2.*rk(49)*C2O3 +2.*rk(49)*C2O3
     $  +2.*rk(101)*CXO3
      JAC(kXO2, kCXO3) =  +2.*rk(101)*C2O3
      JAC(kXO2, kXO2) =  - rk(80)*XO2 - rk(80)*XO2
     $  - rk(80)*XO2 - rk(80)*XO2
     $  - rk(86)*HO2 - rk(89)*XO2N
      JAC(kXO2, kXO2N) =  - rk(89)*XO2
      JAC(kXO2, kROR) =  +.96*rk(53)
      JAC(kXO2N, kNO3) =  +.09*rk(59)*OLE
      JAC(kXO2N, kHO2) =  - rk(87)*XO2N
      JAC(kXO2N, kOH) =  +.13*rk(52)*PAR +.088*rk(76)*ISOP
     $  +.02*rk(110)*MTBE
      JAC(kXO2N, kXO2) =  - rk(89)*XO2N
      JAC(kXO2N, kXO2N) =  - rk(87)*HO2 - rk(88)*XO2N
     $  - rk(88)*XO2N - rk(88)*XO2N
     $  - rk(88)*XO2N - rk(89)*XO2
      JAC(kXO2N, kROR) =  +.04*rk(53)
      JAC(kROR, kOH) =  +.76*rk(52)*PAR
      JAC(kROR, kROR) =  - rk(53) - rk(54)
     $  - rk(55)*NO2 +.02*rk(53)
      JAC(kCRO, kNO3) =  +1.*rk(67)*CRES
      JAC(kCRO, kOH) =  +.4*rk(66)*CRES
      JAC(kCRO, kCRO) =  - rk(68)*NO2
c
      RETURN
      END
      SUBROUTINE FASTRATE_2a2f(NOSPEC,HH,HR,RATE)
      INCLUDE  'parchm.cmd'
      INCLUDE  'comchem.cmd'
      DIMENSION  RATE(MXSPEC), HH(MXSPEC), HR(MXRADS)
      REAL NO, NO2, O3, OLE, PAR, TOL, XYL, HCHO, ACET, ETH, 
     & CRES, MGLY, OPEN, PNA, PAN, CO, HNO2, H2O2, HNO3, ISOP, 
     & SO2, SULF, MEOH, ETOH, MTBE, NPHN, ALDX, IOLE, PANX, CH4, 
     & NTR, ISPD, PHCHO, PACET, O1D, O, NO3, N2O5, HO2, OH, C2O3, 
     & CXO3, XO2, XO2N, TO2, ROR, CRO
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      MEOH = 0.
      ETOH = 0.
      ISOP = 0.
      ISPD = 0.
      MTBE = 0.
      NPHN = 0.
      NO2 = HH(KNO2)
      O3 = HH(KO3)
      OLE = HH(KOLE)
      PAR = HH(KPAR)
      TOL = HH(KTOL)
      XYL = HH(KXYL)
      HCHO = HH(KHCHO)
      ACET = HH(KACET)
      ETH = HH(KETH)
      CRES = HH(KCRES)
      MGLY = HH(KMGLY)
      OPEN = HH(KOPEN)
      PNA = HH(KPNA)
      PAN = HH(KPAN)
      CO = HH(KCO)
      HNO2 = HH(KHNO2)
      H2O2 = HH(KH2O2)
      HNO3 = HH(KHNO3)
      IF (LISOP) ISOP = HH(KISOP)
      IF (LSO2) SO2 = HH(KSIV)
      IF (LSO2) SULF = HH(KSULF)
      IF (LMEOH) MEOH = HH(KMEOH)
      IF (LETOH) ETOH = HH(KETOH)
      IF (LMTBE) MTBE = HH(KMTBE)
      IF (LNPHN) NPHN = HH(KNPHN)
      ALDX = HH(KALDX)
      IOLE = HH(KIOLE)
      PANX = HH(KPANX)
      CH4 = HH(KCH4)
      IF (LNITR) NTR = HH(KNITR)
      IF (LISOP) ISPD = HH(KISPD)
      PHCHO = 0.
      PACET = 0.
      If (LPHCH) Then
        PHCHO = HH(KPHCH)
        PACET = HH(KPACT)
      End If
      NO3 = HR(KNO3)
      N2O5 = HR(KN2O5)
      HO2 = HR(KHO2)
      OH = HR(KOH)
      C2O3 = HR(KC2O3)
      CXO3 = HR(KCXO3)
      XO2 = HR(KXO2)
      XO2N = HR(KXO2N)
      ROR = HR(KROR)
      CRO = HR(KCRO)
      kso2 = ksiv
      kntr = knitr
c
c     *** zero out rate for state species. 
c 
       do 100 i=1,nospec
          rate(i) = 0. 
 100   continue
c
c      Calculating the rate for state species
c
      Sink =   - rk(7)*O3  - rk(16)*NO3  - rk(17)*NO3
     &   - rk(26)*OH  - rk(29)*HO2  - rk(47)*C2O3
     &   - rk(55)*ROR  - rk(68)*CRO  - rk(99)*CXO3
     &   - rk(109)*ISOP
      Source = 2.*rk(16)*NO3*NO2 +1.*rk(19)*N2O5
     &  +1.*rk(24)*OH*HNO2 +2.*rk(25)*HNO2*HNO2
     &  +1.*rk(30)*PNA +1.*rk(31)*OH*PNA
     &  +1.*rk(48)*PAN +1.*rk(59)*NO3*OLE
     &  +.2*rk(78)*NO3*ISOP +1.*rk(97)*IOLE*NO3
     &  +1.*rk(100)*PANX +1.*rk(103)*PANX*OH
     &  +.2*rk(109)*NO2*ISOP
      Rate(kNO2) = Source + Sink*NO2
      Sink =   - rk(7)*NO2  - rk(12)*OH  - rk(13)*HO2
     &   - rk(58)*OLE  - rk(62)*ETH  - rk(71)*OPEN
     &   - rk(77)*ISOP  - rk(96)*IOLE  - rk(106)*ISPD
      Source = -1.*rk(16)*NO3*NO2 +(-1.)*rk(25)*HNO2*HNO2
     &  +.33*rk(50)*C2O3*HO2 +.5*rk(96)*IOLE*O3
     &  +.33*rk(102)*CXO3*HO2 +(-.2)*rk(109)*NO2*ISOP
      Rate(kO3) = Source + Sink*O3
c
      RETURN
      END
      SUBROUTINE fastjac_2a2f(NOSPEC,HH,HR,JAC)
      INCLUDE  'parchm.cmd'
      INCLUDE  'comchem.cmd'
      DIMENSION  JAC(MXSPEC,MXSPEC), HH(MXSPEC),HR(MXRADS)
      REAL JAC
      REAL NO, NO2, O3, OLE, PAR, TOL, XYL, HCHO, ACET, ETH, 
     & CRES, MGLY, OPEN, PNA, PAN, CO, HNO2, H2O2, HNO3, ISOP, 
     & SO2, SULF, MEOH, ETOH, MTBE, NPHN, ALDX, IOLE, PANX, CH4, 
     & NTR, ISPD, PHCHO, PACET, O1D, O, NO3, N2O5, HO2, OH, C2O3, 
     & CXO3, XO2, XO2N, TO2, ROR, CRO
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      MEOH = 0.
      ETOH = 0.
      ISOP = 0.
      ISPD = 0.
      MTBE = 0.
      NPHN = 0.
      NO2 = HH(KNO2)
      O3 = HH(KO3)
      OLE = HH(KOLE)
      PAR = HH(KPAR)
      TOL = HH(KTOL)
      XYL = HH(KXYL)
      HCHO = HH(KHCHO)
      ACET = HH(KACET)
      ETH = HH(KETH)
      CRES = HH(KCRES)
      MGLY = HH(KMGLY)
      OPEN = HH(KOPEN)
      PNA = HH(KPNA)
      PAN = HH(KPAN)
      CO = HH(KCO)
      HNO2 = HH(KHNO2)
      H2O2 = HH(KH2O2)
      HNO3 = HH(KHNO3)
      IF (LISOP) ISOP = HH(KISOP)
      IF (LSO2) SO2 = HH(KSIV)
      IF (LSO2) SULF = HH(KSULF)
      IF (LMEOH) MEOH = HH(KMEOH)
      IF (LETOH) ETOH = HH(KETOH)
      IF (LMTBE) MTBE = HH(KMTBE)
      IF (LNPHN) NPHN = HH(KNPHN)
      ALDX = HH(KALDX)
      IOLE = HH(KIOLE)
      PANX = HH(KPANX)
      CH4 = HH(KCH4)
      IF (LNITR) NTR = HH(KNITR)
      IF (LISOP) ISPD = HH(KISPD)
      PHCHO = 0.
      PACET = 0.
      If (LPHCH) Then
        PHCHO = HH(KPHCH)
        PACET = HH(KPACT)
      End If
      NO3 = HR(KNO3)
      N2O5 = HR(KN2O5)
      HO2 = HR(KHO2)
      OH = HR(KOH)
      C2O3 = HR(KC2O3)
      CXO3 = HR(KCXO3)
      XO2 = HR(KXO2)
      XO2N = HR(KXO2N)
      ROR = HR(KROR)
      CRO = HR(KCRO)
      kso2 = ksiv
      kntr = knitr
c
c     *** zero out jac 
c 
       do 200 i=1,nospec
         do 100 j=1,nospec
           jac(i, j) = 0. 
 100     continue
 200   continue
c
c      Calculating the Jacobian for fast Species
c
      JAC(kNO2, kNO2) =  - rk(7)*O3 - rk(16)*NO3
     $  - rk(17)*NO3 - rk(26)*OH
     $  - rk(29)*HO2 - rk(47)*C2O3
     $  - rk(55)*ROR - rk(68)*CRO
     $  - rk(99)*CXO3 - rk(109)*ISOP
     $  +2.*rk(16)*NO3 +.2*rk(109)*ISOP
      JAC(kNO2, kO3) =  - rk(7)*NO2
      JAC(kO3, kNO2) =  - rk(7)*O3 +(-1.)*rk(16)*NO3
     $  +(-.2)*rk(109)*ISOP
      JAC(kO3, kO3) =  - rk(7)*NO2 - rk(12)*OH
     $  - rk(13)*HO2 - rk(58)*OLE
     $  - rk(62)*ETH - rk(71)*OPEN
     $  - rk(77)*ISOP - rk(96)*IOLE
     $  - rk(106)*ISPD +.5*rk(96)*IOLE
c
      RETURN
      END
