      subroutine chread(lrstrt,nuchp,nors55,nspec5,idebug)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: chread.f,v $
c  Revision 1.18  1999/12/21  21:08:04  tcm
c  Cleaned up some formats and replaced holleriths with quoted strings.
c
c  Revision 1.16  1999/05/18  00:19:33  dfg
c  Addec check for PHCHO & PACET so that lphch can be set.
c  Added the write statement for print out lphch to diag file.
c
c  Revision 1.15  1999/05/13  23:36:36  dfg
c  fixed a format typo.
c
c  Revision 1.14  1999/05/13  17:43:03  dfg
c  Added the write statement for print out lmte and lnphn
c  to diag file.
c
c  Revision 1.13  1999/05/13  17:39:53  dfg
c  Added check for species MTBE & NPHN so that lmtbe & lnphn
c  can be set up.
c
c  Revision 1.12  1999/05/12  18:41:44  dfg
c  removed hardwired nspint value.
c
c  Revision 1.11  1998/11/20  18:49:41  tcm
c  corrected format 2701.
c
c  Revision 1.10  1998/11/19  00:07:44  ara
c  Eliminated error messages directed to diag file where the it
c  was already directed by variable nutrc = 8 = diag file
c
c  Revision 1.9  1998/11/17  18:05:47  ara
c  *** empty log message ***
c
c  Revision 1.8  1998/11/17  17:49:26  ara
c  Directed warning message to screen, diag file and log file
c
c  Revision 1.7  1998/11/16  17:47:09  ara
c  Made modifications to format of error messages
c
c  Revision 1.6  1998/11/06  23:06:26  ara
c  Changed error message reference from unit 66 to unit 8 (diag file)
c
c  Revision 1.5  1998/11/06  21:12:15  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed errors to screen, diag file and log file (ierrlg)
c
c  Revision 1.4  1997/06/03  17:41:45  tcm
c  corrected syntax in if statement at line 292
c
c  Revision 1.3  1996/06/14  22:55:21  tcm
c  number of internal species increased by hpd
c
c  Revision 1.2  1994/02/10  20:53:58  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
      include 'parchm.cmd'
      include 'comd3.cmd'
      include 'comchem.cmd'
      include 'errlog.cmd' 
c
c     ***  read chem parameters and fill in species indices
c
c
c---local variables
c         lerror
c         lmust     l  if true, all species after this must be unreact
c
c--routines called - none
c
c--called by
c         setup
c
c--modified considerably to check for correct species order, set
c  some flags according to presence of species names and to 
c  eliminate explicit reads of flags for those species.
c  (tcm, 12/10/91)
c
      logical lmust,lrstrt, lcsav
      dimension  mmech(60),nam(10),namchp(10),nid(60)
c
      data namchp/'C','H','E','M','P','A','R','A','M',' '/
c
c**********************************************************************
c
c
c  save value of lchem flag
c
      lcsav = lchem
c
c     aqueous reaction rate and temp dependence values
c
c        we are using a cloud particle size representing a peak in the
c        particle size distribution.
c        be very careful, as this is a variable.
c
      dp = 10.
c
      aca = 2.e-5
      ana = 2.e-5
      tnh3 = 6.e-4
      co2 = 3.4e+2
      hcl = 3.e-4
      pno3 = 7.e-5
c
c     in the following data set diffusivities are in cm **2/sec
c        for organic species an average diffusivity of 0.066 cm**2/sec
c        is assumed
c
      doh = 0.13
      dho2 = 0.095
      dn25 = 0.053
      dhcl = 0.090
      do  = 0.135
      dorg = 0.066
c
c
c change per sec. rates to per hr. rates for program
c
c
c     *** read and check file description header record
c
c
c  **** set nspint to 31 here since the data statement in
c       aqbdat is not working.  nspint must match the number
c       of names in the list in mspint
* changed to 32 due to addition of ISPD, 1996/05/30 hpd
c
c  Changed to 38 here due to the addition of 6 more species for TOX (5/12/99, dfg)
c
c     nspint = 32
c...bit 12 (2048's) of idebug activates writes to debug file in chread
c
      idiag=and(idebug,2048)
c 
      if(idiag.ne.0)then
        write(8,*)'just entered chread...'
        write(8,*)'nutrc= ',nutrc
        write(8,*)'nspint= ',nspint
c        write(8,*)'naqeq= ',naqeq
        write(8,*)'k0(1),k0(5)= ',k0(1),k0(5)
        write(8,*)'dhor(1),dhor(5)= ',dhor(1),dhor(5)
      endif
c
      write (nutrc,2500)
c
      read  (nuchp,2505) nam, nid, nsg, nspec5, nbdchp, btchp,
     &  nedchp, etchp
c
      write (nutrc,2510) nam, nid, nsg, nspec5, nbdchp, btchp,
     &  nedchp, etchp
      do 12 i=1,10
        if (nam(i).ne.namchp(i)) then
          write (nutrc,2012) nam, namchp
          write (*,2012) nam,namchp
          write (ierrlg,2013) 1034,nam,namchp
          stop
        endif
   12 continue
c
      if(idiag.ne.0)write(8,*)'checked file description header'
c     ***  read and print chemparam species definition header
c
      read (nuchp,2515)  ((mspec(i,j), i=1,10), j=1,nspec5)
      write (nutrc,2520) ((mspec(i,j), i=1,10), j=1,nspec5)
c
c     ***  read chemistry definition record
c
      read (nuchp,2525)  mmech, lso2, lnitr,
     &     nreact
      write (nutrc,2530)  mmech, lso2, lnitr,
     &     nreact
c
c  if laq is false, set cwcmin large so no aqueous chem will get done
c
      if (laq) then
        cwcmin = .01
        write(*,*) ' *** error*** : laq = true not supported.'
        write(8,*) ' *** error*** : laq = true not supported.'
        write(ierrlg,'(i4,1x,a,a)') 1033,' *** error*** : laq = true ',
     &            'not supported.' 
        stop
      else
        cwcmin = 1.e20
      endif
c
      if(idiag.ne.0)write(8,*)'read chem definition record'
c
c     *** test dimensions
c
      if (nspec5.gt.mxspec.or.nreact.gt.mxgrx ) then
c   
c     *** dimension error
c
        write (nutrc,2050) mxspec,mxgrx,mxarx
        write (*,2050) mxspec,mxgrx,mxarx
        write (ierrlg,2051) 1037,mxspec,mxgrx,mxarx
        lerror = .true.
        go to 800
      endif
c
c     *** read species record
c
  100 continue
      read (nuchp,2535)  ((mspec(i,l),i=1,10), lreac(l), lssic(l),
     &  lssbc(l), bdnl(l), bdnu(l), l=1,nspec5)
c
      write (nutrc,2540) ((mspec(i,l),i=1,10), lreac(l), lssic(l),
     &  lssbc(l), bdnl(l), l=1,nspec5)
c
c
c     ***  set various control flags
c
c---are there any reactive species
c
      nors55 = 0
      lmust  = .false.
      lchem  = .false.
      lanysi = .false.
      lanysb = .false.
c
c
      lint = 0
      do 180 l=1,nspec5
c
        if (lreac(l)) then
c
c        --reactive--
c
          if (lmust) then
            lerror = .true.
            write (nutrc,2130) l
            write (*,2130) l
            write (ierrlg,2131) 214,l
            go to 180
          endif
c
c
          nors55 = nors55 + 1
          lchem = .true.
          if (lssic(l)) lanysi = .true.
          if (lssbc(l)) lanysb = .true.
c
c   this is a reactive species, so check that name matches
c   the internal name
c
  140     lint = lint + 1
          if (idiag .ne. 0) write(nutrc,'(2i4,2x,10a1,2x,10a1)')
     &              l, lint, (mspec(ii,l),ii=1,10),
     &              (mspint(ii,lint),ii=1,10)
          if (lint .gt. nspint) then
            write(nutrc,2220) l, (mspec(i,l),i=1,10)
            write(*,2220) l, (mspec(i,l),i=1,10)
            write(ierrlg,2221) 1039,l, (mspec(i,l),i=1,10)
            stop
          endif
          do 145 i=1,10
            if (mspec(i,l) .ne. mspint(i,lint)) then
              if (lint .le. 20) then
                write(nutrc,2200) l, (mspec(ii,l),ii=1,10),
     &                           (mspint(ii,lint),ii=1,10)
                write(*,2200) l, (mspec(ii,l),ii=1,10),
     &                           (mspint(ii,lint),ii=1,10)
                write(ierrlg,2201) 1038,l,(mspec(ii,l),ii=1,10),
     &                            (mspint(ii,lint),ii=1,10)
                 stop
              else
                kind(lint) = 0
                go to 140
              endif
            endif
  145     continue
          kind(lint)=l
c
c        --unreactive--
c
        else
          lmust = .true.
c
c   see if this name appears in the list of internal names
c   if it does, set the internal pointer, but only if the internal
c   pointer has not already been set.
c
          do 155 lsp=1,nspint
            do 150 i=1,10
              if (mspec(i,l) .ne. mspint(i,lsp)) go to 155
  150       continue
             if (kind(lsp) .ne. 0) then
               l2 = kind(lsp)
               write(nutrc,2250) l, (mspec(i,l),i=1,10),
     &                           l2, (mspec(i,l2),i=1,10)
               write(*,2250) l, (mspec(i,l),i=1,10),
     &                       l2, (mspec(i,l2),i=1,10)
               write(ierrlg,2251) 1050,l, (mspec(i,l),i=1,10), 
     &                         l2, (mspec(i,l2),i=1,10)
               stop
             endif
             kind(lsp) = l
  155      continue
         endif
c
  180  continue
c
c    check for presence of optional species
c
c      meoh?
c
      if (kmeoh .le. 0) then
        lmeoh = .false.
      else if (.not.lreac(kmeoh)) then
        lmeoh = .false.
      else
        lmeoh = .true.
      endif
c
c      etoh?
c
      if (ketoh .le. 0) then
        letoh = .false.
      else if (.not.lreac(ketoh)) then
        letoh = .false.
      else
        letoh = .true.
      endif
c
c      isop?
c
      if (kisop .le. 0 ) then
        lisop = .false.
      else if (.not.lreac(kisop)) then
        lisop = .false.
      else
        lisop = .true.
      endif
c
c      MTBE?
c
      if (kmtbe .le. 0 ) then
        lmtbe = .false.
      else if (.not.lreac(kmtbe)) then
        lmtbe = .false.
      else
        lmtbe = .true.
      endif
c
c      NPHN?
c
      if (knphn .le. 0 ) then
        lnphn = .false.
      else if (.not.lreac(knphn)) then
        lnphn = .false.
      else
        lnphn = .true.
      endif
c
c      PHCHO & PACET?
c
      if (kphch .le. 0 ) then
        lphch = .false.
      else if (.not.lreac(kphch)) then
        lphch = .false.
      else
        lphch = .true.
      endif
c
c---write out values of species flags
c
      write(nutrc,2570) lmeoh,lisop,letoh,lmtbe,lnphn,lphch
c
c
c---if this is a restart, dont do steady state on initial concs
c
      if (lrstrt) lanysi = .false.
c
c
c     ***  read reaction record, if any
c
      if(idiag.ne.0)write(8,*)'finished reads in chemparm'
      call flush(8)
      if (nreact.le.0) go to 300
      read (nuchp,2545) (rkn(j), lphot(j), ltdep(j), lpdep(j),
     &      norder(j),acten(j), rkn3(j), acten3(j), j=1,nreact)
      write (nutrc,2550) (j, rkn(j), lphot(j), ltdep(j), lpdep(j),
     &      norder(j),acten(j),rkn3(j),acten3(j), j=1,nreact)
      do 13 j=1,nreact
        if (lpdep(j)) then
            lpdep(j) = .false.
            write(*,88) j
   88       format('pressure dependence for reaction number ',i2,
     &             ' has been reset to false.',/,'The chemistry',
     &             ' currently does not have pressure dependent',
     &             ' capability.')
        endif
        if (norder(j).gt.1) then
            norder(j) = 1
            write(*,89) j
   89       format('Third order reaction rates for pressure ',
     &             'dependent reactions are not currently ',/,
     &             'implemented in this chemistry mechanism.',
     &             '  norder has been reset to 1 for reaction ',i2)
        endif
   13 continue
c
c
c     *** set global reaction flags
c         initialize calculated rk to rkn
c
  220 lanyph = .false.
      lanytd = .false.
      lphfac = .false.
c
      do 230 j=1,nreact
        rk(j) = rkn(j)
        if (rkn(j).eq.0.) go to 230
        if (lphot(j)) lanyph = .true.
        if (acten(j).eq.0.) ltdep(j) = .false.
        if (ltdep(j)) lanytd = .true.
  230 continue
c
  300 continue
c-----------------------------------------------------------------------
c
c     *** set aerosol index for use in emission conversion
c
c     kkaer = kaer
c
c-----------------------------------------------------------------------
c
c     *** if there is chemistry, validate
c         chemistry integration controls
c          (from simcontrol)
c
      write(8,*)'checking chem integration controls...'
      if (.not.lchem) go to 800
c
      ibad = 0
      if (dtmin.lt.0.) ibad = ibad + 1
      if (maxitr.lt.1) ibad = ibad + 1
      if (rerror.le.0.) ibad = ibad + 1
      if (ibad.eq.0) go to 800
      write (nutrc,2600) ibad
      lerror = .true.
c
c
c     *** check for errors
c
      call flush(8)
c
  800  if (.not.lerror) then
         if(idiag.ne.0)write(8,*)'exiting chread...'         
         nors=nors55                                         
         lchem = lcsav                                       
       else
         write (nutrc,2700)
         write (*,2700)
         write (ierrlg,2701) 1051
         stop
       endif
c------------------------------------------------------------------------
c
c     ***  formats
c
 2012 format ('0***ERROR in -chread- *** file named ',
     &  10a1, ' should have been ', 10a1)
 2013 format (i3,1x,'0***ERROR in -chread- *** filed named ',
     &  10a1, ' should have been ', 10a1)
 2050 format ('0Maximum dimensions exceeded -- '/
     &  ' species ', i2/' gas reacts', i3/' aq reacts',i3)
 2051 format (i4,1x,'0Maximum dimensions exceeded -- '/
     &  ' species ', i2/' gas reacts', i3/' aq reacts',i3)
 2060 format (' species flag mismatch'/' laq=',l3,' lso2=',l3,
     &   ' lfe=',l3,' lmn=',l3)
c
 2130 format (' *ERROR--species ', i2, ' is out of sequence.')
 2131 format (i4,1x,' *ERROR--species ', i2, ' is out of sequence.')
 2200 format (' ***ERROR*** ',/,' input species number ',i4,
     &        '( ',10a1,') does not match ',/,
     &        ' internal name (',10a1,')')
 2201 format (i4,1x,' ***ERROR*** ',/,' input species number ',i4,
     &        '( ',10a1,') does not match ',/,
     &        ' internal name (',10a1,')')
 2220 format (' ***ERROR*** ',/,' input species number ',i4,
     &        '( ',10a1,') does not match ',/,
     &        ' any internal name or species is out of order.')
 2221 format (i4,1x,' ***ERROR*** ',/,' input species number ',i4,
     &        '( ',10a1,') does not match ',/,
     &        ' any internal name or species is out of order.')
 2250 format (' ***ERROR*** ',/,' input species number ',i4,
     &        '( ',10a1,') already defined ',/,
     &        ' at number ',i4,' (',10a1,')')
 2251 format (i4,1x,' ***ERROR*** ',/,' input species number ',i4,
     &        '( ',10a1,') already defined ',/,
     &        ' at number ',i4,' (',10a1,')')
c
 2500 format ('1****************  CHEMPARAM FILE  *******************')
 2505 format (//22x,10a1/22x,60a1,3(/22x,i2),/22x,f2.0/22x,i2,
     1 22x,f2.0)
 2510 format ('0File description header record '/
     &  5x,'File type      = ', 10a1 /
     &  5x,'File id        = ', 60a1 /
     &  5x,'No of segments = ', i2   /
     &  5x,'No of species  = ', i2   /
     &  5x,'Beg date       = ', i2   /
     &  5x,'Beg time       = ', f2.0 /
     &  5x,'End date       = ', i2   /
     &  5x,'End time       = ', f2.0 )
 2515 format (//(5x,10a1))
 2520 format ('0species description header record '/
     &  (5x,10a1))
 2525 format (/23x,60a1,2(/28x,l4),1(/37x,i3))
c 2525 format (/23x,60a1,3(/28x,l4),2(/37x,i3))
 2530 format ('0chemistry definition record '/
     &  5x, 'Mechanism id    = ', 60a1 /
c     &  5x, ' laq=',l3,' lso2=',l3,
     &  5x, ' lso2=',l3,
     &  ' lnitr=',l4,/,
c     &  5x, 'No of gas-phase reactions =' , i3   /
     &  5x, 'No of gas-phase reactions =' , i3)
c     &  5x, 'No of aq-phase reactions  =' , i3)
 2535 format (///(6x,10a1,3l7,1p2e17.4))
 2540 format ('0species parameters record '//
     &  5x, 'Spec Name ', 2x,'React', 2x,' SSIC', 2x,' SSBC',
     & 2x, 10x,'Low Bd Num'/
     & (5x, 10a1, 3l7, 1pe17.4))
 2545 format (//(5x,e12.3,3l6,i6,3e13.3))
 2550 format ('  reaction parameters record' //
     & 7x, 'Rate const', 2x, 'Phot', 2x, 'Temp',2x, 'Pres', 2x,
     &     ' #', 5x, 'Act Energy', 2x, '3rd order',2x,'Act Energy'/
     & (i4, 1x, 1pe11.3, 3l6, i6, 3e13.3))
 2560 format(/(5x,e11.3,2l6,e13.3))
 2570 format(/,' optional species to be included:',/,
     &       5x,'Methanol:      ',l10,/,
     &       5x,'Isoprene:      ',l10,/,
     &       5x,'Ethanol:       ',l10,/,
     &       5x,'MTBE:          ',l10,/,
     &       5x,'NPHN:          ',l10,/,
     &       5x,'PHCHO & PACET: ',l10,/)
 2600 format ('0', i2, ' Validation errors on chemistry ',
     &  ' integration parameters ')
 2700 format ('0program terminating in -chread- due to above errors')
 2701 format(i4,1x,'0program terminating in -chread- due to above ',
     &       'errors')
c-----------------------------------------------------------------------
c
      return
      end
