      subroutine clldim(nutrc)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: clldim.f,v $
c  Revision 1.2  1994/02/10  20:54:02  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c     this subroutine determines width factors for
c     calculating cell widths corresponding to total plume width
c     of defnw*sigma.
c     radfac is the resulting width factor
c    
c     (rewritten for elliptic plume, 1/2/92, tcm)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'pigpen.cmd'
      include 'rpm.cmd'
c
      dimension radfac(mxskn+1)
      data n/100/,eps/1.e-5/
c
      defnw=4.0
      factr=1.0
c
      ncl1=nrclls+1
      nc21=nrclls - 1
      radfac(nrclls)=defnw/2.
      rfacb(1)=0.
      ffinal = finteg(radfac(nrclls))
      finc = ffinal/float(nrclls) 
c 
      if(nrclls.eq.1) then
        wfac(1)=radfac(nrclls)
        rfacc(1)=wfac(1)/2.
        rfacb(2)=wfac(1)
        go to 80
      endif
c
      nc=1
      a1=0.005
      a2=radfac(nrclls)
      fnow = finc
   20 l=1
   30 f1 = finteg(a1)
      f2 = finteg(a2)
      a3 = a1 + (a2-a1)/(f2-f1) * (fnow-f1)
      f3 = finteg(a3)
      fx = f3 - fnow
      if(abs(fx).lt.eps) then
        radfac(nc)=a3
        if(nc.eq.nc21) go to 60
        nc=nc+1
        a1 = a3
        a2 = radfac(nrclls)
        fnow = fnow + finc
        go to 20
      endif
ctcm      write(nutrc,*) 'NC,L,A3,FX,FNOW,FINC:',nc,l,a3,fx,fnow,finc
ctcm      write(nutrc,*) 'NRCLLS, NCL1, NC21, N, EPS:',
ctcm     &                  nrclls, ncl1, nc21, n, eps
ctcm      write(nutrc,*) 'f1,f2,f3,a1,a2,a3:',
ctcm     &                  f1,f2,f3,a1,a2,a3
      if(l.gt.n) then
        write(nutrc,130) nc,l,fx
        stop
      endif
      if (f3 .gt. fnow) then
        a2 = a3
      else
        a1 = a3
      endif
      L=L+1
      go to 30
c
   60 rfacb(1)=0.0
      do 70 nc=1,nrclls
        nc1=nc-1
        drad=radfac(nc)
        dr=radfac(nc)
        cr=radfac(nc)/2.
        if(nc1.gt.0) drad=radfac(nc)-radfac(nc1)
        if(nc1.gt.0) cr=rfacb(ncp+1)+drad/2.
        ncp=nc
        rfacb(ncp+1)=dr
        rfacc(ncp)=cr
        wfac(ncp)=drad
   70 continue
c
   80 write(nutrc,120)
      do 90 nc=1,nrclls
        write(nutrc,100) nc,wfac(nc),rfacc(nc),rfacb(nc)
   90 continue
      write(nutrc,110) ncl1, rfacb(ncl1)
  100 format('CELL NO.',i4,2x,'WIDTH FACTOR-',1pe12.3
     &,2x,'CENTERLINE FACTOR-',1pe12.3,2x,'BOUNDARY FACTOR-'
     &,1pe12.3)
  110 format('INDEX NO.',i3,61x,'BOUNDARY FACTOR-',1pe12.3)
  120 format('PLUME GEOMETRY')
C
      return
  130 format('POOR CONVERGENCE, NC=',i3,' L=',i3
     &,' FX=',1pe12.5)
      end
