      subroutine crsfil(concf,htf,nxf,nyf,nsp,nzf,ifine,idebug)
C
C     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: crsfil.f,v $
c  Revision 1.4  1999/07/07  16:11:43  tcm
c  Track change before and after concentrations are filled in for pa/irr.
c
c  Revision 1.3  1995/04/26  00:37:21  tcm
c  	updated treatment of vertical nesting
c
c  Revision 1.2  94/02/10  20:54:14  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
C
c
c  fill in coarse grid concentrations with fine grid
c  concentrations.  Should be done at end of time step
c  after all transport and chem calculations are done.
c  (tcm, 10/2/90)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      dimension concf(nxf,nyf,nsp,nzf)
      dimension htf(nxf,nyf,nzf)
      include 'comuam.cmd'
      include 'deffin.cmd'
c
czswa------------------------------------------------------------------------
c
      include 'irmb.cmd'
c
c  get concentration difference due to fine_coarse fill-in
c
      call get_difc (5,1,1)
c
czswz------------------------------------------------------------------------
c
c  Bit ten of idebug on (i.e., the five hundred twelves location) 
c  will turn on debug writes in rchem.
c
      idiag = and(idebug,512)
c
c  zero out coarse grid where overlapped by this fine grid
c
      do 100 k=1,nlayer
        do 90 n=1,nospec
          do 80 j=jyfb(ifine),jyfe(ifine)
            do 70 i=ixfb(ifine),ixfe(ifine)
              conc(i,j,n,k) = 0.
   70       continue
   80     continue
   90   continue
  100 continue 
c
c  sum coarse grid for all levels and all species
c
      do 200 k=1,nlayer
        do 190 n=1,nospec
          kf2 = kvmap(k,ifine)
          if (k .eq. 1) then
            kf1 = 1
          else 
            kf1 = kvmap(k-1,ifine) + 1
          endif
          do 180 kf=kf1,kf2
             do 150 j=2,nyf-1
              jc = jyfb(ifine) + (j-2)/nhf(ifine)
              do 140 i=2,nxf-1
                if (kf .gt. 1) then
                  delh = htf(i,j,kf) - htf(i,j,kf-1)
                else
                  delh = htf(i,j,kf)
                endif
                vol = delfx(j,ifine)*delfy(ifine)*delh
                ic = ixfb(ifine) + (i-2)/nhf(ifine)
                if (idiag .ne. 0) then
                  if (ic .eq. 44 .and. jc .eq. 16 .and. n .eq. 1) then
                    write(*,*) ' Sum loop, conc, concf: ',
     &                     conc(ic,jc,n,k), concf(i,j,n,kf)
                    write(*,*) ' vol, delfx, delfy, delh, htfk&k-1:',
     &                     vol, delfx(j,ifine), delfy(ifine),
     &                     delh, htf(i,j,kf), htf(i,j,kf-1)
                    write(*,*) ' ic,jc, i,j, kk, kf: ',
     &                    ic, jc, i, j, kk, kf
                  endif
                endif
                conc(ic,jc,n,k) = conc(ic,jc,n,k)
     &                  + concf(i,j,n,kf)*vol
  140         continue
  150       continue
  180     continue
  190   continue
  200 continue
c
c  recalculate conc as concentration instead of mass
c
      do 300 k=1,nlayer
        do 290 n=1,nospec
          do 280 j=jyfb(ifine),jyfe(ifine)
            do 270 i=ixfb(ifine),ixfe(ifine)
              if (k .gt. 1) then
                delh = h(i,j,k) - h(i,j,k-1)
              else
                delh = h(i,j,k)
              endif
              vol = deltax(j)*deltay*delh
              if (idiag .ne. 0) then
                if (i .eq. 44 .and. j .eq. 16 .and. n .eq. 1) then
                  write(*,*) ' Avg loop, conc: ',
     &                   conc(i,j,n,k)
                  write(*,*) ' vol, deltax, deltay, delh, hk&k-1:',
     &                   vol, deltax(j), deltay,
     &                   delh, h(i,j,k), h(i,j,k-1)
                  write(*,*) ' i,j, k: ',
     &                   i, j, k
                endif
              endif
              conc(i,j,n,k) = conc(i,j,n,k)/vol
  270       continue
  280     continue
  290   continue
  300 continue
c
czswa------------------------------------------------------------------------
c  finish off on getting concentration difference due to fill-ins
c
      call get_difc (5,2,1)
c
czswz------------------------------------------------------------------------
c
      return
      end
