      subroutine diagn(time,idate,m,tend,tstr,idystr
     &,idaynf)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: diagn.f,v $
c  Revision 1.14  2002/06/28  17:38:53  tcm
c  Corrected format 8340
c
c  Revision 1.13  2002/06/26  20:44:13  tcm
c  Eliminated some dead code.
c
c  Revision 1.12  1999/12/21  21:08:28  tcm
c  Cleaned up some format statements.
c
c  Revision 1.10  1999/03/30  21:01:01  tcm
c  Corrected counter for diagnostic averages of input data.
c
c  Revision 1.9  1998/11/20  21:24:14  tcm
c  fixed error messages on lines 157 and 558
c
c  Revision 1.8  1998/11/17  22:30:20  ara
c  Directed warning messages to screen and to log file (ierrlg)
c
c  Revision 1.7  1998/11/09  17:03:04  ara
c  Eliminated reference to some of the error messages to screen
c  diag file and log file. They were considered warnings
c
c  Revision 1.6  1998/11/06  23:40:25  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error messages to screen, diag file and log file (ierrlg)
c
c  Revision 1.5  1998/11/04  01:36:38  tcm
c  Revised time zone range.
c  Diagnostics performed only on non-boundary cells.
c
c  Revision 1.4  1996/06/14  22:55:46  tcm
c  See comments below
c
c  Revision 1.3  1994/02/17  09:07:31  tcm
c  Bypass check of no. of point sources when lpts is false.
c
c  Revision 1.2  94/02/10  20:54:38  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c   Modified to set default min/max for stack parameters
c   gem -- 4/1/96
c
c
c *** This subroutine reads in allowable data intervals
c     calculates min, max, and average data values and
c     checks these against allowable values
c
c...modified 6/21/91 to print mspec rather than hardwired
c...species names npsp,nmmsp...rrs
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
      include 'comd3.cmd'
      include 'comchem.cmd'
      include 'latlon.cmd'
      include 'stack.cmd'
      include 'errlog.cmd'
c
      real mindtd,maxdtd,mindtp,maxdtp,mindx,maxdx,mindy,maxdy
      real minpkr,maxpkr,mincrc,maxcrc,mintem,maxtem
      real minem1,maxem1,minem2,maxem2,minrem,maxrem,minsth,maxsth
      real minstd,maxstd,mintst,maxtst,minv,maxv
      real khmax(mxz),khmin(mxz),khavg(mxz)
      real kvmax(mxz),kvmin(mxz),kvavg(mxz)
      real maxrn,minrn
      logical errflg
      dimension cnmin(mxspec,mxz),cnmax(mxspec,mxz),cnsum(mxspec,mxz)
      dimension umin(mxz),umax(mxz),uavg(mxz),vmin(mxz),vmax(mxz)
      dimension vavg(mxz)
      dimension awsmin(mxz),awsmax(mxz),awsavg(mxz)
      dimension htmin(mxz),htmax(mxz),htavg(mxz)
      dimension cldmin(mxz),cldmax(mxz),cldavg(mxz)
      dimension vdpmin(mxspec),vdpmax(mxspec),vdpavg(mxspec)
      dimension tmpmin(mxz),tmpmax(mxz),tmpav(mxz)
      dimension watmin(mxz),watmax(mxz),watav(mxz)
      dimension nbc(mxz)
      data errflg /.false./
      data mindtd,maxdtd /30.,600./
      data mindtp,maxdtp /30.,600./
      data mindx,mindy,maxdx,maxdy /0.01,0.01,20.,20./
      data minnox,maxnox /5,mxx/
      data minnoy,maxnoy /5,mxy/
      data minpkr,maxpkr /0.,8.3e-04/
      data mincrc,maxcrc /0.,1.0e-2/
      data tzmin,tzmax /0.,23./
      data mintem,maxtem /253.,313./
      data maxnpt /mxsrc/
      data minem1,maxem1 /0.0,1.e20/
      data minem2,maxem2 /0.0,1.e20/
      data minrem,maxrem /0.0,1.e20/
      data minsth,maxsth /0.5,2100./
      data minstd,maxstd /0.01,100./
      data mintst,maxtst /260.,2000./
      data minv,maxv /0.0001,500./
      data maxrn/20.0/, minrn/0.0/
c
c *** do we check setup data or update data
      if(m.gt.1) go to 1000
c *** This portion is executed at setup time only
      if(idystr.gt.idaynf) go to 9001
      if((idystr.eq.idaynf).and.(tstr.gt.tend)) go to 9001
  101 call chkdat(idystr,errflg)
      call chkdat(idaynf,errflg)
      if((tstr.lt.0.).or.(tstr.gt.2400.)) go to 9002
  102 if((tend.lt.0.).or.(tend.gt.2400.)) go to 9003
  103 if(dtdata.lt.mindtd) go to 9005
      if(dtdata.gt.maxdtd) go to 9005
  105 if(dtprnt.lt.mindtp) go to 9007
      if(dtprnt.gt.maxdtp) go to 9007
  107 if(dlong.lt.mindx) go to 9009
      if ((.not.lcart).and.(dlong.gt.maxdx)) go to 9009
      if (lcart.and.dlong.gt.200.0) go to 9009
  109 if (.not.lcart.and.(dlat.gt.maxdy)) go to 9011
      if(dlat.lt.mindy) go to 9011
      if(lcart.and.dlat.gt.200.0) go to 9011
  111 if(nox.lt.minnox) go to 9013
      if(nox.gt.maxnox) go to 9013
  113 if(noy.lt.minnoy) go to 9015
      if(noy.gt.maxnoy) go to 9015
  115 if(nospec.gt.mxspec) go to 9016
      if (nospec.lt.1) go to 9016
  116 continue
  118 if((wlong.lt.(-180.)).or.(wlong.gt.180.)) go to 9019
  119 if((elong.lt.(-180.)).or.(elong.gt.180.)) go to 9020
  120 if((nlat.lt.(-90.)).or.(nlat.gt.90.)) go to 9021
  121 if((slat.lt.(-90.)).or.(slat.gt.90.)) go to 9022
  122 if((tz.lt.tzmin).or.(tz.gt.tzmax)) go to 9023
  123 if(pkrchm.lt.minpkr) go to 9025
      if(pkrchm.gt.maxpkr) go to 9025
  125 if(pkrchm.lt.crchem) go to 9026
  126 if(crchem.lt.mincrc) go to 9027
      if(crchem.gt.maxcrc) go to 9027
  127 continue
  128 continue
  129 if(lpts .and. nopts.lt.1) go to 9031
      if(nopts.gt.maxnpt) go to 9031
  131 do 20 i=1,nopts
  133   continue
  135   continue
  136   if (.not.lcart.and.(plong(i).lt.wlong)) go to 9037
        if (.not.lcart.and.(plong(i).gt.elong)) go to 9037
        if(lcart.and.plong(i).gt.float(nox))go to 9037
        if(lcart.and.plong(i).lt.0.0)go to 9037
  137   if(.not.lcart.and.(plat(i).lt.slat)) go to 9038
        if(.not.lcart.and.(plat(i).gt.nlat)) go to 9038
        if(lcart.and.(plat(i).gt.float(noy)))go to 9038
        if(lcart.and.(plat(i).lt.0.0))go to 9038
  138   continue
  139   if(stkht(i).lt.minsth) go to 9040
 1391   if(stkht(i).gt.maxsth) go to 9140
  140   if(stkd(i).lt.minstd) go to 9041
 1440   if(stkd(i).gt.maxstd) go to 9141
  141   if(temps(i).lt.mintst) go to 9042
 1411   if(temps(i).gt.maxtst) go to 9142
  142   if(vexit(i).gt.maxv) go to  9043
 1420   if(vexit(i).lt.minv) go to 9143
        go to 20
 9037   write(8,8037) i,plong(i)
        write(*,8037) i,plong(i) 
        write(ierrlg,8138) 271,i,plong(i)
        go to 137
 9038   write(8,8038) i,plat(i)
        write(*,8038) i,plat(i)
        write(ierrlg,8139) 272,i,plat(i)
        go to 138
c9039   errflg=.true.
c       write(8,8039) i,tsum
c       write(*,8039) i,tsum
c       write(ierrlg,8240) 273,i,tsum
c       go to 139
c 9040   errflg=.true.
 9040   write(8,8040) i,stkht(i)
        write(*,8040) i,stkht(i)
        write(ierrlg,8340) 274,i,stkht(i)
	stkht(i)=minsth
        go to 1391
 9140   write(8,8140) i,stkht(i)
        write(*,8140) i,stkht(i)
        write(ierrlg,8440) 281,i,stkht(i)
	stkht(i)=maxsth
        go to 140
c9041   errflg=.true.
 9041   write(8,8041) i,stkd(i)
        write(*,8041) i,stkd(i)
        write(ierrlg,8241) 275,i,stkd(i)
	stkd(i)=minstd
        go to 1440
 9141   write(8,8141) i,stkd(i)
        write(*,8141) i,stkd(i)
        write(ierrlg,8242) 276,i,stkd(i)
	stkd(i)=maxstd
        go to 141
 9042   write(8,8042) i,temps(i)
        write(*,8042) i,temps(i)
        write(ierrlg,8243) 277,i,temps(i)
	temps(i)=mintst
        go to 1411
 9142   write(8,8142) i,temps(i)
        write(*,8142) i,temps(i) 
        write(ierrlg,8244) 278,i,temps(i)
	temps(i)=maxtst
        go to 142
c9043   errflg=.true.
 9043   write(8,8043) i,vexit(i)
        write(*,8043) i,vexit(i)
        write(ierrlg,8245) 279,i,vexit(i)
	vexit(i)=maxv
	go to 1420
 9143   write(8,8143) i,vexit(i)
        write(*,8143) i,vexit(i)
        write(ierrlg,8246) 280,i,vexit(i)
	vexit(i)=minv
   20 continue
c
      do 35 l=1,nlayer
        do 34 k=1,nospec
          cnmin(k,l)=1.e20
          cnmax(k,l)=-1.e20
          cnsum(k,l)=0.0
          do 30 j=1,noy
            do 29 i=1,nox
              cnmax(k,l)=amax1(cnmax(k,l),conc(i,j,k,l))
              cnmin(k,l)=amin1(cnmin(k,l),conc(i,j,k,l))
              cnsum(k,l)=cnsum(k,l)+conc(i,j,k,l)
   29       continue
   30     continue
          noxy=nox*noy
          cnsum(k,l)=cnsum(k,l)/noxy
   34   continue
   35 continue
c
      write(8,901)
  901 format('1',40x,'Initial Concentrations',//,16x,'Minimum',
     &   40x,'Maximium',40x,'Average')
      do 990 k=1,nospec
      do 990 l=1,nlayer
      write(8,902) l,(mspec(mm,k),mm=1,10),cnmin(k,l),
     &    cnmax(k,l),cnsum(k,l)
      call flush(8)
  990 continue
  902 format(1x,'layer- ',i2,1x,10a1,2x,f10.6,37x,f10.6,37x,f10.6)
  904 format(1x,'upr layer ',a4,2x,f10.6,37x,f10.6,37x,f10.6)
      if(errflg) go to 10000
      write(8,41)
   41 format(5x,'All variables read in setup lie within',
     &   ' allowable limit')
      return
10000 write(8,42)
      write(*,42)
      write(ierrlg,43) 1052
   42 format(/,5x,'Run aborted because of preceding error',
     &   ' message(s)')
   43 format(i4,1x,/,5x,'Run aborted because of preceding error',
     &   ' message(s)')   
      stop 1
c
c *** check update data
c
 1000 continue
c *** compute min,max,av of input values
      do 45 k=1,nlayer
        umin(k)=u(1,1,k)
        umax(k)=umin(k)
        uavg(k)=0.0
        aumin(k)=abs(u(1,1,k))
        aumax(k)=aumin(k)
        auavg(k)=0.0
        vmin(k)=v(1,1,k)
        vmax(k)=vmin(k)
        vavg(k)=0.0
        avmin(k)=abs(v(1,1,k))
        avmax(k)=avmin(k)
        avavg(k)=0.0
        awsmin(k)=sqrt(u(1,1,k)*u(1,1,k)+v(1,1,k)*v(1,1,k))
        awsmax(k)=awsmin(k)
        awsavg(k)=0.0
        tmpmin(k)=temper(1,1,k)
        tmpmax(k)=tmpmin(k)
        tmpav(k)=0.0
        watmin(k)=ch2o(1,1,k)
        watmax(k)=watmin(k)
        watav(k)=0.0
        khmin(k)=kh(1,1,k)
        khmax(k)=khmin(k)
        khavg(k)=0.0
        kvmax(k)=kv(1,1,k)
        kvmin(k)=kvmax(k)
        kvavg(k)=0.0
        htmin(k)=h(1,1,k)
        htmax(k)=htmin(k)
        htavg(k)=0.0
        cldmax(k)=cloud(1,1,k)
        cldmin(k)=cldmax(k)
        cldavg(k)=0.0
   45 continue
      do 44 l=1,mxspec
        vdpmin(l)=depvel(1,1,l)
        vdpmax(l)=vdpmin(l)
        vdpavg(l)=0.0
   44 continue
      wsmin=wsurf(1,1)
      wsmax=wsmin
      wsavg=0.0
      rnmax=rain(1,1)
      rnmin=rain(1,1)
      rnsum=0.0
      noxm1=nox-1
      noym1=noy-1
      navcll = 0
      navkcl = 0
      do 51 j=1,noy
        if (istr(j) .gt. nox ) goto 51
        is=istr(j)
        ie=iend(j)
c        do 50 i=1,nox
        do 50 i=is,ie
          if ( j .lt. jstr(i) ) goto 50
          if ( j .gt. jend(i) ) goto 50
          if((i.le.noxm1) .and. (j.le.noym1))then
            navkcl = navkcl + 1
            do 47 k=1,nlayer
              khmin(k)=amin1(khmin(k),kh(i,j,k))
              khmax(k)=amax1(khmax(k),kh(i,j,k))
              khavg(k)=khavg(k)+kh(i,j,k)
   47       continue
          endif
          navcll = navcll + 1
          do 48 k=1,nlayer
            umin(k)=amin1(umin(k),u(i,j,k))
            umax(k)=amax1(umax(k),u(i,j,k))
            uavg(k)=uavg(k)+u(i,j,k)
            aumin(k)=amin1(aumin(k),abs(u(i,j,k)))
            aumax(k)=amax1(aumax(k),abs(u(i,j,k)))
            auavg(k)=auavg(k)+abs(u(i,j,k))
            vmin(k)=amin1(vmin(k),v(i,j,k))
            vmax(k)=amax1(vmax(k),v(i,j,k))
            vavg(k)=vavg(k)+v(i,j,k)
            avmin(k)=amin1(avmin(k),abs(v(i,j,k)))
            avmax(k)=amax1(avmax(k),abs(v(i,j,k)))
            avavg(k)=avavg(k)+abs(v(i,j,k))
            wspeed=sqrt(u(i,j,k)*u(i,j,k)+v(i,j,k)*v(i,j,k))
            awsmin(k)=amin1(awsmin(k),wspeed)
            awsmax(k)=amax1(awsmax(k),wspeed)
            awsavg(k)=awsavg(k)+wspeed
            aumax(k)=amax1(aumax(k),wspeed)
            auavg(k)=auavg(k)+wspeed
            kvmin(k)=amin1(kvmin(k),kv(i,j,k))
            kvmax(k)=amax1(kvmax(k),kv(i,j,k))
            kvavg(k)=kvavg(k)+kv(i,j,k)
            htmin(k)=amin1(htmin(k),h(i,j,k))
            htmax(k)=amax1(htmax(k),h(i,j,k))
            htavg(k)=htavg(k)+h(i,j,k)
            tmpmin(k)=amin1(tmpmin(k),temper(i,j,k))
            tmpmax(k)=amax1(tmpmax(k),temper(i,j,k))
            tmpav(k)=tmpav(k)+temper(i,j,k)
            watmin(k)=amin1(watmin(k),ch2o(i,j,k))
            watmax(k)=amax1(watmax(k),ch2o(i,j,k))
            watav(k)=watav(k)+ch2o(i,j,k)
            cldmax(k)=amax1(cldmax(k),cloud(i,j,k))
            cldmin(k)=amin1(cldmin(k),cloud(i,j,k))
            cldavg(k)=cldavg(k)+cloud(i,j,k)
   48     continue
          do 49 l=1,mxspec
            vdpmin(l)=amin1(vdpmin(l),depvel(i,j,l))
            vdpmax(l)=amax1(vdpmax(l),depvel(i,j,l))
            vdpavg(l)=vdpavg(l)+depvel(i,j,l)
   49     continue
          wsmin=amin1(wsmin,wsurf(i,j))
          wsmax=amax1(wsmax,wsurf(i,j))
          wsavg=wsavg+wsurf(i,j)
          rnmax=amax1(rnmax,rain(i,j))
          rnmin=amin1(rnmin,rain(i,j))
          rnsum=rnsum+rain(i,j)
   50   continue
   51 continue
c
      noxy=nox*noy
      noxym1=noxm1*noym1
      do 52 k=1,nlayer
        uavg(k)=uavg(k)/navcll
        vavg(k)=vavg(k)/navcll
        auavg(k)=auavg(k)/navcll
        avavg(k)=avavg(k)/navcll
        awsavg(k)=awsavg(k)/navcll
        tmpav(k)=tmpav(k)/navcll
        watav(k)=watav(k)/navcll
        khavg(k)=khavg(k)/navkcl
        kvavg(k)=kvavg(k)/navcll
        htavg(k)=htavg(k)/navcll
        cldavg(k)=cldavg(k)/navcll
   52 continue
      do 521 l=1,mxspec
        vdpavg(l)=vdpavg(l)/navcll
  521 continue
      wsavg=wsavg/navcll
      rnav=rnsum/navcll
      do 54 k=1,nospec
        do 53 l=1,nlayer
          cnmin(k,l)=1.e20
          cnmax(k,l)=0.0
          cnsum(k,l)=0.0
          nbc(l) = 0
   53   continue
        do 57 l=1,nlayer
          do 55 i=1,nox
            if (bc(i,1,k,l) .ge. 0.) then
              cnmin(k,l)=amin1(cnmin(k,l),bc(i,1,k,l))
              cnmax(k,l)=amax1(cnmax(k,l),bc(i,1,k,l))
              cnsum(k,l)=cnsum(k,l)+bc(i,1,k,l)
              nbc(l) = nbc(l) + 1
            endif
            if (bc(i,2,k,l) .ge. 0.) then
              cnmin(k,l)=amin1(cnmin(k,l),bc(i,2,k,l))
              cnmax(k,l)=amax1(cnmax(k,l),bc(i,2,k,l))
              cnsum(k,l)=cnsum(k,l)+bc(i,2,k,l)
              nbc(l) = nbc(l) + 1
            endif
   55     continue
   57   continue
        do 58 l=1,nlayer
          do 56 i=1,noy
            if (bc(i,3,k,l) .ge. 0.) then
              cnmin(k,l)=amin1(cnmin(k,l),bc(i,3,k,l))
              cnmax(k,l)=amax1(cnmax(k,l),bc(i,3,k,l))
              cnsum(k,l)=cnsum(k,l)+bc(i,3,k,l)
              nbc(l) = nbc(l) + 1
            endif
            if (bc(i,4,k,l) .ge. 0.) then
              cnmin(k,l)=amin1(cnmin(k,l),bc(i,4,k,l))
              cnmax(k,l)=amax1(cnmax(k,l),bc(i,4,k,l))
              cnsum(k,l)=cnsum(k,l)+bc(i,4,k,l)
              nbc(l) = nbc(l) + 1
            endif
   56     continue
   58   continue
      do 54 l=1,nlayer
        cnsum(k,l)=cnsum(k,l)/nbc(l)
   54 continue
      write(8,5) time,idate
    5 format('1',5x,'At time ',f5.0,'   date ',i7,' updated input'
     &,' variables have',
     &    ' the following values',//,30x,'Minimum',30x,'Maximum',
     &    30x,'Average'//)
c
      do 70 l=1,nlayer
        write(8,7001) l,umin(l),umax(l),uavg(l)
        write(8,7002) l,vmin(l),vmax(l),vavg(l)
   70 continue
c
      do 71 l=1,nlayer
        write(8,7003) l,aumin(l),aumax(l),auavg(l)
        write(8,7004) l,avmin(l),avmax(l),avavg(l)
   71 continue
c
      do 72 l=1,nlayer
        write(8,7005) l,l,awsmin(l),awsmax(l),awsavg(l)
   72 continue
c
      write(8,7006) wsmin,wsmax,wsavg
c
      do 73 l=1,nlayer
        write(8,7008) l,htmin(l),htmax(l),htavg(l)
   73 continue
c 
      do 74 l=1,nlayer
        write(8,7009) l,khmin(l),khmax(l),khavg(l)
   74 continue
c
      do 774 l=1,nlayer
        write(8,7079) l,kvmin(l),kvmax(l),kvavg(l)
  774 continue
c
      if (lwet) write(8,7078) rnmin,rnmax,rnav
c
      do 75 l=1,nlayer
        write(8,7033) l,tmpmin(l),tmpmax(l),tmpav(l)
   75 continue
c
      do 76 l=1,nlayer
        write(8,7034) l,watmin(l),watmax(l),watav(l)
   76 continue
c
      do 761 l=1,nlayer
        write(8,7035)l,cldmin(l),cldmax(l),cldavg(l)
  761 continue
c
      do 60 k=1,nospec
        kk=k
        write(8,7021)(mspec(mm,kk),mm=1,10),vdpmin(k),vdpmax(k),
     &     vdpavg(k)
        do 77 l=1,nlayer
          write(8,7020) l,(mspec(mm,kk),mm=1,10),nbc(l),cnmin(k,l),
     &     cnmax(k,l),cnsum(k,l)
   77   continue
   60 continue
      do 80 i=1,nox
        do 79 j=1,noy
          do 78 k=1,nlayer
            ahprec(i,j,k)=1.0
   78     continue
   79   continue
   80 continue
 7001 format(1x,'u -layer ',i2,18x,e9.2,28x,e9.2,28x,e9.2)
 7002 format(1x,'v -layer ',i2,18x,e9.2,28x,e9.2,28x,e9.2)
 7003 format(1x,'abs(u -layer ',i2,')',13x,e9.2,28x,e9.2,28x,e9.2)
 7004 format(1x,'abs(v -layer ',i2,')',13x,e9.2,28x,e9.2,28x,e9.2)
 7005 format(1x,'sqr(u(',i2,')**2+v(',i2,')**2)',7x,e9.2,28x,e9.2
     &,      28x,e9.2)
 7006 format(1x,'wsurf',24x,e9.2,28x,e9.2,28x,e9.2)
 7008 format(1x,'height -layer ',i2,13x,e9.2,28x,e9.2,28x,e9.2)
 7077 format(1x,'region top',19x,e9.2,28x,e9.2,28x,e9.2)
 7078 format(1x,'rain fall ',19x,e9.2,28x,e9.2,28x,e9.2)
 7009 format(1x,'kh -layer ',i2,17x,e9.2,28x,e9.2,28x,e9.2)
 7079 format(1x,'kv -layer ',i2,17x,e9.2,28x,e9.2,28x,e9.2)
 7016 format(1x,'cloud cover (%)',14x,e9.2,28x,e9.2,28x,e9.2)
 7033 format(1x,'layer ',i2,' temp(k)',13x,e9.2,28x,e9.2,28x,e9.2)
 7034 format(1x,'layer ',i2,' h2o(ppm)',12x,e9.2,28x,e9.2,28x,e9.2)
 7035 format(1x,'layer ',i2,'cloud opacity',8x,e9.2,28x,e9.2,28x,e9.2)
 7020 format(1x,'layer ',i2,' bc ',10a1,' (',i3,' cells) ',e9.2,28x,
     &       e9.2,28x,e9.2)
 7021 format(1x,'depos. vel. ',10a1,13x,e9.2,28x,e9.2,28x,e9.2)
      return
c
 9001 write(8,8001) idystr,tstr,idaynf,tend
      write(*,8001) idystr,tstr,idaynf,tend
      write(ierrlg,8045) 270,idystr,tstr,idaynf,tend 
      errflg=.true.
      write(8,8001)
      go to 101
 9002 errflg=.true.
      write(8,8002) tstr
      write(*,8002) tstr
      write(ierrlg,8113) 228,tstr 
      go to 102
 9003 errflg=.true.
      write(8,8003) tend
      write(*,8003) tend
      write(ierrlg,8114) 229,tend
      go to 103
 9005 errflg=.true.
      write(8,8005) dtdata
      write(*,8005) dtdata 
      write(ierrlg,8115) 230,dtdata
      go to 105
 9007 errflg=.true.
      write(8,8007) dtprnt
      write(*,8007) dtprnt
      write(ierrlg,8117) 231,dtprnt
      go to 107
 9009 errflg=.true.
      write(8,8009) deltax
      write(*,8009) deltax
      write(ierrlg,8119) 232,deltax
      go to 109
 9011 errflg=.true.
      write(8,8011) deltay
      write(*,8011) deltay
      write(ierrlg,8111) 235, deltay
      go to 111
 9013 errflg=.true.
      write(8,8013) nox
      write(*,8013) nox
      write(ierrlg,8123) 233, nox
      go to 113
 9015 errflg=.true.
      write(8,8015) noy
      write(*,8015) noy
      write(ierrlg,8125) 234, noy 
      go to 115
 9016 errflg=.true.
      write(8,8016) nospec
      write(*,8016) nospec
      write(ierrlg,8016) 283, nospec
      go to 116
 9019 errflg=.true.
      write(8,8019) wlong
      write(*,8019) wlong
      write(*,8129) 236,wlong
      go to 119
 9020 errflg=.true.
      write(8,8020) elong
      write(*,8020) elong
      write(ierrlg,8120) 237,elong 
      go to 120
 9021 errflg=.true.
      write(8,8021) nlat
      write(*,8021) nlat
      write(ierrlg,8121) 238,nlat
      go to 121
 9022 errflg=.true.
      write(8,8022) slat
      write(*,8022) slat
      write(ierrlg,8122) 239,slat
      go to 122
 9023 errflg=.true.
      write(8,8023) tz
      write(*,8023) tz
      write(ierrlg,8133) 240,tz
      go to 123
 9025 errflg=.true.
      write(8,8025) pkrchm
      write(*,8025) pkrchm
      write(ierrlg,8135) 242,pkrchm
      go to 125
 9026 write(8,8026) pkrchm,crchem
      write(*,8026) pkrchm,crchem
      write(ierrlg,8136) 241,pkrchm,crchem
      go to 126
 9027 errflg=.true.
      write(8,8027) crchem
      write(*,8027) crchem 
      write(ierrlg,8137) 268,crchem
      go to 127
 9031 errflg=.true.
      write(8,8031) nopts
      write(*,8031) nopts   
      write(ierrlg,8131) 269,crchem
      go to 131
 8001 format(5x,'starting date=',i10,10x,'starting time=',f10.2,
     &   /,5x,'Ending date=',i10,10x,'Ending time=',f10.2,
     &   //'Ending time precedes starting time. Please correct',
     &   ' input data')
 8045 format(i3,6x,'starting date=',i10,10x,'starting time=',f10.2,
     &   /,5x,'Ending date=',i10,10x,'Ending time=',f10.2,
     &   //'Ending time precedes starting time. Please correct',
     &   ' input data')
 8002 format(5x,'tstr=',e10.4,20x,'This is not a permissible value')
 8113 format(i3,6x,'tstr=',e10.4,20x,'This is not a permissible value') 
 8003 format(5x,'tend=',e10.4,20x,'This is not a permissible value')
 8114 format(i3,6x,'tend=',e10.4,20x,'This is not a permissible value')
 8005 format(5x,'dtdata=',e10.4,20x,'This is not a permissible value')
 8115 format(i3,6x,'dtdata=',e10.4,20x,'This is not a permissible',
     &    ' value')
 8007 format(5x,'dtprnt=',e10.4,20x,'This is not a permissible value')
 8117 format(i3,6x,'dtprnt=',e10.4,20x,'This is not a permissible ',
     &    'value')
 8009 format(5x,'deltax=',e10.4,20x,'This is not a permissible value')
 8119 format(i3,6x,'deltax=',e10.4,20x,'This is not a permissible ',
     &    'value')
 8011 format(5x,'deltay=',e10.4,20x,'This is not a permissible value')
 8111 format(i4,6x,'deltay=',e10.4,20x,'This is not a permissible ',
     &    'value')
 8013 format(5x,'nox=',i10,20x,'A domain of 5 x 5 grid points is a ',
     &       'minimum requirement.')
 8123 format(i3,6x,'nox=',i10,20x,'A domain of 5 x 5 grid points is a ',
     &       'minimum requirement.')
 8015 format(5x,'noy=',i10,20x,'A domain of 5 x 5 grid points is a ',
     &       'minimum requirement.')
 8125 format(i3,6x,'noy=',i10,20x,'A domain of 5 x 5 grid points is a',
     &       'minimum requirement.')
 8016 format(5x,'nospec=',i10,20x,'This is not a permissible value')
 8019 format(5x,'wlong=',e10.4,20x,'This is not a permissible value')
 8129 format(i3,6x,'wlong=',e10.4,20x,'This is not a permissible ',
     &       'value')
 8020 format(5x,'elong=',e10.4,20x,'This is not a permissible value')
 8120 format(i3,6x,'elong=',e10.4,20x,'This is not a permissible ',
     &       'value')
 8021 format(5x,'nlat=',e10.4,20x,'This is not a permissible value')
 8121 format(i3,6x,'nlat=',e10.4,20x,'This is not a permissible value')
 8022 format(5x,'slat=',e10.4,20x,'This is not a permissible value')
 8122 format(i3,6x,'slat=',e10.4,20x,'This is not a permissible value')
 8023 format(5x,'tz=',e10.4,20x,'This is not a permissible value')
 8133 format(i3,6x,'tz=',e10.4,20x,'This is not a permissible value')
 8025 format(5x,'pkrchm=',e10.4,20x,'This is not a permissible value')
 8135 format(i3,6x,'pkrchm=',e10.4,20x,'This is not a permissible ',
     &     'value')
 8026 format(5x,'pkrchm=',e10.4,10x,'crchem=',e10.4,/,
     & 'pkrchm must be greater than crchem')
 8136 format(i3,6x,'pkrchm=',e10.4,10x,'crchem=',e10.4,/,
     & 'pkrchm must be greater than crchem')
 8027 format(5x,'crchem=',e10.4,20x,'This is not a permissible value')
 8137 format(i3,6x,'crchem=',e10.4,20x,'This is not a permissible ',
     & 'value')
 8029 format(5x,'tempa=',e10.4,20x,'This is not a permissible value')
 8031 format(5x,'nopts=',i10,20x,'This is not a permissible value')
 8131 format(i3,6x,'nopts=',i10,20x,'This is not a permissible value')
 8033 format(5x,'At source ',i4,'so2 emis =',e10.4,
     & 'This is not a permissible value')
 8035 format(5x,'At source ',i4,'so4 emis =',e10.4,
     & 'This is not a permissible value')
 8036 format(5x,'At source ',i4,'so4/so2 emis =',e10.4,
     & 'This is not a permissible value')
 8037 format(5x,'At source ',i4,'xpts=',e10.4,
     & 'This is outside the modeling region.',/
     & ' Emissions from this source will not be included in the run.')
 8138 format(i3,6x,'At source ',i4,'xpts=',e10.4,
     & 'This is outside the modeling region.',/
     & ' Emissions from this source will not be included in the run.')
 8038 format(5x,'at source ',i4,'ypts=',e10.4,
     & 'This is outside the modeling region.',/
     & ' Emissions from this source will not be included in the run.')
 8139 format(i3,6x,'at source ',i4,'ypts=',e10.4,
     & 'This is outside the modeling region.',/
     & ' Emissions from this source will not be included in the run.')
 8039 format(5x,'at source ',i4,'tsum=',e10.4,
     & 'This is not a permissible value')
 8240 format(i3,6x,'at source ',i4,'tsum=',e10.4,
     & 'This is not a permissible value')
 8040 format(5x,'at source ',i4,'stkht=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default minimum')
 8340 format(i3,6x,'at source ',i4,'stkht=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default minimum')
 8140 format(5x,'at source ',i4,'stkht=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default maximum')
 8440 format(i3,6x,'at source ',i4,'stkht=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default maximum')
 8041 format(5x,'at source ',i4,'stkd=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default minimum')
 8241 format(i3,6x,'at source ',i4,'stkd=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default minimum')
 8141 format(5x,'at source ',i4,'stkd=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default maximum')
 8242 format(i3,6x,'at source ',i4,'stkd=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default maximum')
 8042 format(5x,'at source ',i4,'temps=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default minimum')
 8243 format(i3,6x,'at source ',i4,'temps=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default minimum')
 8142 format(5x,'at source ',i4,'temps=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default maximum')
 8244 format(i3,6x,'at source ',i4,'temps=',e10.4, 
     & 'This is not a permissible value',/,
     & 'Reset to default maximum')
 8043 format(5x,'At source ',i4,'vexit=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default maximum')
 8245 format(i3,6x,'At source ',i4,'vexit=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default maximum')
 8143 format(5x,'At source ',i4,'vexit=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default minimum')
 8246 format(i3,6x,'At source ',i4,'vexit=',e10.4,
     & 'This is not a permissible value',/,
     & 'Reset to default minimum')
      end
