      subroutine dtsize(time,ndate,deltat)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: dtsize.f,v $
c  Revision 1.3  1999/12/21  19:27:56  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.2  1994/02/10  20:54:55  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c**********************************************************************
c
c  routine determines  time step size for coarse grid
c
c
c-----this routine is called by:
c          aaamain
c
c*****  introduces a number of comdeck inserts
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
      include 'comchem.cmd'
      include 'comd3.cmd'
c
c
c-----initialize some contants
      dt1=1.e20
      diff=0.0
c
      do 100 j=1,noy
c
c     check if out of modeling region
c
        if (istr(j).gt.nox) go to 100
c
        is=istr(j)
        ie=iend(j)
c
c...    find the minimum horizontal grid resolution to calculate
c...    time step later
c
        if(deltax(j) .gt. deltay)then
          horzds=deltay
        else
          horzds=deltax(j)
        endif
c
c-----  calculate by each column element
c
        do 90 i=is,ie
          if (j.lt.jstr(i)) go to 90
          if (j.gt.jend(i)) go to 90
          do 80 k=1,nlayer
            diff=amax1(diff,kh(i,j,k)/horzds**2)
   80     continue
   90   continue
c
  100 continue
c
c-----  choose the greatest mixing layer windspeed for the
c-----  prepare for time step selection
c
      do 120 k=1,nlayer
        if (aumax(k).gt.0.0)then
          dt1=amin1(dt1,0.48*horzds/aumax(k))
        endif
        if (avmax(k).gt.0.0)then
          dt1=amin1(dt1,0.48*horzds/avmax(k))
        endif
  120 continue
c
      if(diff.gt.0.)then
        dt2=0.15/diff
      else
        dt2=1.e20
      endif
c
c     determine maximum deltat for this time step
c
      deltat=amin1(dt1,dt2,dtstep)
c
c     make time step an even multiple of print or update time
c
      dtval=amin1(dtdata*0.6,dtprnt*0.6)
      nstep=int(dtval/deltat)+1
      deltat=dtval/float(nstep)
      write(*,3100) time,ndate,deltat,dtval,dt1,dt2
3100  format(' TIME STEP SELECTION AT ',f10.1,i10,': ',4f10.2)
      return
      end
