      subroutine emcors(time,ndate,deltat,idebug)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: emcors.f,v $
c  Revision 1.7  2002/06/26  20:44:13  tcm
c  Eliminated some dead code.
c
c  Revision 1.6  1999/12/21  19:27:57  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.5  1999/07/07  16:21:37  tcm
c  Added tracking of changes due to emissions for pa/iir.
c
c  Revision 1.4  1998/11/09  17:39:16  ara
c  Included file errlog.cmd to introduce ierrlg variable
c  Directed error message to log file (ierrlg)
c
c  Revision 1.3  1996/06/14  22:57:48  tcm
c  see comments below
c
c  Revision 1.2  1994/02/10  20:55:02  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c     -redefined checks of source grid location with respect to
c      boundary cells (e.g., cheking i.le.istr instead of i.lt.istr)
c      95/08/21   gem
c
c
c     this subroutine injects emissions into the coarse grid 
c
c     ---modified to correct injection of point source emissions
c        (use delta h instead of h) (tcm,3/25/91)
c  
c     ---modified to treat all concentrations as micromoles/m3
c        (tcm, 5/1/91)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'comd3.cmd'
      include 'deffin.cmd'
      include 'balanc.cmd'
      include 'stack.cmd'
      include 'errlog.cmd'
c
      dimension  iatrac(mxxspc), iptrac(mxxspc)
      dimension  ilvtrc(mxz)
c
      logical ldum
      data ldum/.false./
c
c
c  bit eleven of idebug on (i.e., the 1024's location) will turn
c  on debug writes in emcors.
c
      idiag = and(idebug,1024)
c
      if (idiag .ne. 0) then
        write(*,4000) time,ndate,deltat
      endif
      do 1 n=1,mxxspc
        iatrac(n) = 0
        iptrac(n) = 0
    1 continue
      do 2 k=1,mxz
        ilvtrc(k) = 0
    2 continue
c
      dt=deltat
c
czswa------------------------------------------------------
c
c  let's do the point source emissions for IRR purposes
c
      call get_difc(2,1,1)
c
czswz------------------------------------------------------
c
c *** release area sources and those point sources not
c *** specified for sub-grid scale puffs into grid model
c
      cfact1=1./(1000.*deltay)*deltat
      do 10 l=1,nopts
        if (pflag(l)) goto 10
        call convrt(plong(l),plat(l),i,j)
        if (i.le.istr(j)) go to 10
        if (i.ge.iend(j)) go to 10
        if (j.le.jstr(i)) go to 10
        if (j.ge.jend(i)) go to 10
        if (idiag .ne. 0) then
          write(*,*) 'nopts, l, i, j: ', nopts,l,i,j
        endif
c
c  emissions for areas treated with fine grids will be added 
c  in emfine
c
c*       do 3 ifine=1,numfin
c*         if (i .ge. ixfb(ifine) .and. i .le. ixfe(ifine)
c*   &         .and. j .ge. jyfb(ifine) .and. j .le. jyfe(ifine))
c*   &                                                   go to 10
c*  3    continue
c
c
        do 5 k=1,nlayer
          if (heff(l).gt.1000.0*h(i,j,k))go to 5
c-------------------------------------------
c     put point source emissions in layer k
c-------------------------------------------
          if (k .eq. 1) then
            hdel = h(i,j,k)
          else
            hdel = h(i,j,k) - h(i,j,k-1)
          endif
          ilvtrc(k) = ilvtrc(k) + 1
          do 4 lisp=1,nemit
            isp=kemit(lisp)
            if (isp .le. 0) go to 4
            if (isp .gt. nospec) stop117
            iptrac(isp) = iptrac(isp) + 1
            if (idiag .ne. 0) then
              write(*,*) 'isp, k:  ', isp, k
              write(*,*) 'deltat, temper:', deltat,
     &          temper(i,j,k)
              write(*,*) ' ptemis, press, deltay, deltax, hdel:',
     &          ptemis(lisp,l), press(i,j,k),deltay,deltax(j),
     &          hdel
              write(*,*) 'conc: ',conc(i,j,isp,k)
            endif
            conc(i,j,isp,k)=conc(i,j,isp,k)+ptemis(lisp,l)
     &               * cfact1 / (hdel*deltax(j))
            ptflow(isp) = ptflow(isp) + ptemis(lisp,l)*deltat
            if (idiag .ne. 0) then
              write(*,*) 'after, conc: ',conc(i,j,isp,k)
            endif
    4     continue
          go to 10
    5   continue
   10 continue
c
czswa------------------------------------------------------
c
c  let's finish the point source emissions for IRR purposes
c
      call get_difc(2,2,1)
c
c  then do the low level area emissions
c
      call get_difc(3,1,1)
c
czswz------------------------------------------------------
c
c     add in area emissions
c
      if (idiag .ne. 0) then
        write(*,*) ' about to do area sources, larea = ',larea
      endif
      if (.not.larea) go to 30
      if (idiag .ne. 0) then
        write(*,*) ' looping over grid, nox, noy = ',nox, noy
      endif
      do 26 j=1,noy
        do 25 i=1,nox
          if (i.le.istr(j)) go to 25
          if (i.ge.iend(j)) go to 25
          if (j.le.jstr(i)) go to 25
          if (j.ge.jend(i)) go to 25
c
c  emissions for areas treated with fine grids will be added there
c
c*          do 15 ifine=1,numfin
c*            if (i .ge. ixfb(ifine) .and. i .le. ixfe(ifine)
c*   &          .and. j .ge. jyfb(ifine) .and. j .le. jyfe(ifine))
c*   &                                                    go to 20
c* 15       continue
c
          do 20 lisp=1,naemit
            isp=kaemit(lisp)
            if (isp .le. 0) go to 20
            if (tarea(isp,1).le.0.0) go to 20
            iatrac(isp) = iatrac(isp) + 1
            if (idiag .ne. 0) then
              if (i .gt. 9 .and. i .lt. 13) then
                if (j .gt. 9 .and. j .lt. 13) then
                  write(*,*) 'area source: isp, lisp:  ', isp, lisp
                  write(*,*) 'cell:  ',i,j
                  write(*,*) 'deltat, temper:', deltat,
     &                 temper(i,j,1)
                  write(*,*) ' qarea, press, deltay, deltax, h:',
     &                 qarea(i,j,lisp), press(i,j,1),deltay,deltax(j),
     &                 h(i,j,1)
                  write(*,*) 'conc: ',conc(i,j,isp,1)
                endif
              endif
            endif
            conc(i,j,isp,1)=conc(i,j,isp,1)+qarea(i,j,lisp)
     &                  *cfact1/(h(i,j,1)*deltax(j))
            eflow(isp) = eflow(isp) + qarea(i,j,lisp)*deltat
            if (idiag .ne. 0) then
              if (i .gt. 9 .and. i .lt. 13) then
                if (j .gt. 9 .and. j .lt. 13) then
                  write(*,*) 'after, conc: ',conc(i,j,isp,1)
                endif
              endif
            endif
   20     continue
   25   continue
   26 continue
c
czswa------------------------------------------------------
c
c  let's finish the area source emissions for IRR purposes
c
      call get_difc(3,2,1)
c
czswz------------------------------------------------------
c
   30 continue
c
      write(*,*) ' area sources: ',(iatrac(n),n=1,nospec)
      write(*,*) ' points: ',(iptrac(n),n=1,nospec)
      write(*,*) ' levels: ',(ilvtrc(n),n=1,nlayer)
      if (idiag .ne. 0) then
        write(*,4100) nopts 
      endif
      return
c
 4000 format(' ENTER EMCORS ',f10.1,i10,f10.2)
 4100 format(' leave emcors',i10)
c
      end
