      subroutine emfine(nxf,nyf,nzf,nfspec,delx,dely,
     &      qfarea,htf,presf,temprf,cncf,ifine,idebug)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: emfine.f,v $
c  Revision 1.6  1999/12/21  19:27:58  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.5  1999/07/07  16:22:11  tcm
c  Added tracking of changes due to emissions for pa/iir.
c
c  Revision 1.4  1996/06/14  22:58:10  tcm
c  see comments below
c
c  Revision 1.3  1995/04/26  00:38:00  tcm
c  	added code to correctly locate point sources in fine grid when lat/lon
c  	coordinates are used.
c
c  Revision 1.2  94/02/10  20:55:07  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c     -redefined checks of source grid location with respect to
c      boundary cells (e.g., cheking i.le.istr instead of i.lt.istr)
c      95/08/21   gem
c
c
c     
c  (derived from emcors(time,ndate,deltat) )
c
c     this subroutine injects emissions into a fine grid 
c
c   ---modified to correct injection of point source emissions
c      (use delta h instead of h) (tcm,3/25/91)
c
c   ---modified to treat all concentrations as micromoles/m3
c      (tcm, 5/1/91)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'comd3.cmd'
      include 'deffin.cmd'
      include 'efcon.cmd'
      include 'balanc.cmd'
      include 'stack.cmd'
      include 'latlon.cmd'
c
      dimension htf(nxf,nyf,nzf), cncf(nxf,nyf,nfspec,nzf),
     &          qfarea(nxf,nyf,nfspec), presf(nxf,nyf,nzf),
     &          temprf(nxf,nyf,nzf)
c
      dimension delx(nyf)
c
czswa--------------------------------------------------------------------
c  add the emissions into pemis and aemis
c
      include 'irmb.cmd'
c
czswz--------------------------------------------------------------------
c
      logical ldum
      data ldum/.false./
c
c
c  bit seven of idebug on (i.e., the sixty-fours location) will turn
c  on debug writes in emfine.
c
      idiag = and(idebug,64)
c
      dt=deltf(ifine)
      if (idiag .ne. 0) then
        write(*,*) 'entering emfine dt = ',dt
        write(*,*) 'ifine = ',ifine
      endif
c
c
c *** release area sources and those point sources not
c *** specified for sub-grid scale puffs into grid model
c
      cfact1=1./(1000.*dely)*deltf(ifine)
      do 10 l=1,nopts
        if (pflag(l)) goto 10
        call convrt(plong(l),plat(l),i,j)
        if (i.le.istr(j)) go to 10
        if (i.ge.iend(j)) go to 10
        if (j.le.jstr(i)) go to 10
        if (j.ge.jend(i)) go to 10
        if (lcart) then
          ixf = int((plong(l) - ixfb(ifine) + 1)*nhf(ifine) + 2)
          jyf = int((plat(l) - jyfb(ifine) + 1)*nhf(ifine) + 2)
        else
          xi = (plong(l)-wlong)/dlong
          yj = (plat(l)-slat)/dlat
          ixf = int((xi - ixfb(ifine) + 1)*nhf(ifine) + 2)
          jyf = int((yj - jyfb(ifine) + 1)*nhf(ifine) + 2)
        endif
        if (idiag .ne. 0) then
          write(*,*) 'nopts, l, i, j, ixf, jyf: ', nopts,
     &              l,i,j,ixf,jyf
          write(*,*) 'plong, plat:', plong(l), plat(l)
          write(*,*) 'ixfb, jyfb, nhf:',
     &               ixfb(ifine), jyfb(ifine), nhf(ifine)
        endif
        if (ixf .le. 1 .or. ixf .ge. nxf) go to 10
        if (jyf .le. 1 .or. jyf .ge. nyf) go to 10
c
c
        do 5 k=1,nzf
          if (heff(l).gt.1000.0*htf(ixf,jyf,k)) go to 5
c-------------------------------------------
c     put point source emissions in layer k
c-------------------------------------------
          if (k .eq. 1) then
            hdel = htf(ixf,jyf,k)
          else
            hdel = htf(ixf,jyf,k) - htf(ixf,jyf,k-1)
          endif
          do 4 lisp=1,nemit
            isp=kemit(lisp)
            if (isp .le. 0) go to 4
            if (isp .gt. nospec) stop118
            if (idiag .ne. 0) then
              write(*,*) 'isp, k:  ', isp, k
              write(*,*) 'deltf, temprf:', deltf(ifine),
     &          temprf(ixf,jyf,k)
              write(*,*) ' ptemis, presf, dely, delx, hdel:',
     &          ptemis(lisp,l), presf(ixf,jyf,k),dely,delx(jyf),
     &          hdel
              write(*,*) 'cncf: ',cncf(ixf,jyf,isp,k)
            endif
c
czswa-------------------------------------------------------------------
c  this line is rewritten to add irpam
c
            aapt = ptemis(lisp,l) * cfact1 / (hdel*delx(jyf))
            cncf(ixf,jyf,isp,k)=cncf(ixf,jyf,isp,k)+aapt
            iflgf = iflagf(ixf,jyf,ifine)
            if (iflgf .gt. 0) then
               pemisf(iflgf,isp,k) = pemisf(iflgf,isp,k) + aapt
            endif
c
czswz-------------------------------------------------------------------
c
            fptflo(isp,ifine) = fptflo(isp,ifine) 
     &                          + ptemis(lisp,l)*deltf(ifine)
            if (idiag .ne. 0) then
              write(*,*) 'after, cncf: ',cncf(ixf,jyf,isp,k)
            endif
    4     continue
          go to 10
    5   continue
   10 continue
c
c     add in area emissions
c
      if (idiag .ne. 0) then
        write(*,*) ' about to do area sources, larea = ',larea
      endif
c
      if (larea) then
        if (idiag .ne. 0) then
          write(*,*) ' looping over grid, nxf, nyf = ',nxf, nyf
        endif
        do 30 j=2,nyf-1
          do 25 i=2,nxf-1
c
            do 20 lisp=1,nfemit(ifine)
              isp=kfemit(lisp,ifine)
              if (isp .le. 0) go to 20
              if (tfarea(isp,ifine).le.0.0) go to 20
              if (idiag .ne. 0) then
                if (i .gt. 9 .and. i .lt. 13) then
                  if (j .gt. 9 .and. j .lt. 13) then
                    write(*,*) 'area source :  isp, lisp:  ', isp, lisp
                    write(*,*) 'cell:  ',i,j
                    write(*,*) 'deltf, temprf:', deltf(ifine),
     &                  temprf(i,j,1)
                    write(*,*) ' qfarea, presf, dely, delx, htf:',
     &                  qfarea(i,j,lisp), presf(i,j,1),dely,delx(j),
     &                  htf(i,j,1)
                    write(*,*) 'cncf: ',cncf(i,j,isp,1)
                  endif
                endif
              endif
c
czswa-------------------------------------------------------------------
c  again, this line is rewritten to add irpam
              aaem = qfarea(i,j,lisp)*cfact1/(htf(i,j,1)*delx(j))
              cncf(i,j,isp,1)=cncf(i,j,isp,1)+aaem
              iflgf = iflagf(i,j,ifine)
              if (iflgf .gt. 0) then
                 aemisf(iflgf,isp,1) = aemisf(iflgf,isp,1) + aaem
              endif
c
czswz-------------------------------------------------------------------
              feflo(isp,ifine) = feflo(isp,ifine) 
     &                        + qfarea(i,j,lisp)*deltf(ifine)
c
              if (idiag .ne. 0) then
                if (i .gt. 9 .and. i .lt. 13) then
                  if (j .gt. 9 .and. j .lt. 13) then
                    write(*,*) 'after, cncf: ',cncf(i,j,isp,1)
                  endif
                endif
              endif
   20       continue
   25     continue
   30   continue
      endif
c
      return
      end
