      real function finteg(aend)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: finteg.f,v $
c  Revision 1.2  1994/02/10  20:56:00  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c   calculate fraction of mass in a two dimensional gaussian
c   hill of the form 
c
c     C = (1./2*pi*sigmay*sigmaz)
c                      * exp(-0.5*(y**2/sigmay**2 + z**2/sigmaz**2)
c
c   Integrate to the ellipse defined by
c
c     y**2/sigmay**2 + z**2/sigmaz**2 = aend**2
c
c   calculate fraction for a given aend.
c
c
      rt2 = sqrt(2.)
      nz = 100
      pi = 3.141592635
      rtpi = sqrt(pi)
c
c
      delz = (aend/rt2)/float(nz)
      xi2 = 0.
      do 50 n=1,nz
        znow = (float(n) - .5)*delz
        fnow = exp(-znow**2) * erf(sqrt(.5*aend**2 - znow**2)) * delz
        xi2 = xi2 + fnow
   50 continue
      xi2 = 4.*xi2/(2.*rtpi)
c
      finteg = xi2
      return
c
      end
