      subroutine fvrtwd(nxf,nyf,nzf,uf,vf,hnewf,holdf,htf,delfx,
     &                  delfy,etaf,tphioaf,dilutf,depthf,
     &                  deltf,doldf)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: fvrtwd.f,v $
c  Revision 1.3  1999/12/21  19:28:02  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.2  1994/02/10  20:56:24  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c   calculate effective vertical winds due to divergence and
c   changing layer depths (tcm,10/4/90)
c
c     -- changed to deal with optional staggered u/v grids
c        (tcm, 7/15/91)
c
      include 'parfin.cmd'
      include 'comd3.cmd'
      include 'advec.cmd'
c
      dimension uf(nxf,nyf,nzf), vf(nxf,nyf,nzf),
     &          hnewf(nxf,nyf,nzf), htf(nxf,nyf,nzf),
     &          holdf(nxf,nyf,nzf),
     &          etaf(nxf,nyf,nzf), delfx(nyf),dilutf(nxf,nyf,nzf),
     &          depthf(nxf,nyf,nzf), tphioaf(nyf),doldf(nxf,nyf,nzf)  
c
      dimension div(mxfz), dddt(mxfz), d(mxfz), w(mxfz),
     &          dhdt(mxfz),phpt(mxfz)
c
      nxfm1=nxf-1
      nyfm1=nyf-1
      nxfp1=nxf+1
      nyfp1=nyf+1
c
c     loop through grid
c
      do 410 j=1,nyf
        do 400 i=1,nxf
c
c     establish indices
c
          ip1=i+1
          jp1=j+1
          im1=i-1
          jm1=j-1
          i2=i
          j2=j
          if (i .gt. 1) then
            ii1 = i - 1
          else
            ii1 = i
          endif
          if (j .gt. 1) then
            jj1 = j - 1
          else
            jj1 = j
          endif
c
c     loop through layers
c
          do 200 k=1,nzf
            d(k)=htf(i,j,k)
            if (k.gt.1) d(k)=htf(i,j,k)-htf(i,j,k-1)
c
c     upstream differencing
c
            i1=im1
            j1=jm1
            if (lstagr) then
              uchk = .5*(uf(i,j,k) + uf(ii1,j,k))
              vchk = .5*(vf(i,j,k) + vf(i,jj1,k))
            else
              uchk = uf(i,j,k)
              vchk = vf(i,j,k)
            endif
            if (uchk.lt.0.0) i1=ip1
            if (vchk.lt.0.0) j1=jp1
c
c     inflow boundaries, set indices equal
c
            if (i1.eq.0 .or. i1.eq.nxfp1) i1=i2
            if (j1.eq.0 .or. j1.eq.nyfp1) j1=j2
c
c     total derivative of (k) - upstream spatial differencing
c     total derivative of depthf(k) - upstream differencing
c     divergence, centered differnecing, except at boundary
c
            phpt(k)=(hnewf(i,j,k)-holdf(i,j,k))/datadt
            vphpxy =abs(uchk)*(htf(i2,j,k)-htf(i1,j,k))/delfx(j)
     &              +abs(vchk)*(htf(i,j2,k)-htf(i,j1,k))/delfy
            dhdt(k)=phpt(k)+vphpxy
            dddt(k)=dhdt(k)
            if (k.gt.1) dddt(k)=dhdt(k)-dhdt(k-1)
            doldf(i,j,k)=htf(i,j,k)-phpt(k)*deltf
            if (k.gt.1) doldf(i,j,k)=(htf(i,j,k)-phpt(k)*deltf)-
     &                               (htf(i,j,k-1)-phpt(k-1)*deltf)
c
            if (lstagr) then
c
              if (j.eq.1) then
                dy=0.
              else
                dy=(vf(i,j,k)-vf(i,jm1,k))/delfy
              endif
c
              if (i.eq.1) then
                dx=0.
              else
                dx=(uf(i,j,k)-uf(im1,j,k))/delfx(j)
              endif
c
            else
c
              if (j.le.1) then
                dy=(vf(i,2,k)-vf(i,1,k))/delfy
              elseif (j.ge.nyf) then
                dy=(vf(i,nyf,k)-vf(i,nyfm1,k))/delfy
              else
                dy=(vf(i,jp1,k)-vf(i,jm1,k))/(2.0*delfy)
              endif
c
              if (i.le.1) then
                dx=(uf(2,j,k)-uf(1,j,k))/delfx(j)
              elseif (i.ge.nxf) then
                dx=(uf(nxf,j,k)-uf(nxfm1,j,k))/delfx(j)
              else
                dx=(uf(ip1,j,k)-uf(im1,j,k))/(2.0*delfx(j))
              endif
c
            endif
c
            div(k)=dx+dy
  200     continue
c
c     first calculate w(k) from div(k)
c
          if (lstagr) then
            vchk = .5*(vf(i,j,1)+vf(i,jj1,1))
          else
            vchk = vf(i,j,1)
          endif
          w(1)=-div(1)*d(1)+vchk*tphioaf(j)*d(1)
          do 320 k=2,nzf
            if (lstagr) then
              vchk = .5*(vf(i,j,k)+vf(i,jj1,k))
            else
              vchk = vf(i,j,k)
            endif
            w(k)=w(k-1)-div(k)*d(k)+vchk*tphioaf(j)*d(k)
  320     continue
c
c     entrainment and dilution variables for cell (i,j)
c
          do 330 k=1,nzf
            etaf(i,j,k)=(dhdt(k)-w(k))
            dilutf(i,j,k)=dddt(k)
            depthf(i,j,k)=d(k)
  330     continue
c
  400   continue
  410 continue
c
      return
      end
