      subroutine getbc(time,indate,iunit,ieof)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: getbc.f,v $
c  Revision 1.7  1998/11/20  22:12:51  tcm
c  Fixed comment line on line 65
c
c  Revision 1.6  1998/11/16  18:41:07  ara
c  Made modifications to format of error message
c
c  Revision 1.5  1998/11/09  23:44:54  ara
c  Modified reference for error message to log file
c  Separated in lines to avoid problem with unknown format
c  left to review again
c
c  Revision 1.4  1998/11/09  23:19:53  ara
c  Included file errlog.cmd to introduce ierrlg variable
c  Directed error to diag file and to log file (ierrlg)
c
c  Revision 1.3  1998/11/04  01:39:13  tcm
c  Revised date treatment to handle calendar dates past 1999 and
c  to default Julian dates to 1951 to 2050.
c
c  Revision 1.2  94/02/10  20:56:28  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c  read a time interval off a UAM type boundary file and 
c  return parameters 
c  (tcm, 12/26/90)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
      include 'ibccon.cmd'
      include 'comchem.cmd'
      include 'errlog.cmd'
c
      dimension bcrd(mxz,mxxx) 
      character*4 mdum(10)
c
      ieof = 0
      ndate = indate
c
c  find correct time and read boundary concs
c  (if ndate is calendar date, convert file date; but if ndate
c   is julian date, convert file date to julian)
c
      if (ndate .gt. 99999) then
        call caltoj(ndate, juldat)
        ndate = juldat
      endif
      if (ibcdy1 .gt. 99999) then
        call caltoj(ibcdy1,id1)
        call caltoj(ibcdy2,id2)
      else
        id1 = ibcdy1
        id2 = ibcdy2
      endif
      ndays = intrvl(id1,ndate)
      tchk = bctim1*100. + 2400.*ndays
      ndays = intrvl(id2,ndate)
      tcend = bctim2*100. + 2400.*ndays
      if (time .ge. tchk-1. .and. time .le. tcend-1.) return
c
   10 read (iunit,end=900) ibcdy1, bctim1, ibcdy2, bctim2
      write(*,'(a,i8,f10.2,a,i8,f10.2,a,i4)')
     &     ' Read interval ',ibcdy1, bctim1, ' to ', ibcdy2, bctim2,
     &     ' on unit ', iunit
c
      do 200 l=1,nbcsp
        lint = kbcsp(l)
        do 190 nn=1,4
          ncel = noy
          if (nn .gt. 2) ncel = nox
          nbc = 5 - nn
          read(iunit) iseg,(mdum(ii),ii=1,10),nedgno,
     &                ((bcrd(ii,jj),ii=1,nlayer),jj=1,ncel)
          if (lint .eq. 0) go to 190
          do 150 j=1,ncel
            if (nbc .eq. 1) then
              ixx = j
              jyy = jend(j)
            else if (nbc .eq. 2) then
              ixx = j
              jyy = jstr(j)
            else if (nbc .eq. 3) then
              ixx = iend(j)
              jyy = j
            else if (nbc .eq. 4) then
              ixx = istr(j)
              jyy = j
            endif
            do 140 k=1,nlayer
              if (ixx .ge. 1 .and. ixx .le. nox .and.
     &            jyy .ge. 1 .and. jyy .le. noy .and.
     &            bcrd(k,j) .ge. 0.) then
                bcppm(j,nbc,lint,k) = bcrd(k,j)
              else
                bcppm(j,nbc,lint,k) = -9.
              endif
  140       continue
  150     continue
  190   continue
  200 continue
c
c  check time and if not correct, go back for another interval
c  (if ndate is calendar date, convert file date; but if ndate
c   is julian date, convert file date to julian)
c
      if (ibcdy1 .gt. 99999) then
        call caltoj(ibcdy1,id1)
        call caltoj(ibcdy2,id2)
      else
        id1 = ibcdy1
        id2 = ibcdy2
      endif
      ndays = intrvl(id1,ndate)
      tchk = bctim1*100. + 2400.*ndays
      ndays = intrvl(id2,ndate)
      tcend = bctim2*100. + 2400.*ndays
      if (time .ge. tcend) go to 10
      if (time .lt. tchk-1.) then
        write(*,*) ' Time error on BOUNDARY file',
     &             ' Current time: ',time, ndate,
     &             ' File time: ',bctim2,ibcdy2
        write(8,*) ' Time error on BOUNDARY file',
     &             ' Current time: ',time, ndate,
     &             ' File time: ',bctim2,ibcdy2
       write(ierrlg,*) 1062, '  Time error on BOUNDARY file',  
     &             ' Current time: ',time, ndate,     
     &             ' File time: ',bctim2, ibcdy2
        stop
      endif
c
      return
c
  900 ieof = 1
      return
c
      end
