      subroutine getic(time,indate,iunit,ieof)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: getic.f,v $
c  Revision 1.4  1998/11/17  22:33:41  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed warning message to screen and to log file (ierrlg)
c
c  Revision 1.3  1998/11/04  01:40:42  tcm
c  Revised date treatment to handle calendar dates past 1999 and
c  to default Julian dates to 1951 to 2050.
c
c  Revision 1.2  94/02/10  20:56:37  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c  read a time interval off a UAM type ic file and 
c  return parameters 
c  (tcm, 12/26/90)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
      include 'ibccon.cmd'
      include 'comchem.cmd'
      include 'errlog.cmd'
c
      dimension aq(mxx,mxy)
      character*4 mdum(10)
c
      ieof = 0
      ndate = indate
c
c
c  set all concentrations to numerical lower bound initially
c
      do 30 k=1,nlayer
        do 28 l=1,nospec
          do 26 j=1,noy
            do 24 i=1,nox
              conc(i,j,l,k) = bdnl(l)
   24       continue
   26     continue
   28   continue
   30 continue
c
c  find correct time and read initial concs
c
   50 read (iunit,end=900) idat, tdata, idate, tnext
      write(*,'(a,i8,f10.2,a,i8,f10.2,a,i4)')
     &     ' Read interval ',idat, tdata, ' to ', idate, tnext,
     &     ' on unit ', iunit
c
c
      do 200 l=1,nicsp
        lint = kicsp(l)
        do 190 k=1,nlayer
          read(iunit,end=905) nseg,(mdum(i),i=1,10),
     &                      ((aq(i,j),i=1,nox),j=1,noy)
          if (lint .eq. 0) go to 190
          do 150 j=1,noy
            do 140 i=1,nox
              conc(i,j,lint,k) = aq(i,j)
  140       continue
  150     continue
  190   continue
  200 continue
c
c  check time and if not correct, go back for another interval
c  (if ndate is calendar date, convert file date; but if ndate
c   is julian date, convert file date to julian)
c
      if (ndate .gt. 99999) then
        call caltoj(ndate,juldat)
        ndate = juldat
      endif
      if (idat .gt. 99999) then
        call caltoj(idat,id1)
        call caltoj(idate,id2)
      else
        id1 = idat
        id2 = idate
      endif
      ndays = intrvl(id1,ndate)
      tchk = tdata*100. + 2400.*ndays
      ndays = intrvl(id2,ndate)
      tchk2 = tnext*100. + 2400.*ndays
      if (time-tchk .lt. -0.1 .or. time-tchk2 .gt. 0.1) go to 50
c
      return
c
  900 ieof = 1
      return
c
  905 ieof = 1
      write(*,*) ' Unexpected end of file on IC file.'
      write(8,*) ' Unexpected end of file on IC file.'
      write(ierrlg,*) 247, '  Unexpected end of file on IC file.'
      return
c
      end
