      subroutine grdsp
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: grdsp.f,v $
c  Revision 1.6  1999/12/21  19:28:04  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.5  1998/11/10  17:59:19  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error message to log file (ierrlg)
c
c  Revision 1.4  1998/11/05  19:29:24  tcm
c  Eliminated references to receptors.
c
c  Revision 1.3  1995/04/26  00:40:29  tcm
c  	added code to correctly calculate fine grid spacing when in lat/lon coords
c
c  Revision 1.2  94/02/10  20:56:49  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c  Routine determines cell sizes, cell center locations for fine
c  grids and coarse domain
c
c     dkm - number of km in 1 deg lat (radius=6367.5 km)
c     dtr - degrees to radians
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'deffin.cmd'
      include 'comuam.cmd'
      include 'latlon.cmd'
      include 'comd3.cmd'
      include 'errlog.cmd'
c
      data dkm/111.1338/, dtr/0.01745329/
      data round/5.e-2/
      data a/6367.5/
c
c     if using cartesian coordinate system then dlong and dlat are
c     actually grid spacing in km
c
      if (lcart) then
        deltay=dlat
        do 5 j=1,noy
          deltax(j)=dlong
          tphioa(j)=0.0
    5   continue
c
      else
c
c     check for consitency in grid definition
c
        dum=wlong+dlong*float(nox)
        if (abs(dum-elong).gt.round) go to 800
        dum=slat+dlat*float(noy)
        if (abs(dum-nlat).gt.round) go to 800
c
c     calculate grid spacing of cell centers in km
c
        deltay=dkm*dlat
        do 10 j=1,noy
          alat=(float(j)-0.5)*dlat+slat
          deltax(j)=dkm*dlong*cos(alat*dtr)
          tphioa(j)=tan(alat*dtr)/a
   10   continue
c
      endif
      write(*,*) 'deltax(1), deltay: ', deltax(1), deltay
c
c   calculate cell sizes on fine grid
c
      do 26 ifine=1,numfin
c
        if(lcart) then
          do 23 j=1,nfy(ifine)
            tphioaf(j,ifine)=0.
            delfx(j,ifine) = deltax(1)/float(nhf(ifine))
   23     continue
          delfy(ifine) = deltay/float(nhf(ifine))
c
        else
c
          do 25 j=jyfb(ifine),jyfe(ifine) 
            alat=(float(j)-1.)*dlat +slat
            do 24 jj=1,nhf(ifine)
              jf=(j-jyfb(ifine))*nhf(ifine)+jj+1
              alatf=alat+(float(jj)-0.5)*dlat/float(nhf(ifine))
              delfx(jf,ifine)=dkm*dlong*cos(alatf*dtr)/float(nhf(ifine))
              tphioaf(jf,ifine)=tan(alatf*dtr)/a
   24       continue
   25     continue
          alat=(float(jyfb(ifine))-1.)*dlat +slat
          alatf=alat-0.5*dlat/float(nhf(ifine))
          delfx(1,ifine)=dkm*dlong*cos(alatf*dtr)/float(nhf(ifine))
          alat=float(jyfe(ifine))*dlat +slat
          alatf=alat+0.5*dlat/float(nhf(ifine))
          delfx(nfy(ifine),ifine)=dkm*dlong*cos(alatf*dtr)
     &                                       /float(nhf(ifine))
          delfy(ifine) = deltay/float(nhf(ifine))
c
        endif
        write(*,*) 'ifine, delfx(1,ifine), delfy(ifine): '
        write(*,*) ifine, delfx(1,ifine), delfy(ifine)
   26 continue
      return
c
  800 continue
c
c     grid definition input is inconsistent
c
      write(8,3000) wlong,elong,dlong,nox,dum,slat,nlat,dlat,noy,dum
      write(6,3000) wlong,elong,dlong,nox,dum,slat,nlat,dlat,noy,dum
      write(ierrlg,3001) 1069, wlong,elong,dlong,nox,dum,slat,nlat,
     &  dlat,noy,dum
 3000 format(' $$ERROR GRID DEFINITION INPUT IS INCONSISTENT'
     &,3e12.4,i5,e12.4,/,3e12.4,i5,e12.4)
 3001 format(i4,1x,' $$ERROR GRID DEFINITION INPUT IS INCONSISTENT'
     &,3e12.4,i5,e12.4,/,3e12.4,i5,e12.4)
      stop1
      end
