      subroutine hdrchk(iunit, mfile, xorg, yorg, nx, ny, nz)
c
c      check some header values from a met file
c
       character*10 filhdr, mfile
       character*80 note
c      Include errlog file
       include 'errlog.cmd'
c
c  read data file headers
c
  150 read(iunit) filhdr, note
      read(iunit) ivers, icoord, nspec, idat, timbeg, iend, timend
      read(iunit) xorgh, yorgh, dxh, dyh, nxh, nyh, nzh, izoneh
c
c  check file headers
c
      if (index(filhdr,mfile) .eq. 0) then
        write(*,'(a)') 'WARNING:  File header mismatch.'
        write(*,'(a,a)') '    Expected file header is: ', mfile
        write(*,'(a,a)') '    File contains header:    ', filhdr
        write(8,'(a)') 'WARNING:  File header mismatch.'
        write(8,'(a,a)') '    Expected file header is: ', mfile
        write(8,'(a,a)') '    File contains header:    ', filhdr
        write(ierrlg,'(i3,1x,a)') 248,'WARNING:  File header mismatch.'
        write(ierrlg,'(a,a)') '    Expected file header is: ', mfile
        write(ierrlg,'(a,a)') '    File contains header:    ', filhdr
      endif
      if ( abs(xorg-xorgh) .gt. 0.0001 .or.
     &          abs(yorg-yorgh) .gt. 0.0001 )then
        write(*,'(a,a)') 
     &      'WARNING:  File origin mismatch on file ', filhdr
        write(*,'(a,2f12.4)') 
     &                 '    Expected origin is: ', xorg, yorg
        write(*,'(a,2f12.4)') 
     &                 '    File contains origin:    ',xorgh,yorgh
        write(8,'(a,a)') 
     &      'WARNING:  File origin mismatch on file ', filhdr
        write(8,'(a,2f12.4)')
     &                 '    Expected origin is: ', xorg, yorg
        write(8,'(a,2f12.4)')
     &                 '    File contains origin:    ',xorgh,yorgh
        write(ierrlg,'(i3,1x,a,a)') 
     &      249, 'WARNING:  File origin mismatch on file ', filhdr
        write(ierrlg,'(a,2f12.4)')
     &                 '    Expected origin is: ', xorg, yorg
        write(ierrlg,'(a,2f12.4)') 
     &                 '    file contains origin:    ',xorgh,yorgh
      endif
      if (nx .ne. 0 .or. ny .ne. 0) then
        if (nx .ne. nxh .or. ny .ne. nyh .or. nz .ne. nzh) then
          write(*,'(a,a)') 
     &          'ERROR:  File dimension mismatch on file ', filhdr
          write(*,'(a,3i5)') 
     &                 '    Expected dimensions are: ',nx,ny,nz
          write(*,'(a,3i5)') 
     &                 '    File contains dimensions:',nxh,nyh,nzh
          write(8,'(a,a)') 
     &          'ERROR:  File dimension mismatch on file ', filhdr
          write(8,'(a,3i5)')
     &                 '    Expected dimensions are: ',nx,ny,nz
          write(8,'(a,3i5)')
     &                 '    File contains dimensions:',nxh,nyh,nzh
          write(ierrlg,'(i4,1x,a,a)') 1070,'ERROR:  File dimension ',
     &           'mismatch.'
          write(ierrlg,'(i4,1x,a,a)') 
     &        1070,'ERROR:  File dimension mismatch on file ', filhdr
          write(ierrlg,'(a,3i5)')
     &                 '    Expected dimensions are: ',nx,ny,nz
          write(ierrlg,'(a,3i5)') 
     &                 '    File contains dimensions:',nxh,nyh,nzh
          stop
        endif
      endif
c
      return
      end 
