      subroutine hedibc(nosp, nxsz, nysz, iunit, nspc, kspc, mfil)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: hedibc.f,v $
c  Revision 1.4  1998/11/10  19:14:27  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error messages to diag file and to log file (ierrlg)
c
c  Revision 1.3  1998/11/04  01:43:22  tcm
c  Changed declarations to character variables where appropriate.
c
c  Revision 1.2  94/02/10  20:57:01  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c  reads header of UAM initial conditions file and
c  fills in parameters
c  (tcm, 12/26/90)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'errlog.cmd'
c
      dimension kspc(mxibc)
c
      character*4 msp(10,mxibc), note(60), ifile(10) 
      character*4 mdum(10)
      character*10 m1, m2
      character*10 mfil
C
      read(iunit) ifile, note, nseg, nflspc, idate, begtim, 
     &            jdate, endtim
      write(*,'(a,i2,a,10a1)') ' File on unit ',iunit,' is ',ifile
c
c  pass file name back to calling routine in character variable
c
      write(mfil,'(10a1)') ifile
c
      if (nflspc .gt. mxibc) then
        write(*,*) 'NUMBER OF SPECIES ON INPUT FILE (',nflspc,')',
     &             ' IS GREATER THAN MAX ALLOWED (',mxibc,').'
        write(8,*) 'NUMBER OF SPECIES ON INPUT FILE (',nflspc,')',
     &             ' IS GREATER THAN MAX ALLOWED (',mxibc,').'
        write(ierrlg,*) 1072,'  NUMBER OF SPECIES ON INPUT FILE (',
     &             nflspc,') IS GREATER THAN MAX ALLOWED (', mxibc,').'
        stop
      endif
      read  (iunit) orgx, orgy, izone, utmx, utmy, deltax, deltay,
     &          nx, ny, nz, nzlowr, nzuppr, htsur, htlow, htupp
      if (nx .ne. nxsz) then
        write(*,*) 'NUMBER OF X CELLS ON INPUT FILE (',nx,')',
     &             ' IS INCORRECT. (',nxsz,').'
        write(8,*) 'NUMBER OF X CELLS ON INPUT FILE (',nx,')',
     &             ' IS INCORRECT. (',nxsz,').'
        write(ierrlg,*) 1073, '  NUMBER OF X CELLS ON INPUT FILE (',	
     &             nx,') IS INCORRECT. (',nxsz,').'
        stop
      endif
      if (ny .ne. nysz) then
        write(*,*) 'NUMBER OF Y CELLS ON INPUT FILE (',ny,')',
     &             ' IS INCORRECT. (',nysz,').'
        write(8,*) 'NUMBER OF Y CELLS ON INPUT FILE (',ny,')',
     &             ' IS INCORRECT. (',nysz,').'
        write(ierrlg,*) 1074, '  NUMBER OF Y CELLS ON INPUT FILE (',
     &             ny,') IS INCORRECT. (',nysz,').'
        stop
      endif
      read(iunit) nxx,nyy,nxcell,nycell
      read(iunit) ((msp(m,l),m=1,10),l=1,nflspc)
c
c  find each species on file in standard species list
c  (0 will mean a species on file that is not needed.)
c  Treat FORM on file as equivalent to HCHO.
c  Treat HONO on file as equivalent to HNO2.
c
      do 100 l=1,nflspc
        write(m1,'(10a1)') (msp(i,l),i=1,10)
        do 80 lint=1,nosp
          write(m2,'(10a1)') (mspec(i,lint),i=1,10)
          if (m1 .eq. m2) then
            kspc(l) = lint
            write(*,'(a,i3,1x,a,a,10a1,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on ',ifile,' file = species ',lint,m2,' internally.'
            go to 100
          endif
          if (m1 .eq. 'FORM      ') then
            if ('HCHO      ' .eq. m2) then
              kspc(l) = lint
              write(*,'(a,i3,1x,a,a,10a1,a,i3,1x,a,a)')' Species ',l,m1,
     &            ' on ',ifile,' file = species ',lint,m2,' internally.'
              go to 100
            endif
          endif
          if (m1 .eq. 'HONO      ') then
            if ('HNO2      ' .eq. m2) then
              kspc(l) = lint
              write(*,'(a,i3,1x,a,a,10a1,a,i3,1x,a,a)')' Species ',l,m1,
     &            ' on ',ifile,' file = species ',lint,m2,' internally.'
              go to 100
            endif
          endif
   80   continue
        kspc(l) = 0
  100 continue
c
      nspc = nflspc
      return
      end
