      subroutine hedpts(nosp, nxsz, nysz, iunit, nsem, kespc)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: hedpts.f,v $
c  Revision 1.7  1999/12/21  19:28:06  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.6  1998/11/17  23:09:12  ara
c  Directed warning messages to diag file and to log file (ierrlg)
c
c  Revision 1.5  1998/11/10  19:38:53  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error messages to diag file and to log file (ierrlg)
c
c  Revision 1.4  1998/11/04  01:43:49  tcm
c  Changed declarations to character variables where appropriate.
c
c  Revision 1.3  1995/04/26  00:40:45  tcm
c  	added code to correctly calculate plume location in lat/lon coords
c
c  Revision 1.2  94/02/10  20:57:06  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c  reads header of UAM point source emissions file and
c  fills in parameters for main routine
c  (tcm, 11/1/90)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'stack.cmd'
      include 'comchem.cmd'
      include 'latlon.cmd'
      include 'comd3.cmd'
      include 'pigpen.cmd'
      include 'errlog.cmd'
c
      dimension kespc(mxemit)
c
      character*4 memsp(10,mxemit), note(60), ifile(10) 
      character*10 m1, m2
      nplm = 0
C
      read(iunit) ifile, note, nseg, nemspc, idate, begtim, 
     &            jdate, endtim
      write(m1,'(10a1)') ifile
      if (m1 .ne. 'PTSOURCE  ') then
        write(*,'(a,i2,a,a,/,a)') ' File on unit ',iunit,' is ',m1,
     &           ' It should be PTSOURCE.'
        write(8,'(a,i2,a,a,/,a)') ' File on unit ',iunit,' is ',m1,
     &           ' It should be PTSOURCE.'
        write(ierrlg,'(i4,1x,a,i2,a,a,/,a)') 1076,' File on unit ',
     &           iunit,' is ',m1,'It should be PTSOURCE.'
        stop
      endif
      if (nemspc .gt. mxemit) then
        write(*,*) 'NUMBER OF SPECIES ON PTSOURCE FILE (',nemspc,')',
     &             ' IS GREATER THAN MAX ALLOWED (',mxemit,').'
        write(8,*) 'NUMBER OF SPECIES ON PTSOURCE FILE (',nemspc,')',
     &             ' IS GREATER THAN MAX ALLOWED (',mxemit,').'
        write(ierrlg,*) 1075,'  NUMBER OF SPECIES ON PTSOURCE FILE (',
     &           nemspc,') IS GREATER THAN MAX ALLOWED (',mxemit,').'
        stop
      endif
      read  (iunit) orgx, orgy, izone, utmx, utmy, deltax, deltay,
     &          nx, ny, nz, nzlowr, nzuppr, htsur, htlow, htupp
      if (nx .ne. nxsz) then
        write(*,*) '*** WARNING ***' 
        write(*,*) 'NUMBER OF X CELLS ON PTSOURCE FILE (',nx,')',
     &             ' IS INCORRECT. (',nxsz,').'
        write(8,*) '*** WARNING ***'
        write(8,*) 'NUMBER OF X CELLS ON PTSOURCE FILE (',nx,')',
     &             ' IS INCORRECT. (',nxsz,').'
        write(ierrlg,'(i3,1x,a)') 250,'*** WARNING ***'
        write(ierrlg,*) 'NUMBER OF X CELLS ON PTSOURCE FILE (',nx,')',
     &             ' IS INCORRECT. (',nxsz,').'
      endif
      if (ny .ne. nysz) then
        write(*,*) '*** WARNING ***' 
        write(*,*) 'NUMBER OF Y CELLS ON PTSOURCE FILE (',ny,')',
     &             ' IS INCORRECT. (',nysz,').'
        write(8,*) '*** WARNING ***'
        write(8,*) 'NUMBER OF Y CELLS ON PTSOURCE FILE (',ny,')',
     &             ' IS INCORRECT. (',nysz,').'
        write(ierrlg,'(i3,1x,a)') 251,'*** WARNING ***'
        write(ierrlg,*) 'NUMBER OF Y CELLS ON PTSOURCE FILE (',ny,')', 
     &             ' IS INCORRECT. (',nysz,').'
      endif
      read(iunit) nxx,nyy,nxcell,nycell
      read(iunit) ((memsp(m,l),m=1,10),l=1,nemspc)
c
c  find each species on emissions file in standard species list
c  (0 will mean a species on emissions file that is not needed.)
c  Treat FORM on PTSOURCE file as equivalent to HCHO.
c  Treat HONO on PTSOURCE file as equivalent to HNO2.
c
      do 100 l=1,nemspc
        write(m1,'(10a1)') (memsp(i,l),i=1,10)
        do 80 lint=1,nosp
          write(m2,'(10a1)') (mspec(i,lint),i=1,10)
          if (m1 .eq. m2) then
            kespc(l) = lint
            write(*,'(a,i3,1x,a,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on PTSOURCE file = species ',lint,m2,' internally.'
            go to 100
          endif
          if (m1 .eq. 'FORM      ') then
            if ('HCHO      ' .eq. m2) then
              kespc(l) = lint
              write(*,'(a,i3,1x,a,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on PTSOURCE file = species ',lint,m2,' internally.'
              go to 100
            endif
          endif
          if (m1 .eq. 'HONO      ') then
            if ('HNO2      ' .eq. m2) then
              kespc(l) = lint
              write(*,'(a,i3,1x,a,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on PTSOURCE file = species ',lint,m2,' internally.'
              go to 100
            endif
          endif
   80   continue
        kespc(l) = 0
  100 continue
c
      nsem = nemspc
c
c  read and check number of points
c
      read(iunit) idum, nopts
      if (nopts .gt. mxsrc) then
        write(*,'(1x,i5,a,/,1x,a,i5)') nopts, 
     &                          ' is larger than the maximum',
     &                          ' number of allowed sources: ',mxsrc
        write(8,'(1x,i5,a,/,1x,a,i5)') nopts,
     &                          ' is larger than the maximum',
     &                          ' number of allowed sources: ',mxsrc
        write(ierrlg,'(i4,2x,i5,a,/,1x,a,i5)') 1077,nopts,
     &                          ' is larger than the maximum',
     &                          ' number of allowed sources: ',mxsrc

        stop
      endif
c
c  read location and stack parameters
c
      read(iunit) (plong(n), plat(n), stkht(n), stkd(n),
     &            temps(n), vexit(n),n=1,nopts)
c
c  convert location if necessary, convert vexit from m/hr to m/s, 
c  check for pflag
c
      do 120 n=1,nopts
        if(lcart)then
          plong(n)=(plong(n)*.001-xorg)/dlong
          plat(n)=(plat(n)*.001-yorg)/dlat
        endif
        vexit(n) = vexit(n)/3600.
        if (stkd(n) .lt. 0.) then
          stkd(n) = abs(stkd(n))
          if (stkd(n) .gt. 9000.) then
            stkd(n) = stkd(n) - 9000.
            prflg(n) = .false.
          else
            prflg(n) = .true.
          endif
          if (lpig) then
            nplm = nplm + 1
            pflag(n) = .true.
            npsrc(nplm) = n
            if (lcart) then
              xplm(nplm) = plong(n)*dlong
              yplm(nplm) = plat(n)*dlat
            else
              xplm(nplm) = (plong(n)-wlong)/dlong
              yplm(nplm) = (plat(n)-slat)/dlat
            endif
          else
            pflag(n) = .false.
          endif
        else
          pflag(n) = .false.
        endif
  120 continue
      return
      end
