      subroutine irr_conc(id,irrstrt,irrend,nlayer,nospec)
c
c  subroutine to add up the change in concentration for the following processes
c
c$Log: irr_conc.f,v $
c  Revision 1.1  1999/07/07  00:49:04  tcm
c  Initial revision
c
c
c     1  -  pig treatment for coarse grid
c     2  -  point sources in coarse grid
c     3  -  area sources in coarse grid
c     4  -  chemistry in coarse grid
c     5  -  fill-ins from fine to coarse
c
      include 'parm.cmd'
      include 'parfin.cmd'
      include 'parchm.cmd'
      include 'irmb.cmd'
c
c  if it's 1 - pig
c
      if (id.eq.1) then
         do k = 1, nlayer
            do l = 1, nospec
               do ij = irrstrt, irrend
                  pig(ij,l,k) = cmem(ij,l,k) + pig(ij,l,k)
               enddo
            enddo
         enddo
c
c  if it's 2 - ptsources
c
      elseif (id.eq.2) then
         do k = 1, nlayer
            do l = 1, nospec
               do ij = irrstrt, irrend
                  pemis(ij,l,k) = cmem(ij,l,k) + pemis(ij,l,k)
               enddo
            enddo
         enddo
c
c  if it's 3 - area sources
c
      elseif (id.eq.3) then
         do k = 1, 1
            do l = 1, nospec
               do ij = irrstrt, irrend
                  aemis(ij,l,k) = cmem(ij,l,k) + aemis(ij,l,k)
               enddo
            enddo
         enddo
c
c  if it's 4 - chemistry
c
      elseif (id.eq.4) then
         do k = 1, nlayer
            do l = 1, nospec
               do ij = irrstrt, irrend
                  cchem(ij,l,k) = cmem(ij,l,k) + cchem(ij,l,k)
               enddo
            enddo
         enddo
c
c  if it's 5 - fill-in from fine to coarse
c
      elseif (id.eq.5) then
         do k = 1, nlayer
            do l = 1, nospec
               do ij = irrstrt, irrend
                  fillin(ij,l,k) = cmem(ij,l,k) + fillin(ij,l,k)
               enddo
            enddo
         enddo
c
      endif
c
      call flush(6)
c
      return
      end
