       subroutine irr_wrt (noxy, nz, nspec, nreact, ttime)
c
c  subroutine to print the mass balance for each output period
c
c$Log: irr_wrt.f,v $
c  Revision 1.1  1999/07/07  00:50:31  tcm
c  Initial revision
c
c
c      1  -  horizontal transport (advection + dispersion)
c      2  -  vertical   transport (advection + dispersion)
c      3  -  gas phase chemistry
c      4  -  emissions
c      5  -  dry deposition + reaction rate
c      6  -  final concentration
c
c
       include 'parm.cmd'
       include 'parfin.cmd'
       include 'parchm.cmd'
       include 'comchem.cmd'
       include 'irmb.cmd'
       real aemis1(mxspec)
c
c  if no out file opened, just return
c
       if (irrcrs .le. 0) return
c
c  write to the log file
c
       write (*,50) noxy,nz,nspec,nspec,nreact,ttime,ldark
50     format (' noxy =',i5,'  nz =',i3,'  nspec =',i5,
     &         '  mxspec =',i5,'  nreact =',i5,' ttime =',f5.1,
     &         '  dark =',l5)
c
c  assign everything into the correct dimension
c
       do 400 l = 1, nspec
          do i = 1, 10
             imspec(i,l) = mspec(i,l)
          enddo
400    continue
c
C  if lwbin = .true.  --> write out binary output
C  if lwbin = .false. --> write out ascii output
C
         write (irrcrs) noxy,nz,nspec,nspec,nreact,ttime,ldark
c
c        reaction rates
c
         write(irrcrs) ((imspec(i,l),i=1,10),l=1,nspec)
c
         print *,' layer =', irr_layer,' grids =',irr_grds
c
*hpd     do 900 iz = 1, irr_layer
*hpd     do 900 ij = 1, irr_grds
         do 900 ij = 1, irr_grds
           write(irrcrs) irr_layer
         do 900 iz = 1, irr_layer
*
* set aemis1 appropriately
           IF(irr_ipv(iz).eq.1) THEN
             DO l=1,nspec
               aemis1(l)=aemis(ij,l,1)
             ENDDO
           ELSE
             DO l=1,nspec
               aemis1(l)=0.
             ENDDO
           ENDIF

c
            write (irrcrs) irr_ipv(iz), irr_x(ij),
     &                     irr_y(ij),  irr_f(ij)
c
            write(irrcrs)
     &           (r_tot(ij,ir,irr_ipv(iz)),ir=1,nreact)
c
c        horizontal and vertical transport
c
            write(irrcrs)
     &          (cchem   (ij,l,irr_ipv(iz)),          ! gas phase chemistry
     &           ewflux  (1,ij,l,irr_ipv(iz)),        ! w-bndary advection
     &           ewflux  (2,ij,l,irr_ipv(iz)),        ! e-bndary advection
     &           snflux  (1,ij,l,irr_ipv(iz)),        ! s-bndary advection
     &           snflux  (2,ij,l,irr_ipv(iz)),        ! n-bndary advection
     &           btflux  (1,ij,l,irr_ipv(iz)),        ! b-bndary advection
     &           btflux  (2,ij,l,irr_ipv(iz)),        ! t-bndary advection
*hpd &           aemis   (ij,l,irr_ipv(iz)),          ! low level emissions
     &           aemis1  (l),                         ! low level emissions
     &           pemis   (ij,l,irr_ipv(iz)),          ! elevated point sources
     &           pig     (ij,l,irr_ipv(iz)),          ! plume-in-grid treatment
     &           clorz   (ij,l,irr_ipv(iz)),          ! Lorenz cycle
     &           fillin  (ij,l,irr_ipv(iz)),          ! Lorenz cycle
     &           final   (ij,l,irr_ipv(iz)),          ! final concentration
     &                     l = 1, nspec)              ! loop over species
c
900      continue
c
c  now that this slice is written out, we can flush everything out and
c  initialize everything back to zero ............
c
       call flush (irrcrs)
c       call irr_init0
c
c  return to next time around
c
       return
       end
