       subroutine irr_wrtf (noxy, nz, nspec, nreact, ttime)
c
c  subroutine to print the mass balance for each output period
c
c$Log: irr_wrt_f.f,v $
c  Revision 1.1  1999/07/07  00:51:04  tcm
c  Initial revision
c
c
c      1  -  horizontal transport (advection + dispersion)
c      2  -  vertical   transport (advection + dispersion)
c      3  -  gas phase chemistry
c      4  -  emissions
c      5  -  dry deposition + reaction rate
c      6  -  final concentration
c
c
       include 'parm.cmd'
       include 'parfin.cmd'
       include 'parchm.cmd'
       include 'comchem.cmd'
       include 'deffin.cmd'
       include 'irmb.cmd'
       real aemisf1(mxspec)
c
c  if no out file opened, just return
c
       if (irrfine .le. 0) return
c
c  write to the log file
c
       write (*,50) noxy,nz,nspec,nspec,nreact,ttime,ldark
50     format (' noxy =',i5,'  nz =',i3,'  nspec =',i5,
     &         '  mxspec =',i5,'  nreact =',i5,' ttime =',f5.1,
     &         '  dark =',l5)
c
c  assign everything into the correct dimension
c
       do 400 l = 1, nspec
          do i = 1, 10
             imspec(i,l) = mspec(i,l)
          enddo
400    continue
c
         write (irrfine) noxy,nz,nspec,nspec,nreact,ttime,ldark
c
c        reaction rates
c
         write(irrfine) ((imspec(i,l),i=1,10),l=1,nspec)
c
*hpd         print *,' layer =', irr_layer,' grids =',irr_grds
        write(*,*) 'number of surface cells = ',irr_fine
        do k=1,numfin
         if(irr_layerf(k).gt.0) THEN
           write(*,*) 'grid, layers = ',k,irr_layerf(k)
         endif
        enddo
c
*hpd     do 900 iz = 1, irr_layer
*hpd     do 900 ij = 1, irr_fine
*hpd        write (irrfine) irr_ipv(iz),irr_xf(ij),
*hpd &                     irr_yf(ij), irr_ff(ij)
*hpd        write(irrfine)
*hpd &           (r_totf(ij,ir,irr_ipv(iz)),ir=1,nreact)
c
c        horizontal and vertical transport
c
*hpd        write(irrfine)
*hpd &          (cchemf   (ij,l,irr_ipv(iz)),          ! gas phase chemistry
*hpd &           ewfluxf  (1,ij,l,irr_ipv(iz)),        ! w-bndary advection
*hpd &           ewfluxf  (2,ij,l,irr_ipv(iz)),        ! e-bndary advection
*hpd &           snfluxf  (1,ij,l,irr_ipv(iz)),        ! s-bndary advection
*hpd &           snfluxf  (2,ij,l,irr_ipv(iz)),        ! n-bndary advection
*hpd &           btfluxf  (1,ij,l,irr_ipv(iz)),        ! b-bndary advection
*hpd &           btfluxf  (2,ij,l,irr_ipv(iz)),        ! t-bndary advection
*hpd &           aemisf   (ij,l,irr_ipv(iz)),          ! low level emissions
*hpd &           pemisf   (ij,l,irr_ipv(iz)),          ! elevated point sources
*hpd &           pigf     (ij,l,irr_ipv(iz)),          ! plume-in-grid treatment
*hpd &           clorzf   (ij,l,irr_ipv(iz)),          ! Lorenz cycle
*hpd &           fillinf  (ij,l,irr_ipv(iz)),          ! Lorenz cycle
*hpd &           finalf   (ij,l,irr_ipv(iz)),          ! final concentration
*hpd &                     l = 1, nspec)               ! loop over species
c
         do 900 ij=1,irr_fine
           igrid=irr_ff(ij)                    !just to make it easier to read
           write(irrfine) irr_layerf(igrid)
         do 900 iz = 1,irr_layerf(igrid)
*
* set aemisf appropriately, hpd, 18.Mar.98
            IF(irr_ipvf(igrid,iz).eq.1) THEN
              DO l=1,nspec
                aemisf1(l)=aemisf(ij,l,1)
              ENDDO
            ELSE
              DO l=1,nspec
                aemisf1(l)=0.
              ENDDO
            ENDIF

            write(irrfine) irr_ipvf(igrid,iz),irr_xf(ij),
     &                    irr_yf(ij),     irr_ff(ij)
            write(irrfine)
     &           (r_totf(ij,ir,irr_ipvf(igrid,iz)),ir=1,nreact)
c
c        horizontal and vertical transport
c
            write(irrfine)
     &          (cchemf   (ij,l,irr_ipvf(igrid,iz)),   ! gas phase chemistry
     &           ewfluxf  (1,ij,l,irr_ipvf(igrid,iz)), ! w-bndary advection
     &           ewfluxf  (2,ij,l,irr_ipvf(igrid,iz)), ! e-bndary advection
     &           snfluxf  (1,ij,l,irr_ipvf(igrid,iz)), ! s-bndary advection
     &           snfluxf  (2,ij,l,irr_ipvf(igrid,iz)), ! n-bndary advection
     &           btfluxf  (1,ij,l,irr_ipvf(igrid,iz)), ! b-bndary advection
     &           btfluxf  (2,ij,l,irr_ipvf(igrid,iz)), ! t-bndary advection
*hpd &           aemisf   (ij,l,irr_ipvf(igrid,iz)),   ! low level emissions
     &           aemisf1  (l),                         ! low level emissions
     &           pemisf   (ij,l,irr_ipvf(igrid,iz)),   ! elevated point sources
     &           pigf     (ij,l,irr_ipvf(igrid,iz)),   ! plume-in-grid treatment
     &           clorzf   (ij,l,irr_ipvf(igrid,iz)),   ! Lorenz cycle
     &           fillinf  (ij,l,irr_ipvf(igrid,iz)),   ! Lorenz cycle
     &           finalf   (ij,l,irr_ipvf(igrid,iz)),   ! final concentration
     &                     l = 1, nspec)               ! loop over species
c
900      continue
c
c  now that this slice is written out, we can flush everything out and
c  initialize everything back to zero ............
c
       call flush (irrfine)
c       call irr_init0
c
c  return to next time around
c
       return
       end
