      subroutine jtocal(jdate,idate)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: jtocal.f,v $
c  Revision 1.4  1998/11/10  22:11:35  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error messages to diag file and to log file (ierrlg)
c
c  Revision 1.3  1998/11/04  01:44:18  tcm
c  Revised to default Julian dates to 1951 to 2050 and to return
c  calendar date with four digit year.
c
c  Revision 1.2  94/02/10  20:57:40  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c   convert a five digit Julian date to YYYYMMDD type date
c
      include 'errlog.cmd'
      dimension ntab(12)
      data ntab/31,28,31,30,31,30,31,31,30,31,30,31/
c
      iyr = jdate/1000
      if (iyr .gt. 99) then
        write(*,*) 'Invalid year: ', iyr
        write(*,*) 'Julian dates must use two digit years.'
        write(*,*) 'Converted from input date ', jdate
        write(*,*) 'Terminating in jtocal'
        write(8,*) 'Invalid year: ', iyr
        write(8,*) 'Julian dates must use two digit years.'
        write(8,*) 'Converted from input date ', jdate
        write(8,*) 'Terminating in jtocal'
        write(ierrlg,*) 1082,'  Invalid year: ',iyr
        write(ierrlg,*) 'Julian dates must use two digit years.'
        write(ierrlg,*) 'Converted from input date ',jdate
        write(ierrlg,*) 'Terminating in jtocal'
        stop
      endif
c     
      if (mod(iyr,4) .eq. 0) then
        ntab(2) = 29
        iylen = 366
      else
        ntab(2) = 28
        iylen = 365
      endif
c
      nday = mod(jdate,1000)
      if (nday .lt. 1 .or. nday .gt. iylen) then
        write(*,*) 'Invalid day: ', nday
        write(*,*) 'Converted from input date ', jdate
        write(*,*) 'Terminating in jtocal'
        write(8,*) 'Invalid day: ', nday
        write(8,*) 'Converted from input date ', jdate
        write(8,*) 'Terminating in jtocal'
        write(ierrlg,*) 1083,'  Invalid day: ',nday
        write(ierrlg,*) 'Converted from input date ',jdate
        write(ierrlg,*) 'Terminating in jtocal'
        stop
      endif
c
      nsum = 0
      do 100 ii=1,12
        imo = ii
        nsum = nsum + ntab(imo)
        if (nsum .ge. nday) go to 120
  100 continue
c
  120 nsm1 = nsum - ntab(imo)
      idy = nday - nsm1
c     
      if (iyr .lt. 51) then
        iyr = iyr + 2000
      else
        iyr = iyr + 1900
      endif
      idate = iyr*10000 + imo*100 + idy
      return
      end
