      subroutine pgread(time,idate)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: pgread.f,v $
c  Revision 1.6  1998/11/20  22:16:43  tcm
c  Fixed error message on line 163
c
c  Revision 1.5  1998/11/11  16:27:24  ara
c  Included file errlog.cmd to introduce ierrlg variable
c  Directed error messages to diag file and to log file (ierrlg)
c
c  Revision 1.4  1998/11/04  01:47:59  tcm
c  Filename string lengthened.
c  Revised treatment of dates to handle crossing years.
c
c  Revision 1.3  1996/06/14  23:00:46  tcm
c  call to pigdmp added by gem
c
c  Revision 1.2  1994/02/10  20:58:39  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c   read pig data for restart
c   (tcm, 2/5/92)
c
      include 'parfin.cmd'
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'adunit.cmd'
      include 'empuf.cmd'
      include 'pigdung.cmd'
      include 'pigpen.cmd'
      include 'pigdmp.cmd'
      include 'pufloc.cmd'
      include 'rpm.cmd'
      include 'stack.cmd'
      include 'errlog.cmd'
c
      character*132 fn
      logical lerr
c
      iupigi = 97
      lerr = .false.
c
c  make sure desired date is in julian form
c
      if (idate .gt. 99999) then
        call caltoj(idate,ijdate)
      else
        ijdate = idate
      endif
c
c  open pig restart file on unit 97
c
      read(7,'(a)') fn
      write(*,3315) fn
      write(8,3315) fn
      write(6,3315) fn
 3315 format(' opening unit 97 for pig restart file=',a,'=')
      open(iupigi,file=fn,status='old',form='unformatted')
c
c  read time record
c
   20 read(iupigi,end=800) tf1, idf1
      write(*,'(a,f8.2,i8, a, f8.2, i8)') ' pig time: ', 
     &      tf1, idf1, '  search time: ', time, idate
c
c  make sure file date is in julian form
c
      if (idf1 .gt. 99999) then
        call caltoj(idf1,ijdf1)
      else
        ijdf1 = idf1
      endif
c
c   read values of all parameters to allow restart even when 
c   arrays have changed size
c
      read(iupigi) mfpspc, mfskn, mfpfs, mfplms, maffin, mfdmp,
     &             npuffs, nplm, kcount, nspec, nrclls, curtim
      outtim = curtim
c
c
      read(iupigi) (xloc(i),yloc(i),
     &                 height(i),idump(i),dtpuf(i),
     &                 tpuff(i),sigma(i),sigmav(i),
     &                 kpuff(i),xlnpuf(i),pufage(i),
     &                 ifg(i),iic(i),jjc(i),kkc(i),
     &                 iif(i),jjf(i),kkf(i),nplume(i),nsrcmbn(i),
     &                 i=1,mfpfs)
c
      read(iupigi) (xplm(i),yplm(i), tsrc(i), npsrc(i),
     &              i=1,mfplms)
      read(iupigi) ((isrcmbn(i,j),i=1,mfpfs),j=1,mfplms)
c
      read(iupigi) (rfacb(i),i=1,mfskn+1),
     &             (rfacc(i),wfac(i),i=1,mfskn)
c
      read(iupigi) ((aml(i,j),i=1,mfpspc),j=1,mfpfs)
      read(iupigi) ((oaml(i,j),i=1,mfpspc),j=1,mfpfs)
c
      read(iupigi) (osgy(i),osgz(i),i=1,mfpfs)
c
      read(iupigi) (nskins(i),wnd(i),tmprt(i),i=1,mfpfs)
      read(iupigi) ((emrate(i,j),i=1,mfpspc),j=1,mfpfs)
c
      read(iupigi) (((concs(i,j,k),i=1,mfpspc),j=1,mfskn),k=1,mfpfs)
      read(iupigi) (((connul(i,j,k),i=1,mfpspc),j=1,mfskn),k=1,mfpfs)
c
      read(iupigi) ((idmp(i,j),jdmp(i,j),kdmp(i,j),
     &                tdmp(i,j),i=1,mfdmp),j=1,maffin+1)
c
      read(iupigi) ((condmp(i,j),i=1,mfpspc),j=1,mfdmp)
      read(iupigi) (voldmp(i),dtdmp(i),i=1,mfdmp)
c
      read(iupigi) ((epint(i,j),i=1,mfpspc),j=1,mfpfs)
c
c
c  check time for this record of data:
c   if its early, go back and read another
c   if its late, give up
c   if its right, return
c
      ndays = intrvl(ijdf1,ijdate)
      tchk = tf1 + 2400.*ndays
      if (tchk .lt. time - 1.) go to 20
      if (tchk .gt. time + 1.) go to 810
      write(*,'(a)') ' time found on pig restart file.'
c
c  check consistency of flagged sources on restart and 
c  point source input file
c
      do 120 n=1,nplm
        nn = npsrc(n)
        if (.not.pflag(nn)) then
          lerr = .true.
          write(*,*) ' ***error***'
          write(*,*) ' source ',nn,' is flagged p-i-g in restart file'
          write(*,*) ' but not in ptsource file.'
          write(8,*) ' ***error***'
          write(8,*) ' source ',nn,' is flagged p-i-g in restart file'
          write(8,*) ' but not in ptsource file.'
          write(ierrlg,*) 1087,'  ***error***' 
          write(ierrlg,*) ' source ',nn,' is flagged p-i-g in ', 
     &         'restart file'
          write(ierrlg,*) ' but not in ptsource file.'
        endif
  120 continue
c
      do 140 nn=1,nopts
        if (pflag(nn)) then
          do 130 n=1,nplm
            if (npsrc(n) .eq. nn) go to 140
  130     continue
          lerr = .true.
          write(*,*) ' ***error***'
          write(*,*) ' source ',nn,' is flagged p-i-g in ptsource file'
          write(*,*) ' but not in restart file.'
          write(8,*) ' ***error***'
          write(8,*) ' source ',nn,' is flagged p-i-g in ptsource file'
          write(8,*) ' but not in restart file.'
          write(ierrlg,*) 1088,'  ***error***'
          write(ierrlg,*) ' source ',nn,' is flagged p-i-g in',
     &           ' ptsource file'   
          write(ierrlg,*) ' but not in restart file.'
        endif
  140 continue
      if (lerr) go to 820
c
      if ( ipig .gt. 0 ) call pigdmp(time,idate)
      return
c
c  error occurred
c
  800 write(*,'(a,/,a)') ' *** error ***',
     &      ' end of file on pig restart file.'
      write(8,'(a,/,a)') ' *** error ***',
     &      ' end of file on pig restart file.'
      write(ierrlg,'(i4,1x,a,/,a)') 1089,'  *** error ***',
     &      ' end of file on pig restart file.'
      stop
c
  810 write(*,'(a,/,a)') ' *** error ***',
     &      ' time on pig restart file after desired start time.'
      write(8,'(a,/,a)') ' *** error ***',
     &      ' time on pig restart file after desired start time.'
      write(ierrlg,'(i4,1x,a,/,a)') 1090,'  *** error ***',
     &      ' time on pig restart file after desired start time.'
      stop
c
  820 write(*,'(a,/,a)') ' *** error ***',
     &  ' sources flagged for p-i-g must remain the same after restart.'
      write(8,'(a,/,a)') ' *** error ***',
     &  ' sources flagged for p-i-g must remain the same after restart.'
      write(ierrlg,'(i4,1x,a,/,a)') 1091,'  *** error ***',
     &  ' sources flagged for p-i-g must remain the same after restart.'
      stop
c
      end
