      subroutine rchemf(nxf,nyf,nzf,nfspec,cncf,htf,presf,temprf,
     &                  ch2of,cwatrf,ahprcf,avterf,ctlonf,ctlatf,
     &                  cloudf,time,idate,
     &                  ifine,idebug)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: rchemf.f,v $
c  Revision 1.13  1999/12/21  19:28:24  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.12  1999/07/07  16:33:36  tcm
c  Added tracking of concentrations before and after chemistry calls
c  for pa/irr treatment.  Modified step4 calls to all irr treatment.
c
c  Revision 1.11  1999/05/18  18:57:54  dfg
c  *** empty log message ***
c
c  Revision 1.10  1999/05/12  23:42:21  dfg
c  Set ddtt in munutes for all chem routine now.
c
c  Revision 1.9  1999/05/12  16:42:25  dfg
c  Added a local radical array.  And load radical conc. before step4.
c  Then load back radical conc. into radical array after step4.
c
c  Revision 1.8  1999/04/08  23:56:56  tcm
c  Added branch based on input flag to use either fast or standard chemistry.
c
c  Revision 1.7  1998/11/16  19:43:04  ara
c  Error message directed to diag and to log file (ierrlg)
c
c  Revision 1.6  1998/11/12  17:01:28  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error message to screen, diag file and log file (ierrlg)
c
c  Revision 1.5  1998/11/04  01:50:46  tcm
c  Eliminated superfluous write of tmpinc.
c  Revised treatment of dates.
c  Eliminated use of cfrad.
c
c  Revision 1.4  1996/06/14  23:02:40  tcm
c   diagnostics added by gem
c
c  Revision 1.3  1995/04/26  00:43:41  tcm
c  	height for calculation of photolysis measured above ground rather than above
c  	sea level.
c
c  Revision 1.2  94/02/10  20:59:27  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c     
c     *** Chemistry driver for the fine grids
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'deffin.cmd'
      include 'comuam.cmd'
      include 'comchem.cmd'
      include 'comd3.cmd'
      include 'ppmcon.cmd'
      include 'errlog.cmd'
c
czswa------------------------------------------------------------------
c  ipram stuff
c
      include 'irmb.cmd'
      dimension cold(mxspec)
c
czswz------------------------------------------------------------------
c
      dimension ixff0(maxfin), ixff1(maxfin),
     &          jyff0(maxfin), jyff1(maxfin)
      dimension cncf(nxf,nyf,nfspec,nzf), htf(nxf,nyf,nzf),
     &          presf(nxf,nyf,nzf), temprf(nxf,nyf,nzf),
     &          ch2of(nxf,nyf,nzf), cwatrf(nxf,nyf,nzf),
     &          ahprcf(nxf,nyf,nzf), avterf(nxf,nyf),
     &          ctlonf(nxf,nyf), ctlatf(nxf,nyf),
     &          cloudf(nxf,nyf,nzf)
      dimension con(mxspec),rcon(mxrads)
c
      dimension cmax(mxfz),cmin(mxfz),cavg(mxfz)
      dimension icmax(mxfz),icmin(mxfz),icavg(mxfz)
      logical lsmth,llpt
      common /idcell/irchem,jrchem,krchem,tmchm
      common /ppp/ lcprt, lcstop
      logical lcprt, lcstop
      data lsmth/.true./
      data ichmag/0/
c
c  bit five of idebug on (i.e., the sixteens location) will turn
c  on debug writes in rchemf.
c
      idiag = and(idebug,16)
c
      tmchm = time
      llpt=.false.
c
c  set up some parameters relating the grids
c
      do 15 if1=1,numfin
        if (ifgptr(if1) .ne. ifine) go to 15
        ixff0(if1) = (ixfb(if1) - ixfb(ifine))*nhf(ifine) + 2
        ixff1(if1) = (ixfe(if1) - ixfb(ifine) + 1)*nhf(ifine) + 1
        jyff0(if1) = (jyfb(if1) - jyfb(ifine))*nhf(ifine) + 2
        jyff1(if1) = (jyfe(if1) - jyfb(ifine) + 1)*nhf(ifine) + 1
        if (ixff0(if1) .lt. 2 .or. ixff1(if1) .ge. nxf .or.
     &      jyff0(if1) .lt. 2 .or. jyff1(if1) .ge. nyf) then
          write(*,*) ' erroneous grid parameters in rchemf'
          write(*,*) ' ixff0, ixff1, jyff0, jyff1: ',ixff0,ixff1,
     &                 jyff0, jyff1
          write(*,*) 'if1, ifine: ',if1,ifine
          write(8,*) ' erroneous grid parameters in rchemf'
          write(8,*) ' ixff0, ixff1, jyff0, jyff1: ',ixff0,ixff1,
     &                 jyff0, jyff1
          write(8,*) 'if1, ifine: ',if1,ifine
          write(ierrlg,*) 1154, '  erroneous grid parameters in rchemf'
          write(ierrlg,*) 'ixff0, ixff1, jyff0, jyff1: ',ixff0,ixfff1,
     &                 jyff0, jyff1
          write(ierrlg,*) 'if1, ifine: ',if1,ifine
          stop
        endif
   15 continue
c
c
c     write max,minmavg ozone to diagnostic output file
c
      do 2 l=1,nzf
        cmax(l)=-1.e20
        cmin(l)=1.e20
        cavg(l)=0.0
    2 continue
c
      denom=0.0
      do 7 j=2,nyf-1
        do 4 i=2,nxf-1
          do 3 l=1,nzf
            val=cncf(i,j,ko3,l)*1000.0*cpfac
            cavg(l)=cavg(l)+val
            cmax(l)=amax1(cmax(l),val)
            cmin(l)=amin1(cmin(l),val)
    3     continue
          denom=denom+1.0
    4   continue
    7 continue
c
      do 6 l=1,nzf
        cavg(l)=cavg(l)/denom
        icmax(l)=nint(cmax(l))
        icmin(l)=nint(cmin(l))
        icavg(l)=nint(cavg(l))
    6 continue
c
      write(*,3001) time,idate,(icmax(l),icmin(l),icavg(l),l=1,nzf)
 3001 format('rchemf',f10.2,i10,9i4,/,(25x,9i4))
c
c     extract date
c
      if (idate .lt. 100000) then
        call jtocal(idate,icdate)
        nyr=icdate/10000
        nmth=icdate/100-nyr*100
        nday=icdate-nmth*100-nyr*10000
      else
        nyr=idate/10000
        nmth=idate/100-nyr*100
        nday=idate-nmth*100-nyr*10000
      endif
      if (nyr .lt. 100) then
        if (nyr .lt. 51) then
          nyr = nyr + 2000
        else
          nyr = nyr + 1900
        endif
      endif
c
c%% optimization code
      dmin=1.e20
      dmax=-1.e20
      davg=0.0
      tmin=1.e20
      tmax=-1.e20
      tavg=0.0
      kntt=0
      rmax=-1.e20
      rmin=1.e20
      ravg=0.0
      kntr=0
c%%
c----------------------------------------
c
c     chemistry rates are set up in minutes
c
      ddtt = deltf(ifine) 
c
c     loop on grids
c
      do 100 j=2,nyf-1
        jrchem = j
        do 99 i=2,nxf-1
          irchem=i
          do 40 if1=1,numfin
            if (ifgptr(if1) .eq. ifine) then
              if (i .ge. ixff0(if1) .and. i .le. ixff1(if1)
     &            .and. j .ge. jyff0(if1) .and. j .le. jyff1(if1))
     &            go to 99
            endif
   40     continue
c
c         do chemistry in layer k
c
          hgtemp=0.
          do 90 k=1,nzf
            krchem=k
c
c...    need to get pressure from meteorology model.
c
            pcell=presf(i,j,k)
c%%%
c
c           calculate temperture dependent rates
c
            tcell=temprf(i,j,k)+tmpinc
            if (idiag .ne. 0) then
              if (i .eq. nxf/2 .and. j .eq. nyf/2) then
                write(*,*) ' i, j, k: ', i,j,k
              write(*,7002) tcell
 7002         format(' call tdrate',f10.1)
              endif
            endif
            call tdrate(nreact,tcell,pcell)
c
c           obtain current no2 photolysis rate factor for this height
c
c012595  height for calculation of photolysis rates should be
c012595  above ground rather than above sea level (tcm)
c012595     zavght=hgtemp+(1000.0*htf(i,j,k)-hgtemp)/2.+avterf(i,j)
            zavght=hgtemp+(1000.0*htf(i,j,k)-hgtemp)/2.
            hgtemp=1000.*htf(i,j,k)
c
            icrs = ixfb(ifine) + (i-2)/nhf(ifine)
            jcrs = jyfb(ifine) + (j-2)/nhf(ifine)
            if (idiag .ne. 0) then
              if (i .eq. nxf/2 .and. j .eq. nyf/2) then
              write(*,7001) i,j,zavght
 7001         format(' call phot',2i3,e12.4)
              endif
            endif
            call photf(nxf,nyf,nzf,ctlonf,ctlatf,cloudf,time,nyr,
     &                 nmth,nday,i,j,k,icrs,jcrs,zavght,factor,
     &                 ldark,ifine)
c%%%
            rmax=amax1(rmax,factor)
            rmin=amin1(rmin,factor)
            ravg=ravg+factor
            kntr=kntr+1
c
czswa-----------------------------------------------------------------
c  part of the old code is rewritten,
c
c     save the old concentration
c
            iflgf = iflagf(i,j,ifine)
            if (iflgf.gt.0) then
               do l=1,nospec
                  cold(l)=cncf(i,j,l,k)
               enddo
            endif
c
c     load layer-average concentrations into con array
c
            aam2c=cpfac*tcell/(273.*pcell)
            aac2m=pcell*273./(tcell*cpfac)
c
            do 10 l=1,nospec
              con(l)=cncf(i,j,l,k)*aam2c
   10       continue
c
            h2o=ch2of(i,j,k)
            cwc=cwatrf(i,j,k)
c
c     do chemistry
c
            if (idiag .ne. 0) then
              if (i .eq. nxf/2 .and. j .eq. nyf/2) then
              write(*,7011) k,i,j,ddtt,factor,ldark
 7011         format(' call step4 layer ',i2,' grid ',2i5,2e12.4,l5)
              write(*,7003) ddtt,h2o,factor,tcell,ldark,nutrc,con
 7003         format(' call step4',4e14.7,l5,i5,/,5(7e11.3))
              endif
            endif
c
c  load fine grid radical concentrations (dfg, 05/11/99)
c
            llx = i + nxf*(j-1) + nxf*nyf*(k-1)
            do ll=1,mxrads
              rcon(ll)=radconf(ll,ifine,llx)
            end do
c
            lcstop = .false.
            if (lchfast) then
              call step4f(nospec,nospec,ddtt,con,lerror,tcell,rcon,llpt,
     &                 2,iflgf,k,aac2m)
            else
              call step4(nospec,nospec,ddtt,con,lerror,tcell,rcon,llpt,
     &                 2,iflgf,k,aac2m)
            endif
            if (idiag .ne. 0) then
              if (i .eq. nxf/2 .and. j .eq. nyf/2) then
              write(*,7004)
 7004         format(' aft call step4')
              endif
            endif
            if (lerror) go to 810
	    if ( idiag .ne. 0 ) then
              if (i .eq. nxf/2 .and. j .eq. nyf/2) then
		write(*,*) ' dmax,dmin,davg,dtuse,kntt '
		write(*,*) dmax,dmin,davg,dtuse,kntt
		write(*,*) ' tmax,tmin,tavg,itmax '
		write(*,*) tmax,tmin,tavg,itmax
              endif
	    endif
            dmax=amax1(dmax,dtuse)
            dmin=amin1(dmin,dtuse)
            davg=davg+dtuse
            kntt=kntt+1
            tmax=amax1(tmax,float(itmax))
            tmin=amin1(tmin,float(itmax))
            tavg=tavg+itmax
	    if ( idiag .ne. 0 ) then
              if (i .eq. nxf/2 .and. j .eq. nyf/2) then
		write(*,*) ' dmax,dmin,davg,dtuse,kntt '
		write(*,*) dmax,dmin,davg,dtuse,kntt
		write(*,*) ' tmax,tmin,tavg,itmax '
		write(*,*) tmax,tmin,tavg,itmax
              endif
	    endif
c
c           load back into conc array
c
            do 20 l=1,nospec
              cncf(i,j,l,k)=con(l)*aac2m
   20       continue
c
c   load back into radical array. (5/12/99, dfg)
c
            do ll=1,mxrads
              radconf(ll,ifine,llx)=rcon(ll)
            end do
c
c           get the change in concentration
c
            if (iflgf.gt.0) then
               do l=1,nospec
                  cchemf(iflgf,l,k)=cchemf(iflgf,l,k)+
     &                              cncf(i,j,l,k)-cold(l)
               end do
            endif
c
czswz-------------------------------------------------------------------
c
c     end of loop on layers
c
   90     continue
c
c     end loop on grids
c
   99   continue
  100 continue
c
	    if ( idiag .ne. 0 ) then
              if (i .eq. nxf/2 .and. j .eq. nyf/2) then
		write(*,*) ' dmax,dmin,davg,dtuse,kntt '
		write(*,*) dmax,dmin,davg,dtuse,kntt
		write(*,*) ' tmax,tmin,tavg,itmax '
		write(*,*) tmax,tmin,tavg,itmax
              endif
	    endif
c
      davg=davg/float(kntt)
      tavg=tavg/float(kntt)
      write(*,3000) time,idate,deltf(ifine),ddtt,dmax,
     &              dmin,davg,tmax,tmin,tavg,kntt
 3000 format(f8.0,i10,f5.1,7e12.4,i15)
c
      ravg=ravg/float(kntr)
      write(*,3100) time,idate,rmax,rmin,ravg
 3100 format(f8.0,i10,' In rchemf, k1 range=',3e12.4)
      write(66,3000) time,idate,deltf(ifine),ddtt,dmax,
     &               dmin,davg,tmax,tmin,tavg,kntt   
      write(66,3100) time,idate,rmax,rmin,ravg
c%%%
c
c
      return
c
c     error in chemistry
c
  810 continue
      write(66,2810) k,i,j,factor,time,nyr,nmth,nday,zavght,con
      write(*,2810) k,i,j,factor,time,nyr,nmth,nday,zavght,con
      write(8,2810) k,i,j,factor,time,nyr,nmth,nday,zavght,con
      write(ierrlg,2812) 1096,k,i,j,factor,time,nyr,nmth,nday,zavght, 
     &        con
 2810 format(' $$error in chemistry layer ',i2,' grid',2i5,f10.4
     &,      f10.2,3i5,e12.4/1x,10e12.4/1x,10e12.4/1x,10e12.4)
 2812 format(i4,1x,' $$error in chemistry layer ',i2,' grid',2i5,f10.4
     &,      f10.2,3i5,e12.4/1x,10e12.4/1x,10e12.4/1x,10e12.4)
      write(66,2811) h2o,tcell,ddtt,ldark
 2811 format(3e12.4,l10)
      stop6
      end
