      subroutine shmidt(d,temp,sc)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: shmidt.f,v $
c  Revision 1.2  1994/02/10  21:00:15  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c**********************************************************************
c
c-----this routine estimates the schmidt number
c
c-----the input parameters are
c----- d = diameter of the particle in m
c----- temp = temperature of the particle (deg k)
c-----the output is
c----- sc = schmidt number
c
c**********************************************************************
c
      data a1,a2,a3,xmean,visc/1.257,0.40,0.55,6.53e-08,1.5e-05/
      data bk,xmu,vk/1.38e-16,1.83e-02,0.4/
      data rhoair,grav/1000.,9.81/
      cc=1.+(2*xmean/d)*(a1 + a2*exp(-a3*d/xmean))
      f = 9.42*xmu*d/cc
      dbrown = 1.0e-04*temp*bk/f
      sc = visc/dbrown
      return
      end
