      subroutine ssdark(contm,temper,presur,dt)
c
c     *** (c) Copr. 1992  Systems Applications, Intl.  San Rafael, CA
c
c$Log: ssdark.f,v $
c  Revision 1.7  2002/06/26  20:44:13  tcm
c  removed xo2n references
c
c  Revision 1.6  1999/09/25  00:18:05  tcm
c  This routine has been disabled until it is updated to CB-IV-TOX.
c
c  Revision 1.5  1998/11/20  23:10:13  tcm
c  Moved include of errlog.cmd to chem22 where it is needed.
c
c  Revision 1.4  1998/11/13  00:18:17  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error message to diag file and log file (ierrlg)
c  Second error message should be reviewed (some lines repeated (?))
c
c  Revision 1.3  1998/11/04  01:55:50  tcm
c  Eliminated duplicated variable declarations.
c
c  Revision 1.2  94/02/10  21:00:44  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c     compute steady-state concentrations of no, no2, no3 and o3
c     only at night by mathematical titration (of no)
c
c     calculate transformation of no2 to hno3 and nitrate
c     for one time step, dt
c
c  input arguments:
c                   contm  r  concentration array
c                   temper r  temperature at plume height (k)
c                   presur r  pressure at plume height (mb)
c                   dt     r  time step (hours)
c
c
c     called by:
c               dochem 
c
c     routines called: none
c
c
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'comchem2.cmd'
      dimension contm(mxspec)
      real nox
c
c  nighttime chemistry
c
      write(*,*) 'SSDARK disabled due to incompatibility with CB-IV-TOX'
      stop
c
c  set nxoy to 2*n2o5 + no3 + no + no2
      no=contm(kno)
      no2=contm(kno2)
      o3=contm(ko3)
      nxoy=contm(knxoy)+no+no2
c
c     calculate no3 concentration
c
c     nox = amax1(1.e-15,(nxoy-no-no2))
c     rxn = rk(17)*no2/(rk(18)*h2o+rk(19))
c     no3 = nox/(1.+2.*rxn)
c
c     for now, we will assume all nxoy proceeds through no3 to react with
c     no if little ozone is present, hence:
c
      no3 = amax1(1.e-9,(nxoy-no-no2))
c
      if (no.le.1.e-15) go to 200
      if ((no3+o3).le.2.e-9) go to 200
c
      ox = no3 + o3
      if (ox.ge.no) go to 100
        no = amax1((no-ox),1.e-15)
        no2 = no2 + 2.*no3 + o3
        o3 = 1.e-9
        no3 = 1.e-9
      go to 200
c
  100 frno3 = no3*rk(15)/(no3*rk(15)+o3*rk(3))
      fro3  = 1.-frno3
      dno3 = no*frno3
      do3  = no*fro3
      if ((no3-dno3).lt.1.e-9) then
        dno3 = no3-1.e-9                    
        do3  = no-dno3                      
      else if ((o3-do3).lt.1.e-9) then
        do3  = o3-1.e-9                   
        dno3 = no -do3                    
      endif
      no = 1.e-15
      o3 = amax1((o3-do3),1.e-9)
      no3 = amax1((no3-dno3),1.e-9)
      no2 = no2 + 2.*dno3 + do3
c
  200 continue
c
c
      contm(ko3)=o3
      contm(kno)=no
      contm(kno2)=no2
      contm(knxoy)=no+no2+no3
      cwc=0.0
      if(o3 .lt. no) then
c       call chm22s(contm,cwc,temper,presur,rpan,rhno3)
        go to 400
      else
        call chm23s(contm,cwc,temper,presur,rpan,rhno3)
      endif
      contm(knxoy) = amax1(contm(knxoy),1.e-9)
      fno=contm(kno)/contm(knxoy)
      fno2=contm(kno2)/contm(knxoy)
      fno3=(contm(knxoy)-contm(kno2)-contm(kno))
     &      /contm(knxoy)
      dhno3 = rhno3*dt
      dpan =rpan*dt
      if(rpan .gt. 0.0) then
        dtotal=dhno3+dpan
        if (dtotal.gt.contm(knxoy)) then
          dhno3=contm(knxoy)*rhno3/(rpan+rhno3)
          dpan=contm(knxoy)*rpan/(rpan+rhno3)
        endif 
        dtotal=dhno3+dpan
        contm(knxoy)=contm(knxoy)-dtotal
        contm(kpan)=contm(kpan)+dpan
      else
        dtotal=dhno3
        dpan=-dpan
        dpan=amin1(dpan,contm(kpan))
        contm(kpan)=contm(kpan)-dpan
        contm(knxoy)=contm(knxoy)+dpan
        if (dtotal.gt.contm(knxoy)) dhno3=contm(knxoy)
        dtotal=dhno3
        contm(knxoy)=contm(knxoy)-dtotal
      endif
      if(contm(knxoy) .lt. 0.0) contm(knxoy)=0.0
      if(contm(kpan ) .lt. 0.0) contm(kpan )=0.0
      contm(khno3)=contm(khno3)+dhno3
      contm(kno)=fno*contm(knxoy)
      contm(kno2)=fno2*contm(knxoy)
      contm(knxoy)=fno3*contm(knxoy)
c
  400 return
      end
c
      subroutine chm22s (hh,cwc,temp,pres,rpan,rhno3)
c
c     *** (c) copr. 1992  systems applications, inc.  san rafael, ca
c
c
c    -----------------------------------
c    nighttime, excess no (no o3 or no3)
c    -----------------------------------
c
c--routines called
c         eqlbrm
c         achem
c
c--called by
c         ssdark
c
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'comchem2.cmd'
      include 'errlog.cmd'
      dimension r(250), rate(mxspec)

      dimension  hh(mxspec)
      dimension  rx(250), x(100), xr(100), ar(250)
      real khoh,khho2,ko2n
      real no3, n2o5
  101 format(' in chem22')
      xtol = 0.01
      lss = .true.
      nitmax = 50
c *********************************************************************
c          input of gas-phase concentration data--ppm units
c *********************************************************************
c  clear sky concentrations
      no   = hh(kno  )
      no2  = hh(kno2 )
      ole  = hh(kole )
      par  = hh(kpar )
      tol  = hh(ktol )
      xyl  = hh(kxyl )
      form = hh(khcho)
      pan  = hh(kpan )
      hno3 = hh(khno3)
      acet = hh(kacet)
      eth  = hh(keth )
      cres = hh(kcres)
      mgly = hh(kmgly)
      open = hh(kopen)
      pna  = hh(kpna )
      co   = hh(kco  )
      hno2 = hh(khno2)
      h2o2 = hh(kh2o2)
      isop = 0.
      if (lisop) isop = hh(kisop)
      so2  = 0.
      meoh = 0.
      if (lso2)     so2  = hh(ksiv )
      if (lmeoh)    meoh = hh(kmeoh)
c
  200 continue
      no2= amax1(no2,1.e-8)
c7/90 no = amax1(no,1.e-6)
      do 40 i=1,250
        r(i) = 0.
        rx(i) = 0.
        ar(i)=0.0
   40 continue
      r(20)= rk(20)*no*no
      r(21)= rk(21)*no*no2*h2o
      r(25)= rk(25)*hno2*hno2
      r(30)= rk(30)*pna
      r(48)= rk(48)*pan
      r(83)= rk(83)*so2
      rx(22)= rk(22)*no
      rx(24)= rk(24)*hno2
      rx(26)= rk(26)*no2
      rx(27)= rk(27)*hno3
      rx(28)= rk(28)*no
      rx(29)= rk(29)*no2
      rx(31)= rk(31)*pna
      rx(32)= rk(32)
      rx(33)= rk(33)*h2o
      rx(35)= rk(35)*h2o2
      rx(36)= rk(36)*co
      rx(37)= rk(37)*form
      rx(43)= rk(43)*acet
      rx(46)= rk(46)*no
      rx(47)= rk(47)*no2
      rx(49)= rk(49)
      rx(50)= rk(50)
      rx(51)= rk(51)
      rx(52)= rk(52)*par
      rx(53)= rk(53)
      rx(54)= rk(54)
      rx(55)= rk(55)*no2
      rx(57)= rk(57)*ole
      rx(61)= rk(61)*eth
      rx(63)= rk(63)*tol
      rx(64)= rk(64)*no
      rx(65)= rk(65)
      rx(66)= rk(66)*cres
      rx(68)= rk(68)*no2
      rx(70)= rk(70)*open
      rx(72)= rk(72)*xyl
      rx(73)= rk(73)*mgly
      rx(76)= rk(76)*isop
      rx(79)= rk(79)*no
      rx(80)= rk(80)
      rx(82)= rk(82)*so2
      rx(84)= rk(84)*meoh
      rx(85)= rk(85)
      rx(86)= rk(86)
      rx(87)= rk(87)
      rx(88)= rk(88)
      do 110 i = 1,100
        xr(i) = amax1(rx(i),0.)
        x(i)  = amax1(r(i),0.)
  110 continue
c
c   if clouds are present, calculate diffusion parameters for
c   mass transfer
c     if(cwc.lt.cwcmin) then
      convt = 0.
      kgln25 = 0.
      kglho2 = 0.
      klgho2 = 0.
      kgloh = 0.
      klgoh = 0.
c     end if
c
  165 continue
      to2r = xr(64) + xr(65)
      to2oh = 0.56*xr(63) + 0.30*xr(72)
      f64 = xr(64)/to2r
      f65 = 1.-f64
      xr(64) = to2oh*f64
      xr(65) = to2oh*f65
      rorr = xr(53) + xr(54)+ xr(55)
      f53 = xr(53)/rorr
      f54 = xr(54)/rorr
      f55 = xr(55)/rorr
      xr(53) = 0.76*xr(52)*f53
      xr(54) = 0.76*xr(52)*f54
      xr(55) = 0.76*xr(52)*f55
      ohho2 = xr(35)+xr(36)+xr(37)+xr(51)+xr(52)+xr(57)+xr(61)
     &       +xr(63)+xr(66)+xr(70)+xr(72)+xr(76)+xr(82)+xr(84)
     &       +xr(91)+xr(92)
      ohrx = xr(22)+xr(24)+xr(26)+xr(27)+xr(31)+xr(43)+xr(73)
      ohr = ohho2 + ohrx + kgloh
      c2o3r = xr(46) + xr(47)
      c2o3oh = xr(43) + xr(70) + xr(73) + 0.2*xr(76)
      ho2r = xr(28) + xr(29) + kglho2
      ho2oh  = xr(35)+xr(36)+xr(37)+xr(51)+0.11*xr(52)
     &       +xr(57)+xr(61)+0.44*xr(63)+0.6*xr(66)+2.*xr(70)
     &       +0.7*xr(72)+0.67*xr(76) + xr(82) +xr(84) +xr(91)
     &       + 0.61*xr(92) +0.94*xr(53) +xr(54) +0.9*xr(64) +xr(65)
      xo2oh = xr(51) + 0.87*xr(52) + xr(57) + xr(61) + 0.08*xr(63)
     &      + 0.60*xr(66) + xr(70) + 0.5*xr(72) + xr(73) + xr(76)
     &      + 0.96*xr(53) + 0.61*xr(92)
      xo21 = oh*xo2oh + c2o3*(xr(46)+2.*c2o3*xr(49)+0.33*ho2*xr(50))
      if(oh.ge.1.0e-19) go to 33
      aa = 2.0*xr(49)
      bb = c2o3r
      cc = -x(48)
      bbcc = bb**2 - 4.*aa*cc
      ispot = 1
      if(bbcc.lt.0.) go to 2000
      c2o3 = -2*cc/(bb+sqrt(bbcc))
      c2o3 = amax1(c2o3,1.e-12)
      c2o3 = amin1(c2o3,1.e-6)
      aa = 2.0*(xr(32) + xr(33))
      bb = ho2r + 0.67*c2o3*xr(50) -
     &             ho2oh*(xr(28) + c2o3*0.33*xr(50))/ohr
      cc = -(x(30) + c2o3 *(xr(46) + 2.0*c2o3*xr(49))
     &     + klgho2*aho2t*convt)
      bbcc = bb**2 - 4.*aa*cc
      ispot = 2
      if(bbcc.lt.0.) go to 2000
      ho2 = -2*cc/(bb+sqrt(bbcc))
      ho2 = amax1(ho2,1.e-10)
      ho2 = amin1(ho2,1.e-6)
      oh = (ho2*(xr(28) + c2o3*0.33*xr(50))+klgoh*aoh*convt)/
     & (ohr+ho2*xr(88))
      oh = amax1(oh,1.e-12)
      oh = amin1(oh,2.e-7)
      xo21 = oh*xo2oh + c2o3*(xr(46)+2.*c2o3*xr(49)+0.33*ho2*xr(50))
      xo2 = xo21/(xr(79) + c2o3*xr(87) + ho2*xr(85))
   33 liter = 0
   34 continue
      poh   = oh
      pc2o3 = c2o3
      pho2  = ho2
      pxo2  = xo2
      oh = (ho2*(xr(28) + c2o3*0.33*xr(50)))/(ohr+ho2*rx(88))
      aa = 2.0*xr(49)
      bb = xr(47) + ho2*xr(50) + xo2*(xr(86)+xr(87))
      cc = -(x(48) + oh*c2o3oh)
      bbcc = bb**2 - 4.*aa*cc
      ispot = 3
      if(bbcc.lt.0.) go to 2000
      c2o3 = -2*cc/(bb+sqrt(bbcc))
      aa = 2.0*(xr(32)+xr(33))
      bb = ho2r + 0.67*c2o3*xr(50) + oh*xr(88) + 2.*xo2*xr(85)
      cc = -(x(30) + c2o3 *(2.0*c2o3*xr(49) + xr(46) +
     &       xo2*(xr(86) + xr(87))))
      bbcc = bb**2 - 4.*aa*cc
      ispot = 4
      if(bbcc.lt.0.) go to 2000
      ho2 = -2*cc/(bb+sqrt(bbcc))
      xo21 = oh*xo2oh + c2o3*(xr(46)+2.*c2o3*xr(49)+0.33*ho2*xr(50))
      aa = 2.*xr(80)
      bb = xr(79) + c2o3*xr(87) + ho2*xr(85)
      cc = -xo21
      bbcc = bb**2 - 4.*aa*cc
      ispot = 5
      if(bbcc.lt.0.) go to 2000
      xo2 = -2*cc/(bb+sqrt(bb*bb-4*aa*cc))
      liter = liter + 1
      if(liter.gt.nitmax) goto 290
      test = (oh-poh)/oh
      if (abs(test).gt.xtol) go to 34
      test = (c2o3-pc2o3)/c2o3
      if (abs(test).gt.xtol) go to 34
      test = (ho2-pho2)/ho2
      if (abs(test).gt.xtol) go to 34
      test = (xo2-pxo2)/xo2
      if (abs(test).gt.xtol) go to 34
  601 format(' oh=',e10.3,' ho2=',e10.3,' c2o3=',e10.3,' xo2=',e10.3)
      if (xr(68).le.0.) cro = 1.e-9
      if (xr(68).gt.0.) cro = 0.4*oh*xr(66) / xr(68)
      rx(53) = xr(53)
      rx(54) = xr(54)
      rx(55) = xr(55)
      rx(64) = xr(64)
      rx(65) = xr(65)
c ********************************************************************
c  if clouds are present, and temp > 260 call achem
      kgln25 = 0.
      n2o5 = 0.
c ********************************************************************
      r(22) = rx(22)*oh
      r(24) = rx(24)*oh
      r(26) = rx(26)*oh
      r(27) = rx(27)*oh
      r(28) = rx(28)*ho2
      r(29) = rx(29)*ho2
      r(31) = rx(31)*oh
      r(32) = rx(32)*ho2*ho2
      r(33) = rx(33)*ho2*ho2
      r(35) = rx(35)*oh
      r(36) = rx(36)*oh
      r(37) = rx(37)*oh
      r(43) = rx(43)*oh
      r(46) = rx(46)*c2o3
      r(47) = rx(47)*c2o3
      r(49) = rx(49)*c2o3*c2o3
      r(50) = rx(50)*c2o3*ho2
      r(51) = rx(51)*oh
      r(52) = rx(52)*oh
      r(53) = rx(53)*oh
      r(54) = rx(54)*oh
      r(55) = rx(55)*oh
      r(57) = rx(57)*oh
      r(61) = rx(61)*oh
      r(63) = rx(63)*oh
      r(64) = rx(64)*oh
      r(65) = rx(65)*oh
      r(66) = rx(66)*oh
      r(68) = rx(68)*cro
      r(70) = rx(70)*oh
      r(72) = rx(72)*oh
      r(73) = rx(73)*oh
      r(76) = rx(76)*oh
      r(79) = rx(79)*xo2
      r(80) = rx(80)*xo2*xo2
      r(82) = rx(82)*oh
      r(84) = rx(84)*oh
      r(85) = rx(85)*xo2*ho2
      r(86) = rx(86)*c2o3*xo2
      r(87) = rx(87)*c2o3*xo2
c     r(88) = rx(88)*oh*ho2
      r(91) = rx(91)*oh
      r(92) = rx(92)*oh
      rate(khno2) = 2.0*r(21) + r(22) -r(24) - 2.0*r(25)
      rate(khno3) = r(26) - r(27)
      rate(kpan) = r(47)-r(48)
      if (lnitr) then
        rate(knitr) = r(55) + 0.1*r(64) + r(68)
      endif
  900 rpan=rate(kpan)
      rhno3=rate(khno3)
      hh(kno  )=no
      hh(kno2 )=no2
      hh(ko3  )=o3
      hh(knxoy)=nxoy
      hh(kpan )=pan
      hh(khno3)=hno3
      return
c -----errors-----
  290 write(*,210) oh,ho2,xo2,c2o3
      write(8,210) oh,ho2,xo2,x2o3
      write(ierrlg,213) 1116,oh,ho2,xo2,x2o3
  210 format(1x,'*** error in radical concentration calc in chem22',/,
     &       ' oh=',e10.3,' ho2=',e10.3,' xo2=',e10.3,' c2o3=',e10.3)
  213 format(i4,2x,'*** error in radical concentration calc in',
     &       ' chem22',/,' oh=',e10.3,' ho2=',e10.3,' xo2=',e10.3,
     &        ' c2o3=',e10.3)
      stop
 2000 write(*,2010) ispot,aa,bb,cc,bbcc
      write(*,2015) xr(32), xr(33), ho2r,c2o3,xr(50),
     &             ho2oh,xr(28),ohr,
     &             x(30),xr(46),xr(49),
     &             klgho2,aho2t,convt
 2010 format(' sqrt argument negative in chem22 at location ',i4,/,
     &       ' aa=',e10.3,' bb=',e10.3,' cc=',e10.3,' bbcc=',e10.3)
 2015 format('      xr(32), xr(33), ho2r,c2o3,xr(50),',/,
     &       '     ho2oh,xr(28),ohr,',/,
     &       '     x(30),xr(46),xr(49),',/,
     &       '     klgho2,aho2t,convt',/,
     &       5x,5e14.7,/,5x,3e14.7,/,5x,3e14.7,/,5x,3e14.7)
      stop
c----------------------------------------------------------------------
      end
      subroutine chm23s (hh,cwc,temp,pres,rpan,rhno3)
c
c     *** (c) copr. 1992  systems applications, inc.  san rafael, ca
c
c     -------------------------------------
c     nighttime -- excess oxidants -- no no
c     -------------------------------------
c    
c     ---  added line to reevaluate nxoy when no3 and n2o5 are
c          recalculated (before line 30) (mpl,tcm, 11/6/91)
c
c--routines called
c         eqlbrm
c         achem
c--called by
c         ssdark
c
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'comchem2.cmd'
      dimension r(250), rate(mxspec)
c
      logical lin
      dimension  hh(mxspec)
      dimension  rx(250), x(100), xr(100), ar(250)
      real khoh,khho2,ko2n
      real no3r,noxs
      real no3, n2o5
c
      xtol = 0.01
      lss = .false.
      lin = .false.
      nitmax = 50
c *********************************************************************
c          input of gas-phase concentration data--ppm units
c *********************************************************************
c  clear sky concentrations
      no2  = hh(kno2 )
      o3   = hh(ko3  )
      ole  = hh(kole )
      par  = hh(kpar )
      tol  = hh(ktol )
      xyl  = hh(kxyl )
      form = hh(khcho)
      acet = hh(kacet)
      eth  = hh(keth )
      cres = hh(kcres)
      mgly = hh(kmgly)
      open = hh(kopen)
      pna  = hh(kpna )
      nxoy = hh(knxoy)
      pan  = hh(kpan )
      co   = hh(kco  )
      hno2 = hh(khno2)
      h2o2 = hh(kh2o2)
      hno3 = hh(khno3)
      so2  = 0.
      meoh = 0.
      isop = 0.
      if (lisop)    isop = hh(kisop)
      if (lso2)     so2  = hh(ksiv )
      if (lmeoh)    meoh = hh(kmeoh)
  200 continue
      noxdum = amax1(1.e-15,(nxoy-no2))
      no2 = amax1(no2,1.e-8)
      do 40 i=1,250
        r(i) = 0.
        rx(i) = 0.
        ar(i)=0.0
   40 continue
      r(7) = rk( 7)*no2*o3
      r(25)= rk(25)*hno2*hno2
      r(30)= rk(30)*pna
      r(48)= rk(48)*pan
      r(58)= rk(58)*o3*ole
      r(62)= rk(62)*o3*eth
      r(71)= rk(71)*open*o3
      r(77)= rk(77)*isop*o3
c      r(83)= rk(83)*so2
      rx(12)= rk(12)*o3
      rx(13)= rk(13)*o3
      rx(16)= rk(16)*no2
      rx(17)= rk(17)*no2
      rx(18)= rk(18)*h2o
      rx(19)= rk(19)
      rx(24)= rk(24)*hno2
      rx(26)= rk(26)*no2
      rx(27)= rk(27)*hno3
      rx(29)= rk(29)*no2
      rx(31)= rk(31)*pna
      rx(32)= rk(32)
      rx(33)= rk(33)*h2o
      rx(35)= rk(35)*h2o2
      rx(36)= rk(36)*co
      rx(37)= rk(37)*form
      rx(41)= rk(41)*form
      rx(43)= rk(43)*acet
      rx(44)= rk(44)*acet
      rx(47)= rk(47)*no2
      rx(49)= rk(49)
      rx(50)= rk(50)
      rx(51)= rk(51)
      rx(52)= rk(52)*par
      rx(53)= rk(53)
      rx(54)= rk(54)
      rx(55)= rk(55)*no2
      rx(57)= rk(57)*ole
      rx(59)= rk(59)*ole
      rx(61)= rk(61)*eth
      rx(63)= rk(63)*tol
      rx(66)= rk(66)*cres
      rx(67)= rk(67)*cres
      rx(68)= rk(68)*no2
      rx(70)= rk(70)*open
      rx(72)= rk(72)*xyl
      rx(73)= rk(73)*mgly
      rx(76)= rk(76)*isop
      rx(78)= rk(78)*isop
      rx(80)= rk(80)
      rx(82)= rk(82)*so2
      rx(84)= rk(84)*meoh
      rx(85)= rk(85)
      rx(86)= rk(86)
      rx(87)= rk(87)
      rx(88)= rk(88)
      do 10 i = 1,100
        xr(i) = amax1(rx(i),0.)
        x(i)  = amax1(r(i) ,0.)
   10 continue
c
c   if clouds are present, calculate diffusion parameters for
c   mass transfer
c     if(cwc.lt.cwcmin) then
      convt = 0.
      kgln25 = 0.
      kglho2 = 0.
      klgho2 = 0.
      kgloh = 0.
      klgoh = 0.
c     end if
c
  165 continue
      if (noxdum.lt.1.e-6) go to 22
      if (noxdum.ge.(1.e-2*no2))  lin=.true.
      if (lin) go to 20
   22 no3r = xr(16) +xr(17) +xr(41) +xr(44) +xr(59) +xr(67) +xr(78)
      rxn = xr(17)/(xr(18)+xr(19)+kgln25)
      no3 = x(7)/(no3r -rxn*xr(19))
      no3 = amax1(no3,1.e-12)
      n2o5 = no3*rxn
      n2o5 = amax1(n2o5,1.e-12)
      noxs = no3 + 2.*n2o5
      if (noxs.lt.1.e-6) go to 28
      if (noxs.ge.(1.e-2*no2))  go to 20
   28 lss = .true.
      go to 30
   20 continue
      rxn = xr(17)/(xr(18)+xr(19)+kgln25)
      fno3  = 1. /(1.+2.*rxn)
      fn2o5 = rxn/(1.+2.*rxn)
      no3  = fno3*noxdum
      n2o5 = fn2o5*noxdum
      nxoy = no + no2 + no3 + 2.*n2o5
   30 continue
      rorr = xr(53) + xr(54)+ xr(55)
      f53 = xr(53)/rorr
      f54 = xr(54)/rorr
      f55 = xr(55)/rorr
      xr(53) = 0.76*xr(52)*f53
      xr(54) = 0.76*xr(52)*f54
      xr(55) = 0.76*xr(52)*f55
      ohho2s = xr(12)+xr(35)+xr(36)+xr(37)+xr(51)+xr(52)+xr(57)
     &       +xr(61)+xr(63)+xr(66)+xr(70)+xr(72)+xr(76)+xr(82)+xr(84)
     &       +xr(91)+0.61*xr(92)
      ohrx = xr(24)+xr(26)+xr(27)+xr(31)+xr(43)+xr(73) + kgloh
      ohr = ohho2s + ohrx
      ohs1  = 0.1*x(58) + 0.08*x(71) + 0.1*x(77) + klgoh*aoh*convt
      c2o3s  = no3*xr(44)  + x(48)  + 0.62*x(71)
      c2o3oh = xr(43) + xr(70) + xr(73) + 0.2*xr(76)
      ho2r = xr(13) + xr(29) + kglho2
      ho2s   = x(30)+0.44*x(58)+0.12*x(62)+0.76*x(71)+0.44*x(77)
     &         +no3*xr(41) + klgho2*aho2t*convt
      ho2oh  = xr(12)+xr(35)+xr(36)+xr(37)+xr(51)+0.11*xr(52)
     &       +xr(57)+xr(61)+xr(63)+0.6*xr(66)+2.*xr(70)
     &       +0.7*xr(72)+0.67*xr(76) + xr(82) + xr(84) + 0.94*xr(53)
     &       + xr(54) + xr(91) +0.61*xr(92)
      xo2s = 0.22*x(58) + 0.03*x(71) + 0.91*no3*xr(59)
      xo2oh = xr(51) + 0.87*xr(52) + xr(57) + xr(61) + 0.08*xr(63)
     &      + 0.60*xr(66) + xr(70) + 0.50*xr(72) + xr(73) + xr(76)
     &      + 0.96*xr(53) + 0.61*xr(92)
      if(oh.ge.1.0e-19) go to 33
      oh = 1.e-08
      aa = 2.*xr(49)
      bb = xr(47)
      cc = -(c2o3s + oh*c2o3oh)
      bbcc = bb**2 - 4.*aa*cc
      if(bbcc.lt.0.) go to 2000
      c2o3 = -2.*cc/(bb+sqrt(bbcc))
      c2o3 = amax1(c2o3,1.e-10)
      c2o3 = amin1(c2o3,1.e-4)
      aa = 2.0*(xr(32)+xr(33))
      bb = ho2r + 0.67*c2o3*xr(50)
      cc = -(ho2s + ho2oh*oh + 2.0*c2o3*c2o3*xr(49))
      bbcc = bb**2 - 4.*aa*cc
      if(bbcc.lt.0.) go to 2000
      ho2 = -2.*cc/(bb+sqrt(bbcc))
      ho2 = amax1(ho2,1.e-10)
      ho2 = amin1(ho2,1.e-4)
      xo21 = xo2s + oh*xo2oh + c2o3*(2*c2o3*xr(49) + 0.33*ho2*xr(50))
      aa = 2.*xr(80)
      bb = c2o3*xr(87) + ho2*xr(85)
      cc = -xo21
      bbcc = bb**2 - 4.*aa*cc
      if(bbcc.lt.0.) go to 2000
      xo2 = -2.*cc/(bb+sqrt(bbcc))
      xo2 = amax1(xo2,1.e-12)
      xo2 = amin1(xo2,5.e-4)
   33 continue
      liter = 0
   34 continue
      poh   = oh
      pc2o3 = c2o3
      pho2  = ho2
      pxo2  = xo2
      oh = (ohs1 + ho2*(xr(13) + c2o3*0.33*xr(50)))/(ohr+ho2*rx(88))
      aa = 2.0*xr(49)
      bb = xr(47) + ho2*xr(50) + xo2*(xr(86)+xr(87))
      cc = -(c2o3s + oh*c2o3oh)
      bbcc = bb**2 - 4.*aa*cc
      if(bbcc.lt.0.) go to 2000
      c2o3 = -2.*cc/(bb+sqrt(bbcc))
      aa = 2.0*(xr(32)+xr(33))
      bb = ho2r + 0.67*c2o3*xr(50) + oh*xr(88) + 2.*xo2*xr(85)
      cc = -(ho2s + oh*ho2oh + c2o3*(2.*c2o3*xr(49)
     &      + xo2*(xr(86) + xr(87))))
      bbcc = bb**2 - 4.*aa*cc
      if(bbcc.lt.0.) go to 2000
      ho2 = -2.*cc/(bb+sqrt(bbcc))
      xo21 = xo2s + oh*xo2oh + c2o3*(2*c2o3*xr(49) + 0.33*ho2*xr(50))
      aa = 2.*xr(80)
      bb = c2o3*xr(87) + ho2*xr(85)
      cc = -xo21
      bbcc = bb**2 - 4.*aa*cc
      if(bbcc.lt.0.) go to 2000
      xo2 = -2.*cc/(bb+sqrt(bbcc))
      liter = liter + 1
      if(liter.gt.nitmax) goto 290
      test = (oh-poh)/oh
      if (abs(test).gt.xtol) go to 34
      test = (c2o3-pc2o3)/c2o3
      if (abs(test).gt.xtol) go to 34
      test = (ho2-pho2)/ho2
      if (abs(test).gt.xtol) go to 34
      test = (xo2-pxo2)/xo2
      if (abs(test).gt.xtol) go to 34
      if (xr(68).le.0.) cro = 1.e-9
      if (xr(68).gt.0.) cro = (no3*xr(67) + 0.4*oh*xr(66))/ xr(68)
      rx(53) = xr(53)
      rx(54) = xr(54)
      rx(55) = xr(55)
      r(12) = rx(12)*oh
      r(13) = rx(13)*ho2
      r(16) = rx(16)*no3
      r(17) = rx(17)*no3
      r(18) = rx(18)*n2o5
      r(19) = rx(19)*n2o5
      r(24) = rx(24)*oh
      r(26) = rx(26)*oh
      r(27) = rx(27)*oh
      r(29) = rx(29)*ho2
      r(31) = rx(31)*oh
      r(32) = rx(32)*ho2*ho2
      r(33) = rx(33)*ho2*ho2
      r(35) = rx(35)*oh
      r(36) = rx(36)*oh
      r(37) = rx(37)*oh
      r(41) = rx(41)*no3
      r(43) = rx(43)*oh
      r(44) = rx(44)*no3
      r(47) = rx(47)*c2o3
      r(49) = rx(49)*c2o3*c2o3
      r(50) = rx(50)*c2o3*ho2
      r(51) = rx(51)*oh
      r(52) = rx(52)*oh
      r(53) = rx(53)*oh
      r(54) = rx(54)*oh
      r(55) = rx(55)*oh
      r(57) = rx(57)*oh
      r(59) = rx(59)*no3
      r(61) = rx(61)*oh
      r(63) = rx(63)*oh
      r(66) = rx(66)*oh
      r(67) = rx(67)*no3
      r(68) = rx(68)*cro
      r(70) = rx(70)*oh
      r(72) = rx(72)*oh
      r(73) = rx(73)*oh
      r(76) = rx(76)*oh
      r(78) = rx(78)*no3
c      r(80) = rx(80)*xo2*xo2
      r(82) = rx(82)*oh
      r(84) = rx(84)*oh
      r(85) = rx(85)*xo2*ho2
      r(86) = rx(86)*xo2*c2o3
      r(87) = rx(87)*xo2*c2o3
c      r(88) = rx(88)*oh*ho2
      r(91) = rx(91)*oh
      r(92) = rx(92)*oh
      if (lss) go to 80
      rate(khno2) = -r(24) - 2.0*r(25)
      rate(khno3) = 2.*r(18) + r(26) + r(41) + r(44) + r(67) - r(27)
      rate(kpan) = r(47)-r(48)
      rpos = r(24) +2.*r(25) +r(27) +r(30) +r(31) +r(48)
      rneg = 2.*r(18) +r(26) +r(29) +r(41) +r(44)
     &       +r(47) +r(55) +r(67) +r(68) +r(78)
      rate(knxoy) = rpos-rneg
      if(.not.lnitr) go to 75
      rate(knitr) = r(55) + r(68) + r(78)
   75 continue
      go to 900
c   ----------------------------
c   come here if in steady-state
c   ----------------------------
   80 continue
      rate(khno2) = -r(24) - 2.0*r(25)
      rate(khno3) = 2.*r(18) + r(26) + r(41) + r(44) + r(67) - r(27)
      rate(kpan) = r(47)-r(48)
      go to 900
  900 rpan=rate(kpan)
      rhno3=rate(khno3)
      hh(kno  )=no
      hh(kno2 )=no2
      hh(ko3  )=o3
      hh(knxoy)=nxoy
      hh(kpan )=pan
      hh(khno3)=hno3
      return
c---errors-----------------------------------------------------------
  290 write(*,210) oh,ho2,xo2,c2o3
      write(*,778)no3,n2o5,rxn
      write(*,779)aa,bb,cc,c2o3
      write(*,781)aa,bb,cc,xo2
      Write(*,780)aa,bb,cc,ho2
      write(*,333) oh,ho2,c2o3,xo2
      write(*,777)no3,n2o5,noxs
      write(*,*) ' rorr = ', rorr
  210 format(1x,'*** error in radical concentration calc in chem23',/,
     &       ' oh=',e10.3,' ho2=',e10.3,' xo2=',e10.3,' c2o3=',e10.3)
      write(*,212) cwc, temp, pres
  212 format(' cwc=',e12.4,' temp=',e12.4,' pres=',e12.4)
      write(*,211) (i,hh(i),i=1,mxspec)
  211 format(' hh ',i5,5x,1pe15.5)
  778 format(' lg nox no3',e10.3,' n2o5',e10.3,' rxn=',e10.3)      
  779 format(' aa:',e10.3,' bb:',e10.3,' cc:',e10.3,' c2o3:',e10.3)  
  781 format(' aa:',e10.3,' bb:',e10.3,' cc:',e10.3,' xo2:',e10.3)   
  780 format(' aa:',e10.3,' bb:',e10.3,' cc:',e10.3,' ho2:',e10.3)   
  333 format(4e11.4)                                                 
  777 format(' sm noxdum no3',e10.3,' n2o5',e10.3,' noxs',e10.3)     
      stop
 2000 write(*,2010) aa,bb,cc,bbcc
 2010 format(' sqrt argument negative in chem23'/,
     &       ' aa=',e10.3,' bb=',e10.3,' cc=',e10.3,' bbcc=',e10.3)
      stop
c----------------------------------------------------------------------
      end
