      subroutine ssday (contm,temper,presur,dt)
c
c     *** (c) Copr. 1992  Systems Applications, Intl.  San Rafael, CA
c
c$Log: ssday.f,v $
c  Revision 1.8  1999/12/21  21:09:19  tcm
c  Cleaned up some format statements.
c
c  Revision 1.7  1999/09/25  00:18:13  tcm
c  This routine has been disabled until it is updated to CB-IV-TOX.
c
c  Revision 1.6  1998/11/20  23:10:52  tcm
c  Moved include of errlog.cmd to chem22 where it is needed.
c  Put statement label on format at line 1199.
c
c  Revision 1.5  1998/11/16  21:13:55  ara
c  Introduced reference and code number to error message
c
c  Revision 1.4  1998/11/13  18:11:37  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error message to diag file and to log file (ierrlg)
c
c  Revision 1.3  1996/06/14  23:05:06  tcm
c  changed index nitr to initr to avoid conflict with
c  float value nitr.
c
c  Revision 1.2  1994/02/10  21:00:50  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c     ***  this subroutine calculates basic steady-state photochemical
c          cycle of no2, no, and o3
c
c     ***  calculate transformation of nox to pan, hno3 and nitrate
c          for one time step, dt
c
c
c--input variables
c         contm     r  concentration vector (ppm)
c         temper    r  temperature at plume height (k)
c         presur    r  pressure at plume height (mb)
c         dt        r  time step (hours)
c
c--output variables
c         contm     r  new concentrations
c
c
      include 'parchm.cmd' 
      include 'comchem.cmd' 
      include 'comchem2.cmd' 
c
      dimension  contm(mxspec)
      real nox 
c
c     daytime chemistry
c
      write(*,*) 'SSDAY disabled due to incompatibility with CB-IV-TOX'
      stop
c
      cwc=0.0
      idiag=0
c
      if(oh.lt.1.0e-19) then
        initr=1
        dtsb=dt/float(initr)
      else
        initr=1
        dtsb=dt
      endif
c 
      do 337 iitr=1,initr
c***********************************************************************
c
c
c     *** initialize rk(1) terms to zero
c
        adda = 0.
        addb = 0.
c
c------------------------------------------------------------------------
c
c
c     *** calculate steady state concentrations for no no2 and ozone
c
c
        adda = rk(1)/rk(3)
        addb = contm(kno2)*adda
c
        facta = contm(kno) + contm(ko3) + adda
        factb = contm(kno)*contm(ko3) - addb
        factc = facta * facta  - 4.*factb
c
c     *** check to insure factc positive
c
        if (factc .lt. 0.) factc = 0.
c
        dcon = (-facta + sqrt(factc))/2.
c
c     *** calculate no, no2 and o3 concentrations
c         dont allow them to get below lower bound
c
        contm(kno ) = amax1(contm(kno ) + dcon, bdnl(kno ))
        contm(kno2) = amax1(contm(kno2) - dcon, bdnl(kno2))
        contm(ko3 ) = amax1(contm(ko3 ) + dcon, bdnl(ko3 ))
c
c  set nxoy to 2*n2o5 + no3 + no + no2
c
        contm(knxoy) = contm(knxoy) + contm(kno) + contm(kno2)
c
c
  200   continue
c
        call chems(contm,cwc,temper,presur,idiag,rpan,rhno3)
        contm(knxoy) = amax1(contm(knxoy),1.e-9)
        fno2=contm(kno2)/contm(knxoy)
        fno=contm(kno)/contm(knxoy)
        fno3=(contm(knxoy)-contm(kno)-contm(kno2))
     &      /contm(knxoy)
c
        chno3=rhno3*dtsb
        cpan=rpan*dtsb
        if(rpan .gt. 0.0) then
          ctotal=chno3+cpan
          if (ctotal.gt.contm(knxoy)) then 
            chno3=rhno3/(rhno3+rpan)*contm(knxoy)
            cpan=rpan/(rhno3+rpan)*contm(knxoy)
          endif
          ctotal=chno3+cpan
          contm(knxoy)=contm(knxoy)-ctotal
          contm(kpan )=contm(kpan )+cpan
        else
          ctotal=chno3
          cpan=-cpan
          cpan=amin1(cpan,contm(kpan))
          contm(knxoy)=contm(knxoy)+cpan
          if (ctotal.gt.contm(knxoy)) chno3=contm(knxoy)
          ctotal=chno3
          contm(knxoy)=contm(knxoy)-ctotal
          contm(kpan )=contm(kpan )-cpan
        endif
        if (contm(knxoy).lt.0.) contm(knxoy)=0.0
        if (contm(kpan ).lt.0.) contm(kpan )=0.0
        contm(khno3)=contm(khno3)+chno3
        contm(kno)=fno*contm(knxoy)
        contm(kno2)=fno2*contm(knxoy)
        contm(knxoy)=fno3*contm(knxoy)
c
  337 continue
c
      return
      end
      subroutine chems (hh,cwc,temp,pres,idiag,rpan,rhno3)
c
c               -------
c               daytime
c               -------
c
c
c     ***  modified september 87 for the cbm-iv (gery et al., 1987)
c     ***  modified may 1990 for cloud chemistry (mepl, jpk)
c    
c     ---  added line to reevaluate nxoy when no3 and n2o5 are
c          recalculated (before line 30) (mpl,tcm, 11/6/91)
c
c            systems applications, inc.
c            101 lucas valley rd.
c            san rafael, ca  94903
c
c--input variables
c         hh        r  concentrations (ppm)
c         cwc       r  cloud liquid water content
c
c
c--local variables
c         reaction rates are of form -rn-
c         incomplete reaction terms are of form -rxn-
c
c--routines called
c         eqlbrm (gas/aqueous equilibria)
c         achem  (aqueous phase rates)
c
c--called by
c         ssday
c
c
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'comchem2.cmd'
      include 'errlog.cmd'
      dimension r(250), rate(mxspec)
c
      logical lin,lrad1st

      dimension  hh(mxspec)
      dimension  rx(250), x(250), xr(250), ar(250)
      common /idcell/icell,jcell,kcell,tmchm
      real khoh,khho2,ko2n
      real noxs,no3r
      real no3, n2o5
c
c       data lrad1st/.true./
c
      if (idiag .ne. 0) then
        write(*,*) ' entering chem, cwc, temp, and pres are ',cwc,temp,
     &             pres
      endif
      lss=.false.
      lin=.false.
c
c     *** set tolerance and iteration limits for radical convergence
      xtol = 0.01
      nitmax = 50
c
c *********************************************************************
c          input of gas-phase concentration data--ppm units
c *********************************************************************
c
c
c  clear sky concentrations
c
      no   = hh(kno  )
      no2  = hh(kno2 )
      o3   = hh(ko3  )
      ole  = hh(kole )
      par  = hh(kpar )
      tol  = hh(ktol )
      xyl  = hh(kxyl )
      form = hh(khcho)
      acet = hh(kacet)
      eth  = hh(keth )
      cres = hh(kcres)
      mgly = hh(kmgly)
      open = hh(kopen)
      pna  = hh(kpna )
      nxoy = hh(knxoy)
      pan  = hh(kpan )
      co   = hh(kco  )
      hno2 = hh(khno2)
      h2o2 = hh(kh2o2)
      hno3 = hh(khno3)
      isop = 0.
      if (lisop)  isop = hh(kisop)
      so2  = 0.
      if (lso2)   so2  = hh(ksiv )
      meoh = 0.
      nitr  = 0.
      if (lmeoh)  meoh = hh(kmeoh)
      if (lnitr)  nitr  = hh(knitr )
c
  200 continue
      noxdum = amax1(1.e-15,(nxoy -no -no2))
c
c        radical species to be solved in steady state calculations
c        are:
c              o1d,o,no3,n2o5
c              oh,ho2,c2o3,ror,to2
c              xo2,xo2n,cro
c
c
c=======================================================================
c
c     *** compute complete reaction terms where possible
c
c         r(n)  complete term for reaction n
c         rx(n) incomplete term for reaction n
c
      do 40 i=1,250
        r(i) = 0.
        rx(i) = 0.
        ar(i)=0.0
   40 continue
c
      r(1) = rk( 1)*no2
      r(3) = rk( 3)*o3*no
      r(7) = rk( 7)*no2*o3
      r(8) = rk( 8)*o3
      r(9) = rk( 9)*o3
      r(20)= rk(20)*no*no
      r(21)= rk(21)*no*no2*h2o
      r(23)= rk(23)*hno2
      r(25)= rk(25)*hno2*hno2
      r(30)= rk(30)*pna
      r(34)= rk(34)*h2o2
      r(38)= rk(38)*form
      r(39)= rk(39)*form
      r(45)= rk(45)*acet
      r(48)= rk(48)*pan
      r(58)= rk(58)*o3*ole
      r(62)= rk(62)*o3*eth
      r(69)= rk(69)*open
      r(71)= rk(71)*open*o3
      r(74)= rk(74)*mgly
      r(77)= rk(77)*isop*o3
c      r(83)= rk(83)*so2
      if (idiag .ne. 0) then
        write(*,*) ' r:  ',r
        call flush(6)
      endif
c
c     ***  compute incomplete reaction terms
c
      rx(2) = rk( 2)
      rx(4) = rk( 4)*no2
      rx(5) = rk( 5)*no2
      rx(6) = rk( 6)*no
      rx(10)= rk(10)
      rx(11)= rk(11)*h2o
      rx(12)= rk(12)*o3
      rx(13)= rk(13)*o3
      rx(14)= rk(14)
      rx(15)= rk(15)*no
      rx(16)= rk(16)*no2
      rx(17)= rk(17)*no2
      rx(18)= rk(18)*h2o
      rx(19)= rk(19)
      rx(22)= rk(22)*no
      rx(24)= rk(24)*hno2
      rx(26)= rk(26)*no2
      rx(27)= rk(27)*hno3
      rx(28)= rk(28)*no
      rx(29)= rk(29)*no2
      rx(31)= rk(31)*pna
      rx(32)= rk(32)
      rx(33)= rk(33)*h2o
      rx(35)= rk(35)*h2o2
      rx(36)= rk(36)*co
      rx(37)= rk(37)*form
      rx(40)= rk(40)*form
      rx(41)= rk(41)*form
      rx(42)= rk(42)*acet
      rx(43)= rk(43)*acet
      rx(44)= rk(44)*acet
      rx(46)= rk(46)*no
      rx(47)= rk(47)*no2
      rx(49)= rk(49)
      rx(50)= rk(50)
      rx(51)= rk(51)
      rx(52)= rk(52)*par
      rx(53)= rk(53)
      rx(54)= rk(54)
      rx(55)= rk(55)*no2
      rx(56)= rk(56)*ole
      rx(57)= rk(57)*ole
      rx(59)= rk(59)*ole
      rx(60)= rk(60)*eth
      rx(61)= rk(61)*eth
      rx(63)= rk(63)*tol
      rx(64)= rk(64)*no
      rx(65)= rk(65)
      rx(66)= rk(66)*cres
      rx(67)= rk(67)*cres
      rx(68)= rk(68)*no2
      rx(70)= rk(70)*open
      rx(72)= rk(72)*xyl
      rx(73)= rk(73)*mgly
      rx(75)= rk(75)*isop
      rx(76)= rk(76)*isop
      rx(78)= rk(78)*isop
      rx(79)= rk(79)*no
      rx(80)= rk(80)
      rx(81)= rk(81)*no
      rx(82)= rk(82)*so2
      rx(84)= rk(84)*meoh
      rx(85)= rk(85)
      rx(86)= rk(86)
      rx(87)= rk(87)
      rx(88)= rk(88)
c
c
c   make all rx(i) & (r(i) values > 0 for steady state calculations
c          using the dummy array xr(i) and x(i)
c
      do 10 i = 1,100
        xr(i) = amax1(rx(i),0.)
        x(i)  = amax1(r(i) ,0.)
   10 continue
c
c***********************************************************************
c   if clouds are present, calculate diffusion parameters for
c   mass transfer
c
c     if(cwc.lt.cwcmin) then
      convt = 0.
      kgln25 = 0.
      kglho2 = 0.
      klgho2 = 0.
      kgloh = 0.
      klgoh = 0.
c     end if
c
   15 continue
c=======================================================================
c
c   first:  solve o1d independently
c
c=======================================================================
c
c     for o1d:
c
c       reactions are 10 and 11
c
c       sources are 9
c
c     hence:
c
c          o1d*(xr(10)+xr(11)) = x(9)
c
c      or:
c
       o1d = x(9)/(xr(10)+xr(11))
c
c=======================================================================
c
c   second:  solve no3, n2o5 and o from either the state nox value
c           (using nox = no3 + 2*n2o5 = nxoy - no - no2), or the
c           steady state calculations.
c
c=======================================================================
c
c     determine if sufficient mass exists in the nox species to warrant
c     consideration as state species.
c
      if (noxdum.lt.1.e-6) go to 22
      if (noxdum.ge.(1.e-2*(no+no2)))  lin=.true.
c
      if (lin) go to 20
c
c       else, solve linked steady-state for no3, n2o5 and o.
c
c     for o:
c
c       reactions are 2,4,5,6,40,42,56,60,75
c
   22 continue
c
      orxn = xr(2)+xr(4)+xr(5)+xr(6)+xr(40)+xr(42)+xr(56)+xr(60)+xr(75)
c
c       sources are 1,8
c          plus 10           from o1d
c          plus (0.89) 14    from no3
c
      osrc = x(1) + x(8) + o1d*xr(10)
      if (idiag .ne. 0) write(*,201) x(1),x(8),osrc
  201 format(' x1',e10.3,' x8',e10.3,' osrc',e10.3)
c
c     hence:
c
c       o*orxn = osrc + 0.89*no3*xr(14)
c
c=======================================================================
c
c     for no3:
c
c       reactions are 14,15,16,17,41,44,59,67,78
c
      if (idiag .ne. 0) write(8,3003)
 3003 format(1x,'no3')
      no3r = xr(14) + xr(15) + xr(16) + xr(17) + xr(41) + xr(44)
     &      + xr(59) + xr(67) + xr(78)
c
c       sources are 7
c         plus 5     from o
c         plus 19    from n2o5
c         plus 27    from oh
c
c     hence,
c
c       no3*no3r = x(7) + o*xr(5) + n2o5*xr(19) + oh*xr(27)
c
c=======================================================================
c
c     for n2o5:
c
c       reactions are 18,19 and kgln25
c
c       source is 17 from no3
c
c     hence,
c
c       n2o5*(xr(18)+xr(19)+kgln25) = no3*xr(17)
c
c=======================================================================
c
c     if no3 formation from reaction 27 (oh + hno3) is neglected, then:
c
c       no3*no3r = x(7) + o*xr(5) + n2o5*xr(19)
c
c     substituting or n2o5 from above:
c
c       no3*no3r = x(7) + o*xr(5) + no3*xr(17)*xr(19)/
c                 (xr(18)+xr(19)+kgln25)
c
c     and if:
c
      oc1 = no3r - xr(17)*xr(19)/(xr(18)+xr(19)+kgln25)
      if (idiag .ne. 0)write(*,202)no3r,xr(17),xr(18),xr(19),kgln25,oc1
  202 format(' no3r',e10.3,' xr17',e10.3,' xr18',e10.3,' xr19',e10.3/
     &       ' kgln25',e10.3,' oc1',e10.3)
c
c     then:
c
c       no3 = (x(7) + o*xr(5))/oc1
c
c     substituting into the steady-state equation for o
c
c     o = (osrc + 0.89*xr(14)*(x(7) + o*xr(5))/oc1)/orxn
c
c     or:
c
      o = (osrc + 0.89*xr(14)*x(7)/oc1)/(orxn - 0.89*xr(14)*xr(5)/oc1)
      o = amax1(o,1.e-12)
c
      no3 = (x(7) + o*xr(5))/oc1
      no3 = amax1(no3,1.e-12)
c
      n2o5 = no3*xr(17)/(xr(18)+xr(19)+kgln25)
      n2o5 = amax1(n2o5,1.e-12)
c
      noxs = no3 + 2.*n2o5
      if (idiag .ne. 0) write(*,3002) o,no3,n2o5,noxs
 3002 format(' o:',e10.3,' no3:',e10.3,' n2o5:',e10.3,' noxs:',e10.3)
c
      if (noxs.lt.1.e-6) go to 26
      if (noxs.ge.(1.e-2*(no+no2)))  go to 20
c
c     else, do steady state type calculations for no3 and n2o5
c
   26 lss = .true.
c
      go to 30
c
c=======================================================================
c
   20 continue
c
c     come here if no3 and n2o5 exist at high concentrations to affect o
c
c=======================================================================
c
c     from above,
c
c       n2o5*(xr(18)+xr(19)+kgln25) = no3*xr(17)
c
c    or, if we set
c
      rxn = xr(17)/(xr(18)+xr(19)+kgln25)
c
c       n2o5 = no3*rxn
c
c     recall that,
c
c       nox = no3 + 2.*n2o5 = nxoy - no - no2
c
c       fno3  = no3 /(no3+2.*n2o5)
c
c     or,
c
c       fno3  = no3 /(no3+2.*no3*rxn)
c     or,
c
      fno3  = 1. /(1.+2.*rxn)
c
c     and,
c
        fn2o5 = rxn/(1.+2.*rxn)
c
c     and,
c
      no3  = fno3*noxdum
      n2o5 = fn2o5*noxdum
c
      nxoy = no + no2 + no3 + 2.*n2o5
c
c     and substituting with the expression for o from above:
c
      orxn = xr(2)+xr(4)+xr(5)+xr(6)+xr(40)+xr(42)+xr(56)+xr(60)+xr(75)
      osrc = x(1) + x(8) + o1d*xr(10)
c
      o = (osrc + 0.89*no3*xr(14))/orxn
      if (idiag .ne. 0) write(*,30031) o,no3,n2o5
30031 format(' non-ss o:',e10.3,' no3:',e10.3,' n2o5:',e10.3)
c
   30 continue
c
c=======================================================================
c
c   third:  assume to2 and ror are ideal steady state species
c           and solve now that no2 is known
c
c=======================================================================
c
c     for to2:
c
c       reactions are 64,65
c
      to2r = xr(64) + xr(65)
c
c       sources are (0.56)63,(0.30)72 from oh
c
      to2oh = 0.56*xr(63) + 0.30*xr(72)
c
c     hence,
c
c          to2*to2r = oh*to2oh
c
c     since to2 depends only on oh, we can reset the reactions of
c          to2 to depend on oh:
c
c       if,
c
      f64 = xr(64)/to2r
      f65 = 1.-f64
c
c     and,
c
c       r(65) = to2*xr(65)
c
c     with,
c
c       to2 = oh*to2oh/to2r
c
c     then,
c
c       r(64) = oh*to2oh*f64
c       r(65) = oh*to2oh*f65
c
c     or, reset reactions 64 and 65 as functions of oh
c
      xr(64) = to2oh*f64
      xr(65) = to2oh*f65
c
c=======================================================================
c
c     for ror:
c
c       reactions are 53,54,55
c
      rorr = xr(53) + xr(54)+ xr(55)
c
c       sources are (0.76)52 from oh    (ignoring reaction 53)
c
c     hence,
c
c          ror*rorr = oh*0.76*xr(52)
c
c     since ror depends only on oh, we can reset the reactions of
c          ror to depend on oh:
c
c       if,
c
      f53 = xr(53)/rorr
      f54 = xr(54)/rorr
      f55 = xr(55)/rorr
c
c     and,
c
c       r(53) = ror*xr(53)
c       r(54) = ror*xr(54)
c       r(55) = ror*xr(55)
c
c     with,
c
c       ror = oh*0.76*xr(52)/rorr
c
c     then,
c
c       r(53) = oh*0.76*xr(52)*f53
c       r(54) = oh*0.76*xr(52)*f54
c       r(55) = oh*0.76*xr(52)*f55
c
c     or, reset reactions 53,54,and 55 as functions of oh
c
      xr(53) = 0.76*xr(52)*f53
      xr(54) = 0.76*xr(52)*f54
      xr(55) = 0.76*xr(52)*f55
c
c
c=======================================================================
c
c   fourth:  estimate oh, ho2, and c2o3 and solve  with multiple
c            quadratics (using o1d, to2 and ror assumptions above)
c
c=======================================================================
c
c     for oh:
c
c       reactions making ho2 are 12,35,36,37,51,52,57,61,63,66,70,72,
c                                76,82,84,91,92
c
      ho2oh = xr(12)+xr(35)+xr(36)+xr(37)+xr(51)+xr(52)+xr(57)
     &       +xr(61)+xr(63)+xr(66)+xr(70)+xr(72)+xr(76)+xr(82)
     &       +xr(84)+xr(91)+0.61*xr(92)
c
c       all other reactions are 22,24,26,27,31,43,73,
c           plus  *88* with  ho2
c
      ohrx = xr(22)+xr(24)+xr(26)+xr(27)+xr(31)+xr(43)+xr(73)
c
      ohr = ho2oh + ohrx + kgloh
c
c       sources of oh are 23,(2)34,(0.10)58,(0.08)71,(0.10)77,89,90
c          plus 13 and 28                      from ho2
c          plus 40, 42, (0.20)56 and (0.30)60  from o
c          plus (2.0)11                        from o1d
c          plus (0.33)50                       from ho2 and c2o3
c          plus (0.39) 92                      from oh
c
      ohs1  = x(23) + 2.0*x(34) + 0.1*x(58) + 0.08*x(71) + 0.1*x(77)
     &       + x(89) + x(90) + o1d*2.0*xr(11) + klgoh*aoh*convt
     &       + o*(xr(40)+xr(42)+0.2*xr(56)+0.3*xr(60))
      ohho2 = xr(13) + xr(28)
      if (idiag.ne.0)write(*,3001)x(23),x(34),x(89),x(90),xr(13),xr(28)
 3001 format(' oh sources: hono phot:',e10.3,' h2o2 phot:',e10.3,/
     & ' mhp phot:',e10.3,' paa phot:',e10.3,' o3+ho2:',e10.3/
     & ' ho2+no',e10.3)
      ispot = -1
      if (idiag .ne. 0) then
        write(*,333)ispot, ohr,ohs1,ohho2
      endif
c
c     hence:
c
c          oh*(ohr + ho2*xr(88)) = ohs1 + ho2*(ohho2 + c2o3*0.33*xr(50))
c 
c=======================================================================
c
c     for c2o3:
c
c       reactions are 46,47
c          plus twice 49 with c2o3
c          plus 50       with ho2
c             plus 86,87   with xo2****
c
      c2o3r = xr(46) + xr(47)
c
c       sources are 48,69,(0.62)71,74
c          plus 42                        from o
c          plus 43, 70, 73 and (0.2)76    from oh
c          plus 44                        from no3
c
      c2o3s  = x(48) + x(69) + 0.62*x(71) + x(74) + o*xr(42)
     &       + no3*xr(44)
      c2o3oh = xr(43) + xr(70) + xr(73) + 0.2*xr(76)
      if (idiag .ne. 0) write(*,3005) x(48),x(69),x(71),x(74),
     &      xr(42),xr(44),xr(43), xr(70),xr(73),xr(76)
 3005 format(' c2o3 sources: pan',e10.3,' open',e10.3,' op+o3',e10.3/
     &       ' mgly',e10.3,' acet+o',e10.3,' acet+no3',e10.3,
     &       ' acet+oh',e10.3/' op+oh',e10.3,' mgly+oh',e10.3,
     &       ' isop+oh',e10.3)
c
c
c     hence:
c
c          c2o3 *(c2o3r + ho2*xr(50) + 2.0*c2o3*xr(49))
c*****              +c2o3*(xr(86)+xr(87))*xo2*******
c                   = c2o3s + oh*c2o3oh
c
c=======================================================================
c
c     for ho2:
c
c       reactions are 13,28,29
c          plus twice 32 and 33 with ho2
c          plus 50              with c2o3
c            plus 85            with xo2
c                 85 also eliminates an ho2 from the reaction stream
c            plus 88            with oh
c
      ho2r = xr(13) + xr(28) + xr(29) + kglho2
c
c       sources are 30,(2.0)38,(2.0)45,(0.44)58,(0.12)62,69,
c                   (0.76)71,74,(0.44)77,89,90
c          plus 40,(0.38)56,(1.7)60,(0.60)75        from o
c          plus 12,35,36,37,51,(0.11)52,57,61,(0.44)63,(0.60)66,
c               (2)70,(0.70)72,(0.67)76,82,84,91,(0.61)92 from oh
c          plus (0.94)53,54                         from oh via ror
c          plus (0.9)64,65                          from oh via to2
c          plus 46   from c2o3 and (2.0)49          from two c2o3
c          plus (0.33)50                            from c2o3 and ho2
c          plus 86,87                               from c2o3 and xo2
c          plus 41                                  from no3
c
      ho2s   = x(30)+2.0*x(38)+2.0*x(45)+0.44*x(58) + 0.12*x(62)
     &       + x(69) +0.76*x(71) +x(74) +0.44*x(77) + x(89) + x(90)
     &       + o*(xr(40) + 0.38*xr(56) + 1.7*xr(60) + 0.6*xr(75))
     &       + no3*xr(41) + klgho2*aho2t*convt
      ho2oh  = xr(12)+xr(35)+xr(36)+xr(37)+xr(51)+0.11*xr(52)
     &       +xr(57)+xr(61)+0.44*xr(63)+0.6*xr(66)+2.*xr(70)
     &       +0.7*xr(72)+0.67*xr(76) + xr(82) + xr(84) +xr(91)
     &       +0.61*xr(92) + 0.94*xr(53) + xr(54) + 0.9*xr(64) +xr(65)
      if (idiag .ne. 0) 
     &  write(*,3004) x(30),x(38),x(45),x(69),x(71),x(74),x(89),x(90),
     &      xr(41),xr(12),xr(35),xr(36),xr(37),xr(51),xr(57),xr(61),
     &      xr(70),xr(72),xr(76),xr(82),xr(91),xr(92)
 3004 format(' ho2 sources: pna:',e10.3,' hcho',e10.3,' acet',e10.3/
     &       ' open',e10.3,' op+o3',e10.3,' mgly',e10.3,' mhp',e10.3/
     &       ' paa',e10.3,' hcho+no3',e10.3,' o3+oh',e10.3,' oh+h2o2'
     &       ,e10.3/' oh+co',e10.3,' hcho+oh',e10.3,' ch4',e10.3,
     &       ' ole',e10.3/' eth',e10.3,' op+oh',e10.3,' xyl',e10.3,
     &       ' isop',e10.3/' so2',e10.3,' facd',e10.3,' mhp',e10.3)
c
c     hence:
c
c          ho2 *(ho2r+2.0*ho2*(xr(32)+xr(33))+c2o3*xr(50))
c***********  +ho2*(2*xr(85)*xo2 + xr(88)*oh)*************
c               = ho2s + oh*ho2oh + c2o3 *(xr(46) + 2.0*c2o3*xr(49)
c               + 0.33*ho2*xr(50) + xo2*(xr(86)+xr(87)))
c
c=======================================================================
c
c     so:
c
c          ho2 *(ho2r+2.0*ho2*(xr(32)+xr(33))+c2o3*xr(50)+2*xo2*xr(85)
c********                   +oh*xr(88))
c               = ho2s + oh*ho2oh + c2o3*(xr(46) + 2.0*c2o3*xr(49)
c               + 0.33*ho2*xr(50) +xo2*(xr(86)+xr(87)))
c
c          c2o3 *(c2o3r + ho2*xr(50) + 2.0*c2o3*xr(49) 
c*******             +xo2*(rx(86)+rx(87))
c                   = c2o3s + oh*c2o3oh
c
c          oh*(ohr + xr(88)*ho2) = ohs1 + ho2*(ohho2 + c2o3*0.33*xr(50))
c
c=======================================================================
c
c     for xo2:
c
c       reactions are 79
c          plus 80 with twice xo2
c          plus 85 with       ho2
c          plus 87 with    c2o3 
c          note: reaction 86 has xo2 as reactant and product
c
c       sources are 45,(0.22)58,(0.03)71,90
c          plus 46        from c2o3 and (2.0)49 from two c2o3
c          plus 51,(0.87)52,57,61,(0.08)63,(0.60)66,70,
c               (0.50)72,73,76,(0.61)92                  from oh
c          plus (0.96)53                        from oh via ror
c          plus (0.28)56,(0.70)60,(0.5)75       from o
c          plus (0.33)50                        from ho2 and c2o3
c          plus (0.91)59                        from no3
c
      xo2s   = x(45) + 0.22*x(58) + 0.03*x(71) + x(90)
     &       + o*(0.28*xr(56) + 0.70*xr(60) + 0.5*xr(75))
     &       + no3*0.91*xr(59)
      xo2oh  = xr(51) + 0.87*xr(52) + xr(57) + xr(61)
     &       + 0.08*xr(63) + 0.60*xr(66) + xr(70) + 0.50*xr(72)
     &       + xr(73) + xr(76) + 0.96*xr(53) + 0.61*xr(92)
c
c
c     hence:
c
c          xo2 *(xr(79) + 2.*xo2*xr(80) + ho2*xr(85) + c2o3*xr(87)
c          = xo2s + oh*xo2oh
c           + c2o3 *(xr(46) + 2.0*c2o3*xr(49) + 0.33*ho2*xr(50))
c
c     or
c
c          xo2 *(xr(79) + 2.*xo2*xr(80)+ ho2*xr(85) + c2o3*xr(87)
c          = xo21
c
c     where
c
c
c      xo21 = xo2s + oh*xo2oh + c2o3*(xr(46)+2.*c2o3*xr(49)
c     1       + 0.33*ho2*xr(50))
c
c
c=======================================================================
c
c       need to generate an estimate of a radical concentration.
c       since oh is mainly dependent on state variables, it will
c       be the first guess.
c
c       note: if this is not the first time through, then use
c             the previous radical concentrations as a first 
c             guess.
c
c        if(.not.lrad1st)go to 33
c        lrad1st = .false.
c
      ispot = -2
      if (idiag .ne. 0) then
        write(*,333) ispot, ohs1,ohho2,oh
      endif
      if(oh.ge.1.0e-19) go to 33
c
c
c  okay, getting a bit dangerous here;  need initial guess for rads
c  if no has any concentration, rad-rad will be negligable
c   so oh is radical sources/radical sinks
c
      ohs = ohs1 + ho2s + c2o3s*rx(46)/(rx(46)+rx(47))
      if(no.ge.1.e-03) oh = ohs / (rx(22)+rx(23)+rx(26))
c
c....for high no, oh concentration is expected to be low. to be certain of 
c....this, the following line is added by b. shi on july 23, 1992.
      if(oh.gt.5.0e-09) oh=5.0e-09
c
      if(no.lt.1.e-03) oh = 2.e-07

c
c          given, oh,  we can now determine a first guess
c          at c2o3, ignoring radical cross reactions:
c
c          c2o3 *(c2o3r + 2.0*c2o3*xr(49))
c                   = c2o3s + oh*c2o3oh
c
c          or,
c
c          c2o3*c2o3 *(2.0*xr(49)  + c2o3 *c2o3r
c                 - c2o3s - oh*c2o3oh  =  0
c
c
c          with the quadratic
c
      aa = 2.0*xr(49)
      bb = c2o3r
      cc = -(c2o3s + oh*c2o3oh)
      bbcc = bb**2 - 4.*aa*cc
      ispot = 1
      if (idiag .ne. 0) then
        write(*,333) ispot, oh,ho2,c2o3,xo2
      endif
      if(bbcc.lt.0.) go to 2000
      c2o3 = -2*cc/(bb+sqrt(bbcc))
c
      c2o3 = amax1(c2o3,1.e-10)
      c2o3 = amin1(c2o3,5.e-4)
c
c       now, with an estimate of oh and the c2o3 value, the ho2
c       expression may be reduced to a quadratic, again, ignoring 
c       cross products via:
c
c       ho2 *(ho2r+2.0*ho2*(xr(32)+xr(33)) + c2o3*xr(50))
c          = ho2s + oh*ho2oh 
c          + c2o3 *(xr(46) + 2.0*c2o3*xr(49) + 0.33*ho2*xr(50))
c
      aa=2.0*(xr(32)+xr(33)) 
      bb = ho2r  +0.67*c2o3*xr(50) + xr(88)*oh
      cc = -(ho2s + oh*ho2oh +2.*c2o3*c2o3*xr(49) + c2o3*xr(46))
      bbcc = bb**2 - 4.*aa*cc
      ispot = 2
      if (idiag .ne. 0) then
        write(*,333) ispot, oh,ho2,c2o3,xo2
      endif
      if(bbcc.lt.0.) go to 2000
      ho2 = -2*cc/(bb+sqrt(bbcc))
c
      ho2 = amax1(ho2,1.e-10)
      ho2 = amin1(ho2,5.e-4)
c
c     now we get an estimate for xo2:
c
      xo21 = xo2s + oh*xo2oh + c2o3*(xr(46)+2.*c2o3*xr(49)
     &       + 0.33*ho2*xr(50))
c
c       xo2 *(xo2r+2.0*xo2*(xr(80)) + c2o3*(xr(87)
c                                   + ho2*xr(85))
c          = xo2s + oh*xo2oh 
c          + c2o3 *(xr(46) + 2.0*c2o3*xr(49) + 0.33*ho2*xr(50))
c     
      aa =  2.0*xr(80)
      bb =  xr(79) + c2o3*xr(87) + ho2*xr(85)
      cc =  -xo21
      bbcc = bb**2 - 4.*aa*cc
      ispot = 3
      if (idiag .ne. 0) then
        write(*,333) ispot, oh,ho2,c2o3,xo2
      endif
      if(bbcc.lt.0) go to 2000
      xo2 = -2*cc/(bb+sqrt(bbcc))
      if (idiag .ne. 0)write(*,6003)aa,bb,cc,xo2
 6003 format(' aa',e10.3,' bb',e10.3,' cc',e10.3,' xo2',e10.3)

      xo2=amax1(xo2,1.e-12)
      xo2=amin1(xo2,5.e-4)
c
c          now, the assumptions may be dropped and the explicit
c          equations solved.
c
c      come here if oh,c2o3,ho2,xo2 already estimated
c
   33 continue
      ispot = 35
      if (idiag .ne. 0) then
        write(*,333) ispot, oh,ho2,c2o3,xo2
      endif
  333 format('ispot=',i4,4e11.4)
      liter=0
   34 continue
c
      poh = oh
      pc2o3 = c2o3
      pho2 = ho2
      pxo2 = xo2
c
c      now solve radicals with cross reactions added
c     solve the quadratics, (a and b are positive and c is negative
c            by our above definitions of x and xr)
c
c*****oh  ***************
      oh = (ohs1+ho2*(ohho2 + c2o3*0.33*xr(50)))/(ohr+ho2*rx(88))
c*****c2o3**************
      aa = 2.0*xr(49)
      bb = c2o3r + ho2*xr(50) + xo2*(xr(86)+xr(87))
      cc = -(c2o3s + oh*c2o3oh)
      bbcc = bb**2 - 4.*aa*cc
      ispot = 4
      if (idiag .ne. 0) then
        write(*,333) ispot, oh,ho2,c2o3,xo2
      endif
      if(bbcc.lt.0.) go to 2000
      c2o3 = -2*cc/(bb+sqrt(bbcc))
c******ho2 *************
      aa = 2.0*(xr(32)+xr(33))
      bb = ho2r  +0.67*c2o3*xr(50) + oh*xr(88) + 2*xo2*xr(85)
      cc = -(ho2s + oh*ho2oh +c2o3*(2.*c2o3*xr(49) +xr(46)
     &     +xo2*(xr(86)+xr(87))))
      bbcc = bb**2 - 4.*aa*cc
      ispot = 5
      if (idiag .ne. 0) then
        write(*,333) ispot, oh,ho2,c2o3,xo2
      endif
      if(bbcc.lt.0.) go to 2000
      ho2 = -2*cc/(bb+sqrt(bbcc))
c******xo2 *************
      xo21 = xo2s + oh*xo2oh + c2o3*(xr(46)+2.*c2o3*xr(49)
     &       + 0.33*ho2*xr(50))
      aa =  2.0*xr(80)
      bb =  xr(79) + c2o3*xr(87) + ho2*xr(85)
      cc =  -xo21
      bbcc = bb**2 - 4.*aa*cc
      ispot = 6
      if(bbcc.lt.0.) go to 2000
      xo2 = -2*cc/(bb+sqrt(bbcc))
      if (idiag .ne. 0) then
        write(*,333) ispot, oh,ho2,c2o3,xo2
      endif
      liter = liter + 1
      if(liter.gt.nitmax)go to 180
c
c     test for convergence
      test = (oh-poh)/oh
      if (abs(test).gt.xtol) go to 34
      test = (c2o3-pc2o3)/c2o3
      if (abs(test).gt.xtol) go to 34
      test = (ho2-pho2)/ho2
      if (abs(test).gt.xtol) go to 34
      test = (xo2-pxo2)/xo2
      if (abs(test).gt.xtol) go to 34
      ispot = 7
      if (idiag .ne. 0) then
        write(*,333) ispot, oh,ho2,c2o3,xo2
      endif
c
   36 continue
c
c     convergence achieved
c
c=======================================================================
c
c   fifth: calculate concentrations of remaining radicals
c          based on above.
c
c=======================================================================
c
c      for xo2n:
c
c       reactions are 81
c
c        sources are (0.09)59
c           plus (0.13)52, (0.13)76       from oh
c           plus (0.04)53                 from oh via ror
c           plus (0.02)56                 from o
c           plus 78                       from no3
c
      xo2ns = 0.09*x(59) + oh*(0.13*xr(52) + 0.13*xr(76)
     &        + 0.04*xr(53)) + o*0.02*xr(56) + no3*xr(78)
c
c       then:
c
      if (xr(81).gt.1.e-15) xo2n = xo2ns/xr(81)
      xo2n=amin1(xo2n,1.e-4)
c
c=======================================================================
c
c      for cro:
c
c
      if (xr(68).le.0.) cro = 1.e-9
      if (xr(68).gt.0.) cro = (no3*xr(67) + 0.4*oh*xr(66))/ xr(68)
c
c=======================================================================
c
c     reset the ror and to2 rx terms
c
      rx(53) = xr(53)
      rx(54) = xr(54)
      rx(55) = xr(55)
      rx(64) = xr(64)
      rx(65) = xr(65)
c
c
c    complete reaction terms for the radicals calculated above
c
      if (idiag .ne. 0) then
        write(*,*) ' o, o1d, oh, ho2, no3, n2o5, c2o3, cro, xo2: ',
     &             o, o1d, oh, ho2, no3, n2o5, c2o3, cro, xo2
      endif
      r( 2) = rx( 2)*o
      r( 4) = rx( 4)*o
      r( 5) = rx( 5)*o
      r( 6) = rx( 6)*o
      r(10) = rx(10)*o1d
      r(11) = rx(11)*o1d
      r(12) = rx(12)*oh
      r(13) = rx(13)*ho2
      r(14) = rx(14)*no3
      r(15) = rx(15)*no3
      r(16) = rx(16)*no3
      r(17) = rx(17)*no3
      r(18) = rx(18)*n2o5
      r(19) = rx(19)*n2o5
      r(22) = rx(22)*oh
      r(24) = rx(24)*oh
      r(26) = rx(26)*oh
      r(27) = rx(27)*oh
      r(28) = rx(28)*ho2
      r(29) = rx(29)*ho2
      r(31) = rx(31)*oh
      r(32) = rx(32)*ho2*ho2
      r(33) = rx(33)*ho2*ho2
      if (idiag .ne. 0) write(*,262) ho2,r(28),r(32),r(33)
  262 format(' ho2=',e10.3,' r28=',e10.3,' r32=',e10.3,' r33=',e10.3)
      r(35) = rx(35)*oh
      r(36) = rx(36)*oh
      r(37) = rx(37)*oh
      r(40) = rx(40)*o
      r(41) = rx(41)*no3
      r(42) = rx(42)*o
      r(43) = rx(43)*oh
      r(44) = rx(44)*no3
      r(46) = rx(46)*c2o3
      r(47) = rx(47)*c2o3
      r(49) = rx(49)*c2o3*c2o3
      r(50) = rx(50)*c2o3*ho2
      r(51) = rx(51)*oh
      r(52) = rx(52)*oh
      r(53) = rx(53)*oh
      r(54) = rx(54)*oh
      r(55) = rx(55)*oh
      r(56) = rx(56)*o
      r(57) = rx(57)*oh
      r(59) = rx(59)*no3
      r(60) = rx(60)*o
      r(61) = rx(61)*oh
      r(63) = rx(63)*oh
      r(64) = rx(64)*oh
      r(65) = rx(65)*oh
      r(66) = rx(66)*oh
      r(67) = rx(67)*no3
      r(68) = rx(68)*cro
      r(70) = rx(70)*oh
      r(72) = rx(72)*oh
      r(73) = rx(73)*oh
      r(75) = rx(75)*o
      r(76) = rx(76)*oh
      r(78) = rx(78)*no3
      r(79) = rx(79)*xo2
c     r(80) = rx(80)*xo2*xo2
      r(81) = rx(81)*xo2n
      r(82) = rx(82)*oh
      r(84) = rx(84)*oh
      r(85) = rx(85)*xo2*ho2
      r(86) = rx(86)*c2o3*xo2
c     r(87) = rx(87)*c2o3*xo2
c     r(88) = rx(88)*oh*ho2
      r(91) = rx(91)*oh
      r(92) = rx(92)*oh
      if (lss) go to 80
      call chrt1s(r, rate)
      go to 9000
   80 continue
      call chrt3s(r, rate)
      go to 9000
c
c---------errors------
  180 write(*,1000) oh,ho2,xo2,c2o3,test,poh,pho2,pxo2,pc2o3
      write(*,1010) icell, jcell, kcell, tmchm
      write(8,1000) oh,ho2,xo2,c2o3,test,poh,pho2,pxo2,pc2o3
      write(8,1010) icell, jcell, kcell, tmchm
      write(ierrlg,1001) 1117,oh,ho2,xo2,c2o3,test,poh,pho2,pxo2,pc2o3
      write(ierrlg,1010) oh,ho2,xo2,c2o3,test,poh,pho2,pxo2,pc2o3
      stop
 1000 format(1x,'***error in radical concentration calc in chems',//,
     &       ' oh=',e10.3,' ho2=',e10.3,' xo2=',e10.3,' c2o3=',e10.3,
     &       'test=',e10.3,'poh=',e10.3,'pho2=',e10.3,'pxo2=',
     &       e10.3,'pc2o3=',e10.3)
 1001 format(i4,2x,'***error in radical concentration calc in chems',//
     &      ,' oh=',e10.3,' ho2=',e10.3,' xo2=',e10.3,' c2o3=',e10.3,
     &       'test=',e10.3,'poh=',e10.3,'pho2=',e10.3,'pxo2=',
     &       e10.3,'pc2o3=',e10.3)
 1010 format(1x,' error occurred in cell (',i3,',',i3,',',i3,
     &       ') at time ',f10.1)
 2000 write(*,2010) ispot,aa,bb,cc,bbcc
      write(8,2010) ispot,aa,bb,cc,bbcc
      write(ierrlg,2011) 1156,ispot,aa,bb,cc,bbcc 
 2010 format(' sqrt of neg value in chem at location ',i3,': aa=',
     &       e10.3,' bb=',e10.3,
     &       ' cc=',e10.3,' bbcc=',e10.3)
 2011 format(i4,1x,' sqrt of neg value in chem at location ',i3,': aa=',
     &       e10.3,' bb=',e10.3,
     &       ' cc=',e10.3,' bbcc=',e10.3)
      stop
c----------------------------------------------------------------------
 9000 rpan=rate(kpan)
      rhno3=rate(khno3)
c...concentrations of no, no2, o3 hno3 and pan are not changed in this sub-
c   routine actually.
      hh(kno  )=no
      hh(kno2 )=no2
      hh(ko3  )=o3
      hh(knxoy)=nxoy
      hh(kpan )=pan
      hh(khno3)=hno3
      return
      end   
      subroutine chrt1s(r, rate)
c
c     *** (c) copr. 1992  systems applications, inc.  san rafael, ca
c
c
c***********************************************************************
c        computation of net total rates and jacobian elements
c           clear skies -- nxoy as state species (nox,n2o5 large)
c***********************************************************************
c
c     compute derivative of n-related species i with respect to time
c        {rate(i)}
c
c
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'comchem2.cmd'
      dimension r(250), rate(mxspec)
c
c        15 nxoy
c        =======
      pnxoy = r(23) +r(24) +2.*r(25) +r(27) +r(30) +r(31) +r(48)
      dnxoy = 2.*r(18) +2.*r(21) +r(22) +r(26) +r(29) +r(41) +r(44)
     &       +r(47) +r(55) +0.10*r(64) +r(67) +r(68) +r(78) +r(81)
      rate(knxoy) = pnxoy-dnxoy
c
c        16 pan
c        ======
      rate(kpan) = r(47)-r(48)
c
c        18 hno2
c        =======
      rate(khno2) = 2.0*r(21) + r(22) -r(23) -r(24) - 2.0*r(25)
c
c        20 hno3
c        =======
      rate(khno3) = 2.*r(18) + r(26) + r(41) + r(44) + r(67) - r(27)
c
c        nitrates
c        ========
      if (.not.lnitr) go to 76
      rate(knitr) = r(55) + 0.1*r(64) + r(68) + r(78) + r(81)
c
   76 continue
c
c      write(*,901) (rate(i), i=1,30)
  901 format(7e11.3)
c
  900 return
      end
c
      subroutine chrt3s(r, rate)
c
c     *** (c) copr. 1992  systems applications, inc.  san rafael, ca
c
c
c  calculate rates for clear skies -- nxoy steady-state
c
c
c     calculation of rates if no3 and n2o5 were in steady-state.
c     in this case, nxoy is not calculated, but the lss flag is passed
c     to step4 so that nxoy concentration is set to zero to prevent
c     numerical errors in the fifth to eighth significant figures
c     from accumulating.
c
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'comchem2.cmd'
      dimension r(250), rate(mxspec)
c
c        15 nxoy not a state species when lss = true
c
c        16 pan
c        ======
      rate(kpan) = r(47)-r(48)
c
c        18 hno2
c        =======
      rate(khno2) = 2.0*r(21) + r(22) -r(23) -r(24) - 2.0*r(25)
c
c        20 hno3
c        =======
      rate(khno3) = 2.*r(18) + r(26) + r(41) + r(44) + r(67) - r(27)
c
c        nitrates
c        ========
   81 if(.not.lnitr) go to 82
      rate(knitr) = r(55) + 0.1*r(64) + r(68) + r(78) + r(81)
c
   82 continue            
c
  900 return
      end
