      subroutine stepx(deltat,time,ndate)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: stepx.f,v $
c  Revision 1.3  1999/07/07  16:42:24  tcm
c  Keep track of horizontal fluxes for pa/irr.
c
c  Revision 1.2  1994/02/10  21:01:08  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c  perform advection in x-direction for coarse grid
c
c  -- eliminated shasta option and some superfluous array transfers
c     (tcm, 9/17/91)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'comchem.cmd'
      include 'balanc.cmd'
      include 'ngmap.cmd'
      include 'advec.cmd'
c
      common /shas/ w(mxxx),cx(mxxx),d(mxxx),cb(mxxx),
     &              jadf(mxxx),nm1,b1,b2
c
czswa-----------------------------------------------------------
c  include /irrshas/ which keeps track of fluxes at the 
c  boundaries of the cells
c
      include 'irmb.cmd'
      common /irrshas/ flux1(mxxx), flux2(mxxx)
c
czswz-----------------------------------------------------------
c
      nm1=nox-1
      write(*,3001) deltat
 3001 format(' enter stepx  ',f10.2)
c
c  integrate one species at a time, one row at a time.  chemical decay
c  and wet deposition are included in stepx through the decay term
c  d(j).
c
c
c
      do 260 j=1,noy
c
c        check for out side of modeling region
c
        if (istr(j).ge.nox) go to 260
        i1=istr(j)
        i2=iend(j)
        nm1 = i2 - i1
c
c     call terms to calculate wet deposition and linear chem
c
            
        call terms(deltat,time,ndate,j)
c
c     for all species . . .
c
        do 250 l=1,nospec
c
c
c     call advection scheme for each layer
c
          do 40 k=1,nlayer
            do 20 i=i1,i2
              if (k .eq. 1) then
                dpflow(l) = dpflow(l) + decay(i,l,1)
     &               *conc(i,j,l,1)*deltat*deltay*deltax(j)
     &               *h(i,j,1)*1000.
              endif
              ii=i-i1+1
              d(ii)=decay(i,l,k)
              cx(ii)=conc(i,j,l,k)
              cb(ii)=kh(i,j,k)*deltat/deltax(j)**2
              if (mod(ingmap(i,j),10) .eq. 0) then
                jadf(ii) = 0
              else
                jadf(ii) = 1
              endif
              w(ii)=u(i,j,k)
   20       continue
c
            b1=bc(j,4,l,k)
            b2=bc(j,3,l,k)
c
c  subroutine smolar does the actual integration
c
            call smolar(deltat,deltax(j))
c
            do 25 i=i1,i2
              ii=i-i1+1
              conc(i,j,l,k)=cx(ii)
   25       continue
c
czswa-------------------------------------------------------------
c
c  now that we finished one row/col, update the flux arrays
c
            do 35 i=i1,i2
               ii=i-i1+1
               if (iflag(i,j) .gt. 0) then
                  ewflux(1,iflag(i,j),l,k) = flux1(ii) +
     &               ewflux(1,iflag(i,j),l,k)
                  ewflux(2,iflag(i,j),l,k) = flux2(ii) +
     &               ewflux(2,iflag(i,j),l,k)
c
               endif
   35       continue
c
czswz-------------------------------------------------------------
c
c  end loop over layers
c
   40     continue
c
c      end y loop
c
  250   continue
c
c    end species loop
c
  260 continue
c
c     make sure that concentrations do not go
c     below minimum value
c
      do 273 k=1,nlayer
        do 272 l=1,nospec
          do 271 j=1,noy
            do 270 i=1,nox
              if (conc(i,j,l,k).lt.bdmol(l)) then
                conc(i,j,l,k)=bdmol(l)
              endif
  270       continue
  271     continue
  272   continue 
  273 continue
c
      return
      end
