      subroutine stepxf(nxf,nyf,nzf,nspecf,fkh,uf,bcf,htf,
     &                  decayf,cncf,delfx,delfy,deltf,ifine)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: stepxf.f,v $
c  Revision 1.3  1999/07/07  16:42:49  tcm
c  Keep track of horizontal fluxes for pa/irr.
c
c  Revision 1.2  1994/02/10  21:01:14  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c  perform advection in x-direction for fine grid
c
c  -- eliminated shasta option and some superfluous array transfers
c     (tcm, 9/17/91)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'comchem.cmd'
      include 'balanc.cmd'
      include 'ngmap.cmd'
      include 'advec.cmd'
c
      common /shas/ w(mxxx),cx(mxxx),d(mxxx),cb(mxxx),
     &              jadf(mxxx),nm1,b1,b2
      dimension delfx(nyf)
      dimension fkh(nxf,nyf,nzf), uf(nxf,nyf,nzf)
      dimension bcf(mxfxy,4,mxspec,mxfz)
      dimension htf(nxf,nyf,nzf)
      dimension cncf(nxf,nyf,nspecf,nzf)
      dimension decayf(nxf,nyf,nspecf,nzf)
c
czswa-------------------------------------------------------------------
c  include /irrshas/ to keep track of fluxes at the cell boundaries
c
      include 'irmb.cmd'
      common /irrshas/ flux1(mxxx),flux2(mxxx)
c
czswz-------------------------------------------------------------------
c
      nm1=nxf-1
      write(*,3001) deltf 
 3001 format(' enter stepxf ',f10.2)
c
c  integrate one species at a time, one row at a time.  chemical decay
c  and wet deposition are included in stepx through the decay term
c  d(j).  
c
c
      i1 = 1
      i2 = nxf
c
      do 260 l=1,nspecf
        do 250 j=2,nyf-1
c
c
c     call advection scheme for each layer
c
          do 40 k=1,nzf
            do 20 i=i1,i2
              if (k .eq. 1) then
                fdpflo(l,ifine) = fdpflo(l,ifine) 
     &            + decayf(i,j,l,1)*cncf(i,j,l,1)
     &            *deltf*delfy*delfx(j)*htf(i,j,1)*1000.
              endif
              ii=i-i1+1
              d(ii)=decayf(i,j,l,k)
              cx(ii)=cncf(i,j,l,k)
              if (mod(ifngmp(i,j,ifine),10) .eq. 0) then
                jadf(ii) = 0
              else
                jadf(ii) = 1
              endif
              cb(ii)=fkh(i,j,k)*deltf/delfx(j)**2
              w(ii)=uf(i,j,k)
   20       continue
c
            b1=bcf(j,4,l,k)
            b2=bcf(j,3,l,k)
c
c  subroutine smolar does the actual integration
c
            call smolar(deltf,delfx(j))
c
            do 25 i=i1,i2
              ii=i-i1+1
              cncf(i,j,l,k) = cx(ii)
   25       continue
c
czswa--------------------------------------------------------------------
c  finish one row, update the flux arrays
c
            do i=i1,i2
               ii = i-i1+1
               iflgf=iflagf(i,j,ifine)
               if (iflgf .gt. 0) then
                  ewfluxf(1,iflgf,l,k) = flux1(ii) +
     &               ewfluxf(1,iflgf,l,k)
                  ewfluxf(2,iflgf,l,k) = flux2(ii) +
     &               ewfluxf(2,iflgf,l,k)
               endif
            enddo
c
czswz--------------------------------------------------------------------
c
c      end loop over levels
c
   40     continue
c
c  end y loop
c
  250   continue
c
c  end species loop
c
  260 continue
c 
c     make sure that concentrations do not go
c     below minimum value
c
      do 273 k=1,nzf
        do 272 l=1,nspecf
          do 271 j=1,nyf
            do 270 i=1,nxf
              if (cncf(i,j,l,k).lt.bdmol(l)) then
                cncf(i,j,l,k)=bdmol(l)
              endif
  270       continue
  271     continue
  272   continue
  273 continue
c
      return
      end
