      subroutine stepy(deltat,idebug)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: stepy.f,v $
c  Revision 1.5  1999/12/21  19:28:36  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.4  1999/07/07  16:44:43  tcm
c  Keep track of horizontal fluxes and track changes due to vertical
c  advection.
c
c  Revision 1.3  1996/06/14  23:05:52  tcm
c  correction factor added for tapering cells
c
c  Revision 1.2  1994/02/10  21:01:21  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c  perform advection in y-direction for coarse grid
c
c-- eliminated shasta option and some superfluous array transfers
c   (tcm, 9/17/91)
c
c-- lorenz cylce cleaned up and rewritten:
c   * included calculation of depth during each lorenz cycle (cae,10/22/92)
c   * moved lorenz cycle past call to smolar so that vertical adustments
c     are calculated after horizontal advection in x & y is complete
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'comchem.cmd'
      include 'ngmap.cmd'
      include 'advec.cmd'
      include 'comd3.cmd'
c
      common /shas/ w(mxxx),cx(mxxx),d(mxxx),cb(mxxx),
     &              jadf(mxxx),nm1,b1,b2
      dimension cc(mxz,mxy),ee(mxz,mxy)
      dimension zc(mxz)
c
czswa-----------------------------------------------------------
c
c  include /irrshas/ which keeps track of fluxes at the 
c  boundaries of the cells and also
c  use cold to keep track of the change in concentration
c  before/after the Lorenz cycle.
c
      include 'irmb.cmd'
      common /irrshas/ flux1(mxxx), flux2(mxxx)
      dimension cold(mxz,mxy)
c
czswz-----------------------------------------------------------
c
c
c  bit eight of idebug on (i.e., the 128s location) will turn
c  on debug writes in stepy.
c
      idiag = and(idebug,128)
c
      if (idiag.ne.0) then
         if (i.eq.7 .and. j.eq.9)
     &      write(*,3001) deltat, nlayer, nox, noy, nospec
      endif
 3001 format(' enter stepy  ',f10.2,4i10)
c
      ca=deltat/deltay
      b=deltat/deltay**2
      nm1=noy-1
      noxm1=nox-1
c
c     loop through species
c
      do 260 l=1,nospec
c
c       loop through rows
c
        do 250 i=1,nox
c
c       check if in modeling region
c
          if (jstr(i).ge.noy) go to 250
          j1=jstr(i)
          j2=jend(i)
          nm1=j2-j1
          do 25 j=j1,j2
            do 15 k=1,nlayer
              cc(k,j)=conc(i,j,l,k)
   15       continue
   25     continue
c
c     call smolarkiewicz advection scheme for each layer
c
          do 240 k=1,nlayer
            do 230 j=j1,j2
              jj=j-j1+1
              cb(jj)=b*kh(i,j,k)
              w(jj)=v(i,j,k)
              cx(jj)=cc(k,j)*deltax(j)
              if (ingmap(i,j)/10 .eq. 0) then
                jadf(jj) = 0
              else
                jadf(jj) = 1
              endif
              d(jj)=0.0
  230       continue
            b1=bc(i,2,l,k)*deltax(j1)
            b2=bc(i,1,l,k)*deltax(j2)
c
            call smolar(deltat,deltay)
c
            do 235 j=j1,j2
              jj=j-j1+1
              cc(k,j)=cx(jj)/deltax(j)
              flux1(jj) = flux1(jj)/deltax(j)
              flux2(jj) = flux2(jj)/deltax(j)
  235       continue
c
czswa-------------------------------------------------------------
c  now that we finished one row/col, update the flux arrays
c
            do 241 j=j1,j2
               jj=j-j1+1
               if (iflag(i,j) .gt. 0) then
                  snflux(1,iflag(i,j),l,k) = flux1(jj) +
     &               snflux(1,iflag(i,j),l,k)
                  snflux(2,iflag(i,j),l,k) = flux2(jj) +
     &               snflux(2,iflag(i,j),l,k)
c
               endif
  241       continue
c
c  saves concentration into cold and uses it to calculate the
c  change in concentration due to the Lorenz cycle
c
            do 242 j=j1,j2
              jj=j-j1+1
              cold(k,j)=cx(jj)/deltax(j)
  242       continue
c
czswz-------------------------------------------------------------
c
c  loop over layers
c
  240     continue
c
c     loop through columns
c
          do 220 j=j1+1,j2-1
            if (istr(j).ge.nox) go to 220
            if (idiag .ne. 0) then
              if (i .eq. nox/2.and. j .eq. noy/2) then
                write(*,*) 'before lorenz loop cc(k,j) = ',
     &                      (cc(k,j),k=1,nlayer)
                write(*,*) ' i, j, j1, j2: ', i,j,j1,j2
              endif
            endif
c
c     zero out terms for lorenz n-cylcle
c
            dt4=deltat/4.0
            a4=0.0
            b4=1.0/dt4
            do 30 k=1,nlayer
              zc(k)=0.0
   30       continue
c
c     start lorenz n-cylcle loop (n=4)
c
            do 200 i4=1,4
c
c     layer 1
c
c     entrainment and dilution terms
c
              dddt = (dnew(i,j,1)-dold(i,j,1))/datadt
              dpth = depth(i,j,1) - dddt*(4-i4)*dt4
              ee(1,j)=-cc(1,j)*dilut(i,j,1)/dpth
              cup=cc(1,j)
              if (eta(i,j,1).gt.0.0) cup=cc(2,j)
              ee(1,j)=ee(1,j)+cup*eta(i,j,1)/dpth
c
c     loop through layers
c
              do 190 k=2,nlayer-1
                kp1=k+1
                km1=k-1
c
c     entrainment and dilution terms
c
                dddt = (dnew(i,j,k)-dold(i,j,k))/datadt
                dpth = depth(i,j,k) - dddt*(4-i4)*dt4
                ee(k,j)=-cc(k,j)*dilut(i,j,k)/dpth
                cup=cc(k,j)
                if (eta(i,j,k).gt.0.0) then
                  cup=cc(kp1,j)
                endif
                cdn=cc(km1,j)
                if (eta(i,j,km1).gt.0.0) cdn=cc(k,j)
                ee(k,j)=ee(k,j) + cup*eta(i,j,k)/dpth
     &                          - cdn*eta(i,j,km1)/dpth
  190         continue
c
c     top layer
c
              km1=nlayer-1
c
c     entrainment and dilution terms
c
              dddt = (dnew(i,j,nlayer)-dold(i,j,nlayer))/datadt
              dpth = depth(i,j,nlayer) - dddt*(4-i4)*dt4
              ee(nlayer,j)=-cc(nlayer,j)*dilut(i,j,nlayer)/dpth
              cup=cc(nlayer,j)
              if (eta(i,j,nlayer).gt.0.0) then
                cup=caloft(l)
              endif
              cdn=cc(km1,j)
              if (eta(i,j,km1).gt.0.0) cdn=cc(nlayer,j)
              ee(nlayer,j)=ee(nlayer,j) + cup*eta(i,j,nlayer)/dpth
     &                        - cdn*eta(i,j,km1)/dpth
c
c     apply lorenz n-cylcle rates
c
              do 180 k = 1,nlayer
                zc(k)=(a4*zc(k)+ee(k,j))/b4
                cc(k,j)=cc(k,j)+zc(k)
  180         continue
c
c     update lorenz-cycle constants
c
              a4=a4-1.0/(deltat)
              b4=b4-1.0/(deltat)
c
  200       continue
            if (idiag .ne. 0) then
              if (i .eq. nox/2.and. j .eq. noy/2) then
                write(*,*) 'after lorenz loop cc(k,j) = ',
     &                      (cc(k,j),k=1,nlayer)
              endif
            endif
            do 201 k = 1,nlayer
              conc(i,j,l,k)=cc(k,j)
  201       continue
c
czswa-------------------------------------------------------------
c  if the cell falls within the interested region, save the change
c  in concentration
c
            if (iflag(i,j) .gt. 0) then
               do k = 1,nlayer
                  clorz(iflag(i,j),l,k)=cc(k,j)-cold(k,j)
     &                  + clorz(iflag(i,j),l,k)
               enddo
            endif
c
czswz-------------------------------------------------------------
c
  220     continue
c
c         end loop on columns
c
  250   continue
c
c       end loop on species
c
  260 continue
c
c     make sure concentrations do not go below
c     minimum value
c
      do 281 k=1,nlayer
        do 280 l=1,nospec
          do 271 j=1,noy
            do 270 i=1,nox
              if (conc(i,j,l,k).lt.bdmol(l)) then
                conc(i,j,l,k)=bdmol(l)
              endif
  270       continue
  271     continue
  280   continue
  281 continue
c
      return
      end
