      subroutine stepyf(nxf,nyf,nzf,nspecf,fkh,vf,bcf,
     &                  dilutf,depthf,etaf,doldf,
     &                  cncf,delfx,delfy,deltf,ifine)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: stepyf.f,v $
c  Revision 1.5  1999/07/07  16:45:31  tcm
c  Keep track of horizontal fluxes and track changes due to vertical
c  advection.
c
c  Revision 1.4  1998/11/04  02:01:31  tcm
c  Eliminated diagnostic write of deltf.
c
c  Revision 1.3  1996/06/14  23:07:15  tcm
c  correction factor added for tapering cells
c
c  Revision 1.2  1994/02/10  21:01:26  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c  perform advection in y-direction for fine grid
c
c  -- eliminated shasta option and some superfluous array transfers
c     (tcm, 9/17/91)
c
c-- lorenz cylce cleaned up and rewritten:
c   * included calculation of depth during each lorenz cycle (cae,10/22/92)
c   * moved lorenz cycle past call to smolar so that vertical adustments
c     are calculated after horizontal advection in x & y is complete
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'comchem.cmd'
      include 'ngmap.cmd'
      include 'advec.cmd'
c
      common /shas/ w(mxxx),cx(mxxx),d(mxxx),cb(mxxx),
     &              jadf(mxxx),nm1,b1,b2
      dimension cc(mxfz,mxfy),ee(mxfz,mxfy)
      dimension zc(mxfz)
      dimension fkh(nxf,nyf,nzf), vf(nxf,nyf,nzf)
      dimension dilutf(nxf,nyf,nzf), depthf(nxf,nyf,nzf),
     &          etaf(nxf,nyf,nzf),doldf(nxf,nyf,nzf)
      dimension bcf(mxfxy,4,mxspec,mxfz)
      dimension cncf(nxf,nyf,nspecf,nzf)
      dimension delfx(nyf)
      data idiag /0/
c
czswa---------------------------------------------------------------------
c  include /irrshas/ to keep track of fluxes at the cell boundaries,
c  also use cold to keep track of the changes in concentration
c  before/after the Lorenz cycle
c
      include 'irmb.cmd'
      common /irrshas/ flux1(mxxx), flux2(mxxx)
      dimension cold(mxfz,mxfy)
c
czswz---------------------------------------------------------------------
c
      if (idiag.ne.0) write(*,3001) deltf
 3001 format(' enter stepyf ',f10.2)
c
      ca=deltf/delfy
      b=deltf/delfy**2
      nm1=nyf-1
      j1 = 1
      j2 = nyf
      nxfm1=nxf-1
c
c     loop through species
c
      do 260 l=1,nspecf
c
c     loop through rows
c
        do 250 i=2,nxf-1
c
          do 25 j=j1,j2
            ip1=i+1
            if (ip1.gt.nxf) ip1=nxf
            im1=i-1
            if (im1.lt.1) im1=1
            do 15 k=1,nzf
              cc(k,j)=cncf(i,j,l,k)
   15       continue
   25     continue
c
c     call smolarkiewicz advection scheme for each layer
c
          do 240 k=1,nzf
            do 230 j=j1,j2
              jj=j-j1+1
              cb(jj)=b*fkh(i,j,k)
              w(jj)=vf(i,j,k)
              cx(jj)=cc(k,j)*delfx(j)
              if (ifngmp(i,j,ifine)/10 .eq. 0) then
                jadf(jj) = 0
              else
                jadf(jj) = 1
              endif
              d(jj)=0.0
  230       continue
            b1=bcf(i,2,l,k)*delfx(1)
            b2=bcf(i,1,l,k)*delfx(nyf)
c
            call smolar(deltf,delfy)
c
            do 235 j=j1,j2
              jj=j-j1+1
              cc(k,j)=cx(jj)/delfx(j)
              flux1(jj)=flux1(jj)/delfx(j)
              flux2(jj)=flux2(jj)/delfx(j)
  235       continue
c
czswa----------------------------------------------------------------
c  update the flux arrays
c
          do j=j1,j2
             jj=j-j1+1
             iflgf=iflagf(i,j,ifine)
             if (iflgf .gt. 0) then
                snfluxf(1,iflgf,l,k) = flux1(jj) +
     &             snfluxf(1,iflgf,l,k)
                snfluxf(2,iflgf,l,k) = flux2(jj) +
     &             snfluxf(2,iflgf,l,k)
             endif
          enddo
c
c  saves concentration into cold and uses it to calculate the change
c  due to Lorenz cycle
c
          do j=j1,j2
             jj=j-j1+1
             cold(k,j)=cx(jj)/delfx(j)
          enddo
c
czswz----------------------------------------------------------------
c  loop over layers
c
  240     continue
c
c     zero out terms for lorenz n-cylcle
c
          do 220 j=j1,j2
            dt4=deltf/4.0
            a4=0.0
            b4=1.0/dt4
            do 30 k = 1,nzf
              zc(k)=0.0
   30       continue
c
c     start lorentz n-cylcle loop (n=4)
c
            do 200 i4=1,4
c
c     layer 1
c     entrainment and dilution terms
c
              dddt = (depthf(i,j,1)-doldf(i,j,1))/deltf
              dpth = depthf(i,j,1) - dddt*(4-i4)*dt4
              ee(1,j)=-cc(1,j)*dilutf(i,j,1)/dpth
              cup=cc(1,j)
              if (etaf(i,j,1).gt.0.0) cup=cc(2,j)
              ee(1,j)=ee(1,j)+cup*etaf(i,j,1)/dpth
c
c       loop through layers
c
              do 190 k=2,nzf-1
                kp1=k+1
                km1=k-1
c
c     entrainment and dilution terms
c
                dddt = (depthf(i,j,k)-doldf(i,j,k))/deltf
                dpth = depthf(i,j,k) - dddt*(4-i4)*dt4
                ee(k,j)=-cc(k,j)*dilutf(i,j,k)/dpth
                cup=cc(k,j)
                if (etaf(i,j,k).gt.0.0) then
                     cup=cc(kp1,j)
                endif
                cdn=cc(km1,j)
                if (etaf(i,j,km1).gt.0.0) cdn=cc(k,j)
                ee(k,j)=ee(k,j) + cup*etaf(i,j,k)/dpth
     &                          - cdn*etaf(i,j,km1)/dpth
  190         continue
c
c     top layer
c     entrainment and dilution terms
              km1=nzf-1
              dddt = (depthf(i,j,nzf)-doldf(i,j,nzf))/deltf
              dpth = depthf(i,j,nzf) - dddt*(4-i4)*dt4
              ee(nzf,j)=-cc(nzf,j)*dilutf(i,j,nzf)/dpth
              cup=cc(nzf,j)
              if (etaf(i,j,nzf).gt.0.0) cup=caloft(l)
              cdn=cc(km1,j)
              if (etaf(i,j,km1).gt.0.0) cdn=cc(nzf,j)
              ee(nzf,j)=ee(nzf,j) + cup*etaf(i,j,nzf)/dpth
     &                          - cdn*etaf(i,j,km1)/dpth
c
c
c     apply lorenz n-cylcle rates
c
              do 180 k = 1,nzf
                zc(k)=(a4*zc(k)+ee(k,j))/b4
                cc(k,j)=cc(k,j)+zc(k)
  180         continue
              a4=a4-1.0/(deltf)
              b4=b4-1.0/(deltf)
c
  200       continue
            do 201 k = 1,nzf
              cncf(i,j,l,k)=cc(k,j)
  201       continue
c
czswa-------------------------------------------------------------------
c  ipram stuff
c
          iflgf = iflagf(i,j,ifine)
          if (iflgf .gt. 0) then
             do k = 1, nzf
                clorzf(iflgf,l,k)=cc(k,j)-cold(k,j)+
     &             clorzf(iflgf,l,k)
             enddo
          endif
c
czswz-------------------------------------------------------------------
c
  220     continue
c
c       end loop on columns
c
  250   continue
c
c     end loop on species
c
  260 continue
c
c     make sure concentrations do not go below
c     minimum value
c
      do 280 k=1,nzf
        do 281 l=1,nspecf
          do 270 j=1,nyf
            do 271 i=1,nxf
              if (cncf(i,j,l,k).lt.bdmol(l)) then
                cncf(i,j,l,k)=bdmol(l)
              endif
  271       continue
  270     continue
  281   continue
  280 continue
c
      return
      end
