      subroutine terms(deltat,time,ndate,jcell)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: terms.f,v $
c  Revision 1.4  1999/12/21  19:28:44  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.3  1998/11/03  17:30:16  tcm
c  revised date treatment to allow calendar dates past 1999
c
c  Revision 1.2  94/02/10  21:01:51  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c-----calculates wet deposition and linear so2-so4 reaction rates
c     for a single row.
c
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
      include 'latlon.cmd'
      include 'comd3.cmd'
      include 'comchem.cmd'
c
      parameter (mxset2=mxspec*mxz)
c
c     rdecay- decay rate due to wet deposition (species,layers)
c
      dimension rdecay(mxspec,mxz)
      data rrchem/0.0/
      data rdecay/mxset2*0.0/
c
c
c     convert date to day,month,year
c
      call jtocal(ndate,ncdate)
      nd=mod(ncdate,100)
      num=ncdate/100
      nm=mod(num,100)
      ny=num/100
c
c     check if inside of modeling region
c
      if (istr(jcell).ge.nox) return
      is=istr(jcell)
      ie=iend(jcell)
      do 90 i=is,ie
        if (jcell.lt.jstr(i)) go to 90
        if (jcell.gt.jend(i)) go to 90
c
c
c     if using linear so2/so4 chemistry calculate chemical
c     reaction rate based on solar zenith angle.
c
        if (.not.lchem) then
          rllng=-ctlon(i,jcell)
          rllt=ctlat(i,jcell)
c
c     use time at beginning of time step for solar zenith angle
c
          ztime=time
          call solar(rllt,rllng,tz,ny,nm,nd,ztime,zcoef)
c
c  calculate chem reaction rate as a fraction of peak rate
c    +constant rate
c
          rrchem=(pkrchm-crchem)*(zcoef/zmax)+crchem
        endif
c
c     calculate wet depostion if neccesary
c
        if (lwet) call wetdep(i,jcell,rdecay,deltat)
c
        do 60 k=1,nlayer
          do 61 isp=1,nospec
            decay(i,isp,k)=-rdecay(isp,k)
   61     continue
   60   continue
c
        if (.not.lchem) then
          do 70 k=1,nlayer
            decay(i,1,k)=decay(i,1,k)-rrchem
            decay(i,2,k)=decay(i,2,k)
     &            +1.5*rrchem*conc(i,jcell,1,k)/conc(i,jcell,2,k)
   70     continue
        endif
c
   90 continue
c
      return
      end
