      subroutine unchek
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: unchek.f,v $
c  Revision 1.5  1999/05/03  18:28:36  gem
c  added checks of additional unit numers for fine grid data files
c
c Revision 1.1  1999/05/03  17:55:36  gem
c Initial revision
c
c  Revision 1.4  1998/11/20  23:15:39  tcm
c  Fixed format of error message on line 119
c
c  Revision 1.3  1998/11/13  19:19:45  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error messages to diag and log file (ierrlg)
c
c  Revision 1.2  1994/02/10  21:02:17  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c   checks for multiple use of same unit number
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'adunit.cmd'
      include 'deffin.cmd'
      include 'idvcon.cmd'
      include 'errlog.cmd'
c
      dimension junlst(100)
      logical lustop
c
      lustop = .false.
c
c   set junlst to units already used
c
      junlst(1) = 7
      junlst(2) = 98
      junlst(3) = 99
      junlst(4) = 66
      junlst(5) = 97
      junlst(6) = 8
      junlst(7) = iuavg
      junlst(8) = 51
      junlst(9) = ifavg
      junlst(10) = ifinst
      junlst(11) = jchem
      junlst(12) = mdf
      junlst(13) = mixht
      junlst(14) = itemp
      junlst(15) = iuh2o
      junlst(16) = isurf
      junlst(17) = edf
      junlst(18) = edf1
      junlst(19) = aem1
      if (aem2 .ne. aem1) then
        junlst(20) = aem2
      else
        junlst(20) = 0
      endif
      if (aem3 .ne. aem1) then
        junlst(21) = aem3
      else
        junlst(21) = 0
      endif
      junlst(22) = icbc
      junlst(23) = icloud
      junlst(24) = irain
      junlst(25) = iterr
      junlst(26) = ikv
      junlst(27) = iagg
      junlst(28) = nphval
      junlst(29) = iupigo
      junlst(30) = iupign
      junlst(31) = ibeta 
c
c   standard input and output units (5 & 6 on unix)
c
      junlst(32) = 5
      junlst(33) = 6
      nfiles = 33
c
c   set one element of junlst equal to each unit used for a 
c   fine grid emissions, kv or mdf file
c
      do 50 ifine=1,numfin
        if (ifaem1(ifine) .gt. 0) then
          nfiles = nfiles + 1
          junlst(nfiles) = ifaem1(ifine)
        endif
        if (ifaem2(ifine) .gt. 0) then
          nfiles = nfiles + 1
          junlst(nfiles) = ifaem2(ifine)
        endif
        if (ifaem3(ifine) .gt. 0) then
          nfiles = nfiles + 1
          junlst(nfiles) = ifaem3(ifine)
        endif
        if (ifmdf(ifine) .gt. 0) then
          nfiles = nfiles + 1
          junlst(nfiles) = ifmdf(ifine)
        endif
        if (ifkv(ifine) .gt. 0) then
          nfiles = nfiles + 1
          junlst(nfiles) = ifkv(ifine)
        endif
        if (ifzp(ifine) .gt. 0) then
          nfiles = nfiles + 1
          junlst(nfiles) = ifzp(ifine)
        endif
        if (iftemp(ifine) .gt. 0) then
          nfiles = nfiles + 1
          junlst(nfiles) = iftemp(ifine)
        endif
        if (ifuh2o(ifine) .gt. 0) then
          nfiles = nfiles + 1
          junlst(nfiles) = ifuh2o(ifine)
        endif
        if (ifrain(ifine) .gt. 0) then
          nfiles = nfiles + 1
          junlst(nfiles) = ifrain(ifine)
        endif
        if (ifcld(ifine) .gt. 0) then
          nfiles = nfiles + 1
          junlst(nfiles) = ifcld(ifine)
        endif
   50 continue
c
c   check each unit value against every other except itself
c   its ok to be the same if they are zero.
c
      do 100 n=1,nfiles-1
        iu1 = junlst(n)
        do 90 nn=n+1,nfiles
          iu2 = junlst(nn)
          if (iu2 .ne. 0 .and. iu1 .ne. 0) then
            if (iu2 .eq. iu1) then
              write(*,'(a,i4,a)') 'error:  unit ',iu2, 
     &                ' is used twice.'
              write(8,'(a,i4,a)') 'error:  unit ',iu2,
     &                ' is used twice.'
              write(ierrlg,'(i4,1x,a,i4,a)') 1122,'error:  unit ',iu2,
     &                ' is used twice.'
              lustop = .true.
            endif
          endif
   90   continue
  100 continue
c
c  stop if any conflicts
c
      if (lustop) then
        write(*,'(a)') 'stopping due to above conflicts'
        write(8,'(a)') 'stopping due to above conflicts'
       write(ierrlg,'(i4,1x,a)') 1123,'stopping due to above conflicts'
        stop
      endif
c
      return
      end
