      subroutine update (time,ndate,tdatnx,totime,idebug)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: update.f,v $
c  Revision 1.20  1999/12/21  19:28:48  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.19  1999/05/20  17:51:01  gem
c  fixed time checks one final time ...
c
c  Revision 1.18  1999/05/19  19:40:45  gem
c  fixed time checks and advancing to proper time for rain file
c
c  Revision 1.17  1999/05/19  18:49:28  gem
c  fixed time check ... again
c
c  Revision 1.16  1999/05/19  18:14:34  gem
c  modified time check after reading height files to
c  check for zero next day as well as 2400 same day
c
c  Revision 1.15  1999/05/14  17:41:35  gem
c  fixed unit number in call to rdfn
c
c  Revision 1.14  1999/05/12  16:46:27  gem
c  added check for temporally varying stack temps to use
c  in call to plume rise calculations
c
c  Revision 1.13  1999/05/05  20:33:31  gem
c  cleaned up some commented out code
c
c  Revision 1.12  1999/05/03  18:29:47  gem
c  added reads of fine grid met data files
c  added appropriate calls to interpolate fine grid met data
c
c Revision 1.1  1999/05/03  17:55:36  gem
c Initial revision
c
c  Revision 1.11  1999/04/08  23:54:30  tcm
c  Check magnitude of time values to see if they are hours or hours*100
c
c  Revision 1.10  1998/11/20  23:21:01  tcm
c  Added label on format statement at line 832
c
c  Revision 1.9  1998/11/16  21:37:39  ara
c  *** empty log message ***
c
c  Revision 1.8  1998/11/13  22:42:26  ara
c  Included errlog.cmd file to introduce ierrlg variable
c
c  Directed error messages to screen, diag and log file (ierrlg)
c  directed error messages to diag and log files
c
c  Revision 1.7  1998/11/05  21:56:51  tcm
c  Added reads of header records for files with newly added headers.
c
c  Revision 1.6  1998/11/04  02:05:04  tcm
c  Many revisions to handle revised dates with 4 digit year for calendar
c  dates and Julian dates from 1951 to 2050.
c
c  Revision 1.5  1995/04/26  00:46:32  tcm
c  	read fine grid height files or interpolate if necessary.  move interpolation
c  	of fine grid wind and kv after read of heights.
c
c  Revision 1.4  94/07/27  09:40:19  tcm
c  Extended check of layer thicknesses (149 loop) to cover all layers
c  instead of just layers 1 and 2.
c  
c  Revision 1.3  94/05/17  17:21:33  tcm
c  Added code to interpolate fine grid winds and kv from another fine
c  grid when appropriate.
c  /
c  
c  Revision 1.2  94/02/10  21:02:22  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c...modified to put a cap on vertical diffusivites 7/22/91 rrs
c
c...    this program updates meteorological parameters
c
c...    files read from:
c...            mdf:    meteorological parameters:
c...                    u,v,wsurf(surface wind speed) 
c...            icbc:   initial boundary conditions 
c...            mixht:  mixing height  (km)
c...            irain:  rainfall rate  (inches/hr)
c...            itemp:  temperature    (degree kelvin)
c...            ikv:    vertical diffusion coefficient   (cm**2/sec)
c...            icloud: cloud cover    (fraction of total opaque cloud cover)
c...            iuh2o:  water vapor concentration   (ppm)
c...            ibeta:  deposition velocities (m**2/s)     gem
c...    files write to:
c...            stdout; 8;  66;
c...    routines called:
c...            diagn;   convrt;    beh084;    diffus;
c...    called by:
c...            setup;   aaamain;
c
c     -- changed to deal with optional staggered u/v grids
c        (tcm, 7/15/91)
c
c     -- plume rise updated to beh084 (cae, 10/8/91)
c
c     -- vphpxy removed from calculation of dhdt, and division of dilut
c        by depth removed; will be done in stepy (cae, 10/22/92)
c
c     -- modified to read deposition velocities from external file
c        for rom emulation ( depvel(*,*,*) calculation is bypassed.
c        (gem 12/30/92)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'deffin.cmd'
      include 'com1f.cmd'
      include 'comuam.cmd'
      include 'oneday.cmd'
      include 'comd3.cmd'
      include 'advec.cmd'
      include 'stack.cmd'
      include 'ctlflg.cmd'
      include 'adunit.cmd'
      include 'idvcon.cmd'
      include 'errlog.cmd'
c
      logical lfirst
      save lfirst
      dimension ntab(12)
      real zs(mxz), pp(mxz), tt(mxz), ww(mxz)
      character*10 mdum
      character*10 mwnd, mzp, mterr, mkv, mhum, mrain, mcld, mtmpr,
     &             msrf
c
      data mwnd  /'WIND      '/
      data mzp   /'HEIGHT    '/
      data mterr /'TERRAIN   '/
      data mtmpr /'TEMPERATUR'/
      data mhum  /'H2O       '/
      data mkv   /'VDIFFUSION'/
      data mrain /'RAIN      '/
      data mcld  /'CLOUD     '/
      data msrf  /'SURFACE   '/
c
      data ntab/31,28,31,30,31,30,31,31,30,31,30,31/
      data lfirst/.true./
c
c  bit 13 (4096's) of idebug turns on debugs in update
c
      idiag = and(idebug,4096)
c
      knteof=0
      if (ndate .lt. 99999) then
        njdate = ndate
        call jtocal(ndate,ncdate)
      else
        ncdate = ndate
        call caltoj(ndate,njdate)
      endif
      write(*,4000) time,ncdate,njdate
 4000 format(' enter update ',f10.1,i10,'(',i8,')')
c***      call dmprpm(time,ndate)
c
c  check time and date
c
   10 read(mdf,end=411) tdata,idate
      if (tdata .lt. 24.1) tdata = tdata*100.
      write(*,5001) tdata,idate,time,ndate
 5001 format(' read mdf  ',f10.1,i10,f10.1,i10)
      do 35 k=1,nlayer
c       read x-winds
        read(mdf) ((u(i,j,k),i=1,nox),j=1,noy)
c       read y-winds
        read(mdf) ((v(i,j,k),i=1,nox),j=1,noy)
c
c   surface wind speeds (see below) are in m/sec and are used in those
c   units internally.  u & v however must be converted from m/sec
c   to km/min
c
        do 34 j=1,noy
          do 33 i=1,nox
            u(i,j,k) = u(i,j,k)*.06
            v(i,j,k) = v(i,j,k)*.06
   33     continue
   34   continue
   35 continue
c
c       read the surface windspeeds
      read(mdf) ((wsurf(i,j),i=1,nox),j=1,noy)
c
c  read mdf files for fine grids also
c
      do 60 ifine=1,numfin
        if (ifmdf(ifine) .gt. 0) then
          read(ifmdf(ifine),end=411) tfdata,ifdate
          if (tfdata .lt. 24.1) tfdata = tfdata*100.
          write(*,5010) ifine,tfdata,ifdate,time,ndate
 5010     format(' read mdf, fine grid ',i3,2x,f10.1,i10,f10.1,i10)
c
c  if mdf and fine grid mdf are out of synch, stop right here and
c  now
c
          if (ifdate .ne. idate .or. abs(tfdata-tdata) .gt. .1) then
            write(*,'(a,i3)') 'mdf out of synch with fine grid ',ifine
            write(8,'(a,i3)') 'mdf out of synch with fine grid ',ifine
            write(ierrlg,'(i4,1x,a,i3)') 1124,'mdf out of synch with', 
     &         ' fine grid',ifine

            stop
          endif
          call rdfwnd(nfx(ifine),nfy(ifine),nfz(ifine),ifmdf(ifine),
     &                uf(1,1,ifine),vf(1,1,ifine),wfsrf(1,ifine))
        endif
   60 continue
c
c  check for match on time
c
      if (idate .gt. 99999) then
        call caltoj(idate,id1)
      else
        id1 = idate
      endif
      if (l1day) then
        if (abs(time-tdata).gt.1.0) go to 10
      else
        ndays = intrvl(id1,njdate)
        tchk = tdata + 2400.*ndays
        if (tchk+1.0 .lt. time) go to 10
        if (tchk-1.0 .gt. tdata) go to 110
      endif
      tdatnx=totime+dtdata
c
c     put mixing heights into current array
c
      kntmix=0
  106 continue
      do 99 k=1,nlayer
        do 98 j=1,noy
          do 97 i=1,nox
            h(i,j,k)=hnew(i,j,k)
            hold(i,j,k)=hnew(i,j,k)
   97     continue
   98   continue
   99 continue
      elapsth=0.0
c
c     put fine grid heights in current array
c
      do 109 ifine=1,numfin
        call htfage(nfx(ifine),nfy(ifine),nfz(ifine),
     &              holdf(1,1,ifine),hnewf(1,1,ifine),htf(1,1,ifine))
  109 continue
c
c  *** read in layer heights in meters
c
      do 111 k=1,nlayer
        read(mixht,end=412) ttim,iidat,((hnew(i,j,k),i=1,nox),j=1,
     &                      noy)
        read(mixht,end=412) ttim,iidat,((press(i,j,k),i=1,nox),j=1,
     &                      noy)
  111 continue
      if (ttim .lt. 24.1) ttim = ttim*100.
      do 172 k=1,nlayer
        do 171 j=1,noy
          do 170 i=1,nox
            hnew(i,j,k) = hnew(i,j,k)*.001
            press(i,j,k)=press(i,j,k)/1013.6
  170     continue
  171   continue
  172 continue
c
c  to ensure that htf is defined, interpolate it from h for
c  fine grids that do not have their own height file
c
      do 1122 ifine=1,numfin
        if (ifzp(ifine) .le. 0) then
          inttyp = 1
          call fgrtrp(mxx,mxy,nox,noy,nlayer,h,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                htf(1,1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
        endif
 1122 continue
c
c  read zp files for fine grids also
c
      do 180 ifine=1,numfin
        if (ifzp(ifine) .gt. 0) then
          call rdfzp(tfdata,ifdate,nfx(ifine),nfy(ifine),nfz(ifine),
     &                ifzp(ifine),hnewf(1,1,ifine),
     &                presf(1,1,ifine))
          if (tfdata .lt. 24.1) tfdata = tfdata*100.
          write(*,5080) ifine,tfdata,ifdate,ttim,iidat
 5080     format(' read fzp, fine grid ',i3,2x,f10.1,i10,f10.1,i10)
c
c  if zp and fine grid fzp are out of synch, stop right here and
c  now
c
          if (ifdate .ne. iidat .or. abs(tfdata-ttim) .gt. .1) then
            write(*,'(a,i3)') 'zp out of synch with fine grid ',ifine
            write(8,'(a,i3)') 'zp out of synch with fine grid ',ifine
            write(ierrlg,'(i4,1x,a,a,i3)') 1125,'zp out of synch with ', 
     &             'fine grid ',ifine 
            stop
          endif
        endif
  180 continue
      write(*,5082) ttim,iidat,time,ndate
 5082 format(' read zp   ',f10.1,i10,f10.1,i10)
c
c      if necessary, interpolate zp's to fine grids
c     
      do 182 ifine=1,numfin
c        inttyp = 1
c
        if (ifzp(ifine) .le. 0) then
          if (ifgptr(ifine) .eq. 0) then
	    inttyp = 1
            call fgrtrp(mxx,mxy,nox,noy,nlayer,hnew,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                hnewf(1,1,ifine),hnewf(1,1,ifine),
     &                ifine,inttyp,idebug)
	    inttyp = 11
            call fgrtrp(mxx,mxy,nox,noy,nlayer,press,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                presf(1,1,ifine),hnewf(1,1,ifine),
     &                ifine,inttyp,idebug)
          else
            ifget = ifgptr(ifine)
	    inttyp = 1
            call ffgtrp(nfx(ifget),nfy(ifget),nfz(ifget),
     &                hnewf(1,1,ifget),ifget,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                hnewf(1,1,ifine),hnewf(1,1,ifine),
     &                ifine,inttyp,idebug)
	    inttyp = 11
            call ffgtrp(nfx(ifget),nfy(ifget),nfz(ifget),
     &                presf(1,1,ifget),ifget,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                presf(1,1,ifine),hnewf(1,1,ifine),
     &                ifine,inttyp,idebug)
          endif
        endif
  182 continue
c
c
c
      kntmix=kntmix+1
      if (lfirst.and.kntmix.le.1) go to 106
c
      write(*,5002) ttim,iidat,time,ndate
 5002 format(' read mixht',f10.1,i10,f10.1,i10)
c     if first time through advance the mixht file to proper date
c
c     note: want hnew to be next time period for temporal changes
c           of layer heights.
c
      if (iidat .gt. 99999) then
        call caltoj(iidat,id1)
      else
        id1 = iidat
      endif
      ttim=ttim-dtdata
cgem
      if ( ttim .lt. 0. ) then
        ttim=ttim+2400.
        id1=id1-1
      endif
      call jtocal(id1,iidat)
cgem
      ndays = intrvl(id1,njdate)
      tchk = ttim + 2400.*ndays
      if (l1day) then
        if (ttim+1.0 .lt. time) go to 106
      else
        if (lfirst) then
          if (tchk+1.0 .lt. time) go to 106
        else
          if (tchk-1.0 .gt. time) go to 121
        endif
      endif
c
c     read in rainfall rate in inches/hour
c
      if (.not.lwet) go to 608
      if (irain.eq.0) go to 608
  108 continue
      read(irain,end=413) rtime,irdate,((rain(i,j),i=1,nox),j=1,noy)
      if (rtime .lt. 24.1) rtime = rtime*100.
c
c  read rain files for fine grids also
c
      do 181 ifine=1,numfin
        if (ifrain(ifine) .gt. 0) then
          call rdfrn(tfdata,ifdate,nfx(ifine),nfy(ifine),
     &                ifrain(ifine),rainf(1,ifine))
          if (tfdata .lt. 24.1) tfdata = tfdata*100.
          write(*,5081) ifine,tfdata,ifdate,ttim,iidat
 5081     format(' read rainf, fine grid ',i3,2x,f10.1,i10,f10.1,i10)
c
c  if rain and fine grid rainf are out of synch, stop right here and
c  now
c
          if (ifdate .ne. irdate .or. abs(tfdata-rtime) .gt. .1) then
            write(*,'(a,i3)') 'rain out of synch with fine grid ',ifine
            write(8,'(a,i3)') 'rain out of synch with fine grid ',ifine
            write(ierrlg,'(i4,1x,a,a,i3)') 1125,'rain out of synch ', 
     &             'with fine grid ',ifine 
            stop
          endif
        endif
  181 continue
c
      write(*,5007) rtime,irdate,time,ndate
 5007 format(' read rainfall ',f10.1,i10,f10.1,i10)
c
c     if first time through advance rain file to proper time
c
      if (irdate .gt. 99999) then
        call caltoj(irdate,id1)
      else
        id1 = irdate
      endif
      ndays = intrvl(id1,njdate)
      tchk = rtime + 2400.*ndays
      if (l1day) then
        if (rtime+1.0 .lt. time) go to 108
      else
        if (lfirst) then
          if (tchk+1.0 .lt. time) go to 108
        endif
        if (tchk-1.0 .gt. time) go to 128
      endif
c
c      if necessary, interpolate rain to fine grids
c     
      do 184 ifine=1,numfin
        inttyp = 0
        if (ifrain(ifine) .le. 0) then
          if (ifgptr(ifine) .eq. 0) then
            call fgrtrp(mxx,mxy,nox,noy,1,rain,
     &                nfx(ifine),nfy(ifine),1,
     &                rainf(1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
          else
            ifget = ifgptr(ifine)
            call ffgtrp(nfx(ifget),nfy(ifget),1,
     &                rainf(1,ifget),ifget,
     &                nfx(ifine),nfy(ifine),1,
     &                rainf(1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
          endif
        endif
  184 continue
c
c     read in deposition velocities if ibeta > 0
c
  608 continue
      if ( ibeta .gt. 0 ) then
c
        read(ibeta,end=613) btime,ibdate
        if (btime .lt. 24.1) btime = btime*100.
c
        write(*,5006) btime,ibdate,time,ndate
 5006   format(' read depvel ',f10.1,i10,f10.1,i10)
c
        do 6868 k=1,ndvsp
          ksp = kdvsp(k)
          if (ksp .eq. 0) then
            read(ibeta,end=613) ((dum,i=1,nox),j=1,noy)
          else
            read(ibeta,end=613) ((depvel(i,j,ksp),i=1,nox),j=1,noy)
          endif
          do 6085 ifine=1,numfin
c        
c        interpolate to get fine grid deposition velocities
c
            inttyp = 20
            call fgrtrp(mxx,mxy,nox,noy,nospec,depvel,
     &                    nfx(ifine),nfy(ifine),nospec,
     &                    depvelf(1,1,ifine),holdf(1,1,ifine),
     &                    ifine,inttyp,idebug)
            if (idiag .ne. 0) then
              write(*,'(a,i3)')
     &              ' finished fgrtrp depvelf for fg#',ifine
            endif
 6085     continue
 6868   continue
        if (ibdate .gt. 99999) then
          call caltoj(ibdate,id1)
        else
          id1 = ibdate
        endif
        ndays = intrvl(id1,njdate)
        tchk = btime + 2400.*ndays
c
c     if first time through advance depvel file to proper time
c
        if (l1day) then
          if (btime+1.0 .lt. time) go to 608
        else
          if (lfirst) then
            if (tchk+1.0 .lt. time) go to 608
          endif
          if (tchk-1.0 .gt. time) go to 628
        endif
c
      endif
c
c     read in temperature field (degrees kelven)
c
  113 continue
      read(itemp,end=414) ttim,iidat,((tsurf(i,j),i=1,nox),j=1,noy)
      do 1113 k=1,nlayer
        read(itemp,end=414) ttim,iidat,((temper(i,j,k),i=1,nox),j=1,noy)
 1113 continue
      if (ttim .lt. 24.1) ttim = ttim*100.
c
c  read temp files for fine grids also
c
      do 71 ifine=1,numfin
        if (iftemp(ifine) .gt. 0) then
          call rdftmp(tfdata,ifdate,nfx(ifine),nfy(ifine),nfz(ifine),
     &                iftemp(ifine),temprf(1,1,ifine),
     &                tfsurf(1,ifine))
          if (tfdata .lt. 24.1) tfdata = tfdata*100.
          write(*,5021) ifine,tfdata,ifdate,ttim,iidat
 5021     format(' read ftmp, fine grid ',i3,2x,f10.1,i10,f10.1,i10)
c
c  if temp and fine grid ftemp are out of synch, stop right here and
c  now
c
          if (ifdate .ne. iidat .or. abs(tfdata-ttim) .gt. .1) then
            write(*,'(a,i3)') ' temp out of synch with fine grid ',ifine
            write(8,'(a,i3)') ' temp out of synch with fine grid ',ifine
            write(ierrlg,'(i4,1x,a,a,i3)') 1113,
     &         'temp out of synch with fine grid ',ifine  
            stop
          endif
        endif
   71 continue
c
      if (iidat .gt. 99999) then
        call caltoj(iidat,id1)
      else
        id1 = iidat
      endif
      ndays = intrvl(id1,njdate)
      tchk = ttim + 2400.*ndays
c
      write(*,5003) ttim,iidat,time,ndate
 5003 format(' read temp ',f10.1,i10,f10.1,i10)
c     if first time through advance temp file to proper time
c
      if (l1day) then
        if (ttim+1.0 .lt. time) go to 113
      else
        if (lfirst) then
          if (tchk+1.0 .lt. time) go to 113
        endif
        if (tchk-1.0 .gt. time) go to 123
      endif
  404 continue
c
c      if necessary, interpolate temp's to fine grids
c     
      do 183 ifine=1,numfin
c        inttyp = 1
c
        if (iftemp(ifine) .le. 0) then
          if (ifgptr(ifine) .eq. 0) then
	    inttyp = 11
            call fgrtrp(mxx,mxy,nox,noy,nlayer,temper,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                temprf(1,1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
	    inttyp = 21
            call fgrtrp(mxx,mxy,nox,noy,1,tsurf,
     &                nfx(ifine),nfy(ifine),1,
     &                tfsurf(1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
          else
            ifget = ifgptr(ifine)
	    inttyp = 11
            call ffgtrp(nfx(ifget),nfy(ifget),nfz(ifget),
     &                temprf(1,1,ifget),ifget,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                temprf(1,1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
	    inttyp = 21
            call ffgtrp(nfx(ifget),nfy(ifget),1,
     &                tfsurf(1,ifget),ifget,
     &                nfx(ifine),nfy(ifine),1,
     &                tfsurf(1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
          endif
        endif
  183 continue
c
c  read the boundry conditions
c
      call getbc(time,ndate,icbc,ibeof)
      if (ibeof .ne. 0) then
        write(*,*) ' end of file on boundary file.'
        write(8,*) ' end of file on boundary file.'   
        write(ierrlg,*) 1126, '  end of file on boundary file.'
        stop
      endif
c
c  convert bcs from ppm to micromoles/m3
c
      call cnvtbc
c
c  if not an inert run, read the haze and ozone column codes
c
      if (.not.linert) then
        call gethaz(time,ndate,nphval,iheof)
c
c      ... a problem finding the time on the file?
c          rewind file, position and try again.
c
        if (iheof .ne. 0) then
          rewind nphval
c
c      skip until end of albedo section found
c
          read(nphval,'(a10)') mdum
          read(nphval,'(a10)') mdum
 4045     read(nphval,'(a10,a10)') mdum, mdum2
          call lftpak(mdum)
          if (mdum .ne. 'albedo   ') go to 4045
          read(mdum2,'(i10)') iff
          if (iff .gt. 0) go to 4045
c
c      now try again
c
          call gethaz(time,ndate,nphval,iheof)
          if (iheof .ne. 0) then
            write(*,*) ' error reading albedo-haze-ozone col file'
            write(8,*) ' error reading albedo-haze-ozone col file' 
            write(ierrlg,*) 1127,'  error reading albedo-haze-ozone ',
     &            'col file' 
            stop
          endif
        endif
      endif
c
c     read in vertical diffusion field
c
  228 continue
      do 1128 k=1,nlayer
        read(ikv,end=429) ttim,iidat,((kv(i,j,k),i=1,nox),j=1,noy)
 1128 continue
      if (ttim .lt. 24.1) ttim = ttim*100.
c
c  read fkv files for fine grids also
c
      do 70 ifine=1,numfin
        if (ifkv(ifine) .gt. 0) then
          call rdfkv(tfdata,ifdate,nfx(ifine),nfy(ifine),nfz(ifine),
     &                ifkv(ifine),fkv(1,1,ifine),
     &                htf(1,1,ifine))
          if (tfdata .lt. 24.1) tfdata = tfdata*100.
          write(*,5020) ifine,tfdata,ifdate,ttim,iidat
 5020     format(' read fkv, fine grid ',i3,2x,f10.1,i10,f10.1,i10)
c
c  if kv and fine grid fkv are out of synch, stop right here and
c  now
c
          if (ifdate .ne. iidat .or. abs(tfdata-ttim) .gt. .1) then
            write(*,'(a,i3)') 'kv out of synch with fine grid ',ifine
            write(8,'(a,i3)') 'kv out of synch with fine grid ',ifine
            write(ierrlg,'(i4,1x,a,a,i3)') 1128,'kv out of synch with ',
     &             'fine grid ',ifine  
            stop
          endif
        endif
   70 continue
c
c...    input kv values are in m**2/sec, convert to cm**2/sec
c...    this version limits kv's to 0.4*layer height (m)
c
      do 1112 kkv1=1,nlayer
        do 1111 jkv1=1,noy
          do 1110 ikv1=1,nox
            zzmx=400.*h(ikv1,jkv1,kkv1)
            if(kv(ikv1,jkv1,kkv1).gt.zzmx)kv(ikv1,jkv1,kkv1)=zzmx
            kv(ikv1,jkv1,kkv1)=kv(ikv1,jkv1,kkv1)*10000.0
 1110     continue
 1111   continue
 1112 continue
      write(*,5004) ttim,iidat,time,ndate
 5004 format(' read kv   ',f10.1,i10,f10.1,i10)
      if (iidat .gt. 99999) then
        call caltoj(iidat,id1)
      else
        id1 = iidat
      endif
      ndays = intrvl(id1,njdate)
      tchk = ttim + 2400.*ndays
c
c     if first time through advance vertdifkv file to proper time
c
      if (l1day) then
        if (ttim+1.0 .lt. time) go to 228
      else
        if (lfirst) then
          if (tchk+1.0 .lt. time) go to 228
        endif
        if (tchk-1.0 .gt. time) go to 328
      endif
c
c     read in cloud cover data
c     in fractions of total opaque cloud cover
c
  115 continue
      if (icloud.gt.0) then
 1115   continue
        do 1151 kkgg=1,nlayer
          read(icloud,end=415) ttim,iidat,((cloud(i,j,kkgg),i=1,nox),
     &                      j=1,noy)
          read(icloud,end=415)ttim,iidat,((cwater(i,j,kkgg),i=1,nox),
     &                      j=1,noy)
 1151   continue
        if (ttim .lt. 24.1) ttim = ttim*100.
c
c  read cloud files for fine grids also
c
      do 73 ifine=1,numfin
        if (iftemp(ifine) .gt. 0) then
          call rdfcld(tfdata,ifdate,nfx(ifine),nfy(ifine),nfz(ifine),
     &                ifcld(ifine),cloudf(1,1,ifine),
     &                cwatrf(1,1,ifine))
          if (tfdata .lt. 24.1) tfdata = tfdata*100.
          write(*,5023) ifine,tfdata,ifdate,ttim,iidat
 5023     format(' read fcld, fine grid ',i3,2x,f10.1,i10,f10.1,i10)
c
c  if cloud and fine grid fcloud are out of synch, stop right here and
c  now
c
          if (ifdate .ne. iidat .or. abs(tfdata-ttim) .gt. .1) then
            write(*,'(a,i3)')'cloud out of synch with fine grid ',ifine
            write(8,'(a,i3)')'cloud out of synch with fine grid ',ifine
            write(ierrlg,'(i4,1x,a,a,i3)') 1113,
     &         'cloud out of synch with fine grid ',ifine  
            stop
          endif
        endif
   73 continue
c
        write(*,5008) ttim,iidat,time,ndate
 5008   format(' read cloud',f10.1,i10,f10.1,i10)
        if (iidat .gt. 99999) then
          call caltoj(iidat,id1)
        else
          id1 = iidat
        endif
        ndays = intrvl(id1,njdate)
        tchk = ttim + 2400.*ndays
c
c     if first time through advance cloud file to proper time period
c
        if (l1day)  then
          if (ttim+1.0 .lt. time) go to 1115
        else
          if (lfirst) then
            if (tchk+1.0 .lt. time) go to 1115
          endif
          if (tchk-1.0 .gt. time) go to 125
        endif
      endif
c
c      if necessary, interpolate cloud's to fine grids
c     
      do 186 ifine=1,numfin
        inttyp = 10
        if (ifcld(ifine) .le. 0) then
          if (ifgptr(ifine) .eq. 0) then
            call fgrtrp(mxx,mxy,nox,noy,nlayer,cloud,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                cloudf(1,1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
            call fgrtrp(mxx,mxy,nox,noy,nlayer,cwater,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                cwatrf(1,1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
          else
            ifget = ifgptr(ifine)
            call ffgtrp(nfx(ifget),nfy(ifget),nfz(ifget),
     &                cloudf(1,1,ifget),ifget,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                cloudf(1,1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
            call ffgtrp(nfx(ifget),nfy(ifget),nfz(ifget),
     &                cwatrf(1,1,ifget),ifget,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                cwatrf(1,1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
          endif
        endif
  186 continue
c
c     read in water vapor concentration (ppm)
c
  117 continue
      do 1117 k=1,nlayer
        read(iuh2o,end=416) ttim,iidat,((ch2o(i,j,k),i=1,nox),j=1,noy)
 1117 continue
      if (ttim .lt. 24.1) ttim = ttim*100.
c
c  read h2o files for fine grids also
c
      do 733 ifine=1,numfin
        if (ifuh2o(ifine) .gt. 0) then
          call rdfh2o(tfdata,ifdate,nfx(ifine),nfy(ifine),nfz(ifine),
     &                ifuh2o(ifine),ch2of(1,1,ifine))
          if (tfdata .lt. 24.1) tfdata = tfdata*100.
          write(*,5024) ifine,tfdata,ifdate,ttim,iidat
 5024     format(' read fh2o, fine grid ',i3,2x,f10.1,i10,f10.1,i10)
c
c  if h2o and fine grid fh2o are out of synch, stop right here and
c  now
c
          if (ifdate .ne. iidat .or. abs(tfdata-ttim) .gt. .1) then
            write(*,'(a,i3)')'h2o out of synch with fine grid ',ifine
            write(8,'(a,i3)')'h2o out of synch with fine grid ',ifine
            write(ierrlg,'(i4,1x,a,a,i3)') 1113,
     &         'h2o out of synch with fine grid ',ifine  
            stop
          endif
        endif
  733 continue
c
      write(*,5005) ttim,iidat,time,ndate
 5005 format(' read water',f10.1,i10,f10.1,i10)
      if (iidat .gt. 99999) then
        call caltoj(iidat,id1)
      else
        id1 = iidat
      endif
      ndays = intrvl(id1,njdate)
      tchk = ttim + 2400.*ndays
      if (l1day) then
        if (ttim+1.0 .lt. time) go to 117
      else
        if (lfirst) then
          if (tchk+1.0 .lt. time) go to 117
        endif
        if (tchk-1.0 .gt. time) go to 129
      endif
c
c      if necessary, interpolate ch2o's to fine grids
c     
      do 187 ifine=1,numfin
        inttyp = 10
        if (ifuh2o(ifine) .le. 0) then
          if (ifgptr(ifine) .eq. 0) then
            call fgrtrp(mxx,mxy,nox,noy,nlayer,ch2o,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                ch2of(1,1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
          else
            ifget = ifgptr(ifine)
            call ffgtrp(nfx(ifget),nfy(ifget),nfz(ifget),
     &                ch2of(1,1,ifget),ifget,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                ch2of(1,1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
          endif
        endif
  187 continue
c
c
      if (idiag .gt. 0) then
        write(*,*) ' check layer thicknesses'
      endif
c
c     check to make sure that layers are at least 10 meters thick
c
      do 149 kk=1,nlayer-1
        k=kk+1
        do 148 j=1,noy
          do 147 i=1,nox
            i1=i-1
            i2=i+1
            j1=j-1
            j2=j+1
            if (i1.lt.1) i1=1
            if (i2.gt.nox) i2=nox
            if (j1.lt.1) j1=1
            if (j2.gt.noy) j2=noy
c
            htmax=0.0
            do 146 ii=i1,i2
              do 145 jj=j1,j2
                if (htmax.lt.(hnew(ii,jj,kk)+0.01)) 
     &                          htmax=hnew(ii,jj,kk)+0.01
  145         continue
  146       continue
c
            if (hnew(i,j,k).ge.htmax) go to 147
            hnew(i,j,k)=htmax
  147     continue
  148   continue
  149 continue
c
      noxm1=nox-1
      noym1=noy-1
      noxp1=nox+1
      noyp1=noy+1
c
c     loop through grid
c
      do 210 j=1,noy
        do 205 i=1,nox
c
c     loop through layers -- calculate layer depth
c
          do 200 k=1,nlayer
            dold(i,j,k)=h(i,j,k)
            if (k.gt.1) dold(i,j,k)=h(i,j,k)-h(i,j,k-1)
            dnew(i,j,k)=hnew(i,j,k)
            if (k.gt.1) dnew(i,j,k)=hnew(i,j,k)-hnew(i,j,k-1)
  200     continue
  205   continue
  210 continue
c
c-----prepare inputs for, and call plume rise algorithm
c
      if (idiag .gt. 0) then
        write(*,*) ' calculate plumerise for all sources'
      endif
 
      do 152 l=1,nopts
c        ix=int((plong(l)-wlong)/dlong)+1
c        jy=int((plat(l)-slat)/dlat)+1
        call convrt(plong(l),plat(l),ix,jy)
        if (ix.lt.istr(jy)) go to 152
        if (ix.gt.iend(jy)) go to 152
        if (jy.lt.jstr(ix)) go to 152
        if (jy.gt.jend(ix)) go to 152
        do 151 kk=1,nlayer
          zs(kk) = 1000.*h(ix,jy,kk)
          pp(kk) = 1013.*press(ix,jy,kk)
          tt(kk) = temper(ix,jy,kk)
          if (lstagr) then
            if (ix .gt. 1) then
              uchk = (u(ix,jy,kk)+u(ix-1,jy,kk))/2.
            else
              uchk = u(ix,jy,kk)/2.
            endif
            if (jy .gt. 1) then
              vchk = (v(ix,jy,kk)+v(ix,jy-1,kk))/2.
            else
              vchk = v(ix,jy,kk)/2.
            endif
          else
            uchk = u(ix,jy,kk)
            vchk = v(ix,jy,kk)
          endif
          ww(kk) = 16.67*sqrt(uchk**2.+vchk**2.)
  151   continue

        if ( lstkt(l) ) then
	  tmpstk = stktmp(l)
	else
	  tmpstk = temps(l)
	endif
        if (idiag .gt. 0) then
          write(*,*) ' Calculate plumerise for source ', l 
          write(*,*) ' at ', ix, jy
          write(*,*) ' Stack params: ', stkht(l), stkd(l), 
     &                  vexit(l), tmpstk
        endif
        call beh084(stkht(l),stkd(l),vexit(l),tmpstk,zs,
     &               ww,tt,pp,nlayer,heff(l))
        if (idiag .gt. 0) then
          write(*,*) ' Calculated plume height is ', heff(l)
        endif
        
  152 continue

      lfirst=.false.
c
c     calculate diffusivities
c
      if (idiag .gt. 0) then
        write(*,*) ' calculate diffusivities'
      endif
      call diffus
c
c *** calculate diagnostics
c
      if (idiag .gt. 0) then
        write(*,*) ' call diagn'
      endif
      call diagn(time,ndate,2,0.,0.,0,0)
c
c *** check layer heights for fine grids
c
      do 720 ifine=1,numfin
        if (ifzp(ifine) .gt. 0) then
          if (ifgptr(ifine) .eq. 0) then
            call ckhgt(ifgptr(ifine),mxx,mxy,nox,noy,nlayer,hnew,
     &            ifine,nfx(ifine),nfy(ifine),nfz(ifine),
     &            hnewf(1,1,ifine))
          else
            ifget = ifgptr(ifine)
            call ckhgt(ifget,nfx(ifget),nfy(ifget),
     &            nfx(ifget),nfy(ifget),nfz(ifget),hnewf(1,1,ifget),
     &            ifine,nfx(ifine),nfy(ifine),nfz(ifine),
     &            hnewf(1,1,ifine))
          endif
        endif
  720 continue
c
c      if necessary, interpolate winds to fine grids--
c     
      do 730 ifine=1,numfin
        inttyp = 10
        if (ifmdf(ifine) .le. 0) then
          if (ifgptr(ifine) .eq. 0) then
            call fgrtrp(mxx,mxy,nox,noy,nlayer,u,
     &                  nfx(ifine),nfy(ifine),nfz(ifine),
     &                  uf(1,1,ifine),hnewf(1,1,ifine),
     &                  ifine,inttyp,idebug)
            call fgrtrp(mxx,mxy,nox,noy,nlayer,v,
     &                  nfx(ifine),nfy(ifine),nfz(ifine),
     &                  vf(1,1,ifine),hnewf(1,1,ifine),
     &                  ifine,inttyp,idebug)
          else
            ifget = ifgptr(ifine)
            call ffgtrp(nfx(ifget),nfy(ifget),nfz(ifget),
     &                  uf(1,1,ifget),ifget,
     &                  nfx(ifine),nfy(ifine),nfz(ifine),
     &                  uf(1,1,ifine),hnewf(1,1,ifine),
     &                  ifine,inttyp,idebug)
            call ffgtrp(nfx(ifget),nfy(ifget),nfz(ifget),
     &                  vf(1,1,ifget),ifget,
     &                  nfx(ifine),nfy(ifine),nfz(ifine),
     &                  vf(1,1,ifine),hnewf(1,1,ifine),
     &                  ifine,inttyp,idebug)
          endif
        endif
  730 continue
c
c      if necessary, interpolate kv's to fine grids
c     
      do 740 ifine=1,numfin
        inttyp = 0
        if (ifkv(ifine) .le. 0) then
          if (ifgptr(ifine) .eq. 0) then
            call fgrtrp(mxx,mxy,nox,noy,nlayer,kv,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                fkv(1,1,ifine),holdf(1,1,ifine), 
     &                ifine,inttyp,idebug)
          else
            ifget = ifgptr(ifine)
            call ffgtrp(nfx(ifget),nfy(ifget),nfz(ifget),
     &                fkv(1,1,ifget),ifget,
     &                nfx(ifine),nfy(ifine),nfz(ifine),
     &                fkv(1,1,ifine),holdf(1,1,ifine),
     &                ifine,inttyp,idebug)
          endif
        endif
  740 continue
c
      return
c
c  if time or date of data is in error, print message and stop
  110 write(66,120) time,ndate,tdata,idate
      write(*,120) time,ndate,tdata,idate 
      write(8,120) time,ndate,tdata,idate
      write(ierrlg,131) 1129,time,ndate,tdata,idate
  120 format('1**ERROR:  Data for',f6.0,' on',i8,' is labeled',
     &        f6.0,'on',i8)
  131 format(i4,1x,'1**ERROR:  Data for',f6.0,' on',i8,' is labeled',
     &        f6.0,'on ',i8)
      stop21
  123 write(66,124) time,ndate,ttim,iidat
      write(*,124) time,ndate,ttim,iidat
      write(8,124) time,ndate,ttim,iidat
      write(ierrlg,135) 1130,time,ndate,ttim,iidat
  124 format(' **ERROR:  temperature data for',f10.1,i10,
     &        ' is labeled ',f10.1,i10)
  135 format(i4,1x,' **ERROR:  temperature data for',f10.1,i10,
     &        ' is labeled ',f10.1,i10)
      stop22
  125 write(66,126) time,ndate,ttim,iidat
      write(*,126) time,ndate,ttim,iidat 
      write(8,126) time,ndate,ttim,iidat
      write(ierrlg,137) 1131,time,ndate,ttim,iidat
  126 format(' **ERROR:  cloud data for',f10.1,i10,' is labeled ',
     &        f10.1,i10)
  137 format(i4,1x,' **ERROR:  cloud data for',f10.1,i10,' is labeled '
     &       ,f10.1,i10)
      stop23
  129 write(66,130) time,ndate,ttim,iidat
      write(*,130) time,ndate,ttim,iidat
      write(8,130) time,ndate,ttim,iidat
      write(ierrlg,133) 1132,time,ndate,ttim,iidat
  130 format(' **ERROR:  water data for',f10.1,i10,' is labeled ',
     &        f10.1,i10)
  133 format(i4,1x,' **ERROR:  water data for',f10.1,i10,' is labeled',
     &        f10.1,i10)
      stop24
  121 write(66,122) time,ndate,ttim,iidat
  122 format(' **ERROR:  mixht data for',f10.1,i10,' is labeled ',
     &        f10.1,i10)
      stop25
  628 write(66,227) time,ndate,btime,ibdate
      write(*,227) time,ndate,btime,ibdate
      write(8,227) time,ndate,btime,ibdate
      write(ierrlg,229) 1133,time,ndate,btime,ibdate
  227 format(' **ERROR:  depvel data for',f10.1,i10,' is labeled ',
     &        f10.1,i10)
  229 format(i4,1x,' **ERROR:  depvel data for',f10.1,i10,' is labeled'
     &       ,f10.1,i10)
      stop28
  128 write(66,127) time,ndate,rtime,irdate
      write(*,127) time,ndate,rtime,irdate
      write(8,127) time,ndate,rtime,irdate
      write(ierrlg,134) 1134,time,ndate,rtime,irdate
  127 format(' **ERROR:  rain data for',f10.1,i10,' is labeled ',
     &        f10.1,i10)
  134 format(i4,1x,' **ERROR: rain data for',f10.1,i10,' is labeled ',
     &        f10.1,i10)
      stop26
  328 write(66,138) time,ndate,ttim,iidat
      write(*,138) time,ndate,ttim,iidat
      write(8,138) time,ndate,ttim,iidat
      write(ierrlg,139) 1135,time,ndate,ttim,iidat
  138 format(' **ERROR:  kv data for',f10.1,i10,' is labeled ',
     &        f10.1,i10)
  139 format(i4,1x,' **ERROR:  kv data for',f10.1,i10,' is labeled ',
     &        f10.1,i10)
      stop27
  411 continue
      if (.not.l1day) then
        write(6,5011) time,ndate,tdata,idate
        write(8,5011) time,ndate,tdata,idate
        write(ierrlg,5009) 1136,time,ndate,tdata,idate
 5011   format(' ERROR eof on mdf ',2(f10.1,i10))
 5009   format(i4,1x,' ERROR eof on mdf ',2(f10.1,i10))
        stop4
      endif
      knteof=knteof+1
      if (knteof.gt.10) then
        write(6,6011) time,ndate,tdata,idate
        write(8,6011) time,ndate,tdata,idate
        write(ierrlg,6010) 1137,time,ndate,tdata,idate
 6011   format(' eof mdf one day error ',2(f10.1,i10))
 6010   format(i4,1x,' eof mdf one day error ',2(f10.1,i10))
        stop3
      endif
      rewind mdf
      call hdrchk(mdf, mwnd, xorg, yorg, nox, noy, nlayer)
      go to 10
c
  412 continue
      if (.not.l1day) then
        write(6,5012) time,ndate,ttim,iidat
        write(8,5012) time,ndate,ttim,iidat
        write(ierrlg,5019) 1138,time,ndate,ttim,iidat
 5012   format(' ERROR eof on mixht ',2(f10.1,i10))
 5019   format(i4,1x,' ERROR eof on mixht ',2(f10.1,i10))
        stop4
      endif
      knteof=knteof+1
      if (knteof.gt.10) then
        write(6,6012) time,ndate,ttim,iidat
        write(8,6012) time,ndate,ttim,iidat
        write(ierrlg,6019) 1139,time,ndate,ttim,iidat
 6012   format(' eof mixht one day error ',2(f10.1,i10))
 6019   format(i4,1x,' eof mixht one day error ',2(f10.1,i10))
        stop3
      endif
      rewind mixht
      call hdrchk(mixht, mzp, xorg, yorg, nox, noy, nlayer)
      go to 106
c
  413 continue
      if (.not.l1day) then
        write(6,5013) time,ndate,rtime,irdate
        write(8,5013) time,ndate,rtime,irdate
        write(ierrlg,5018) 1140,time,ndate,rtime,irdate
 5013   format(' ERROR eof on rain ',2(f10.1,i10))
 5018   format(i4,1x,' ERROR eof on rain ',2(f10.1,i10))
        stop4
      endif
      knteof=knteof+1
      if (knteof.gt.10) then
        write(6,6013) time,ndate,rtime,irdate
        write(8,6013) time,ndate,rtime,irdate
        write(ierrlg,6018) 1141,time,ndate,rtime,irdate 
 6013   format(' eof rain one day error ',2(f10.1,i10))
 6018   format(i4,1x,' eof rain one day error ',2(f10.1,i10))
        stop3
      endif
      rewind irain
      call hdrchk(mixht, mzp, xorg, yorg, nox, noy, nlayer)
      go to 108
c
  613 continue
      if (.not.l1day) then
        write(6,5613) time,ndate,btime,ibdate
        write(8,5613) time,ndate,btime,ibdate
        write(ierrlg,5614) 1142,time,ndate,btime,ibdate
 5613   format(' ERROR eof on depvel ',2(f10.1,i10))
 5614   format(i4,1x,' ERROR eof on depvel ',2(f10.1,i10))
        stop4
      endif
      knteof=knteof+1
      if (knteof.gt.10) then
        write(6,6513) time,ndate,btime,ibdate
        write(8,6513) time,ndate,btime,ibdate 
        write(ierrlg,6514) 1143,time,ndate,btime,ibdate
 6513   format(' eof depvel one day error ',2(f10.1,i10))
 6514   format(i4,1x,' eof depvel one day error ',2(f10.1,i10))
        stop3
      endif
      rewind ibeta
      go to 608
c
  414 continue
      if (.not.l1day) then
        write(6,5014) time,ndate,ttim,iidat
        write(8,5014) time,ndate,ttim,iidat 
        write(ierrlg,5115) 1144,time,ndate,ttim,iidat
 5014   format(' ERROR eof on temper ',2(f10.1,i10))
 5115   format(i4,1x,' ERROR eof on temper ',2(f10.1,i10))
        stop4
      endif
      knteof=knteof+1
      if (knteof.gt.10) then
        write(6,6014) time,ndate,ttim,iidat
        write(8,6014) time,ndate,ttim,iidat
        write(ierrlg,6114) 1145,time,ndate,ttim,iidat
 6014   format(' eof temper one day error ',2(f10.1,i10))
 6114   format(i4,1x,' eof temper one day error ',2(f10.1,i10))
        stop3
      endif
      rewind itemp
      call hdrchk(itemp, mtmpr, xorg, yorg, nox, noy, nlayer)
      go to 113
c
  415 continue
      if (.not.l1day) then
        write(6,5015) time,ndate,ttim,iidat
        write(8,5015) time,ndate,ttim,iidat
        write(ierrlg,5116) 1146,time,ndate,ttim,iidat
 5015   format(' ERROR eof on cloud ',2(f10.1,i10))
 5116   format(i4,1x,' ERROR eof on cloud ',2(f10.1,i10))
        stop4
      endif
      knteof=knteof+1
      if (knteof.gt.10) then
        write(6,6015) time,ndate,ttim,iidat
        write(8,6015) time,ndate,ttim,iidat
        write(ierrlg,6116) 1147,time,ndate,ttim,iidat
 6015   format(' eof cloud one day error ',2(f10.1,i10))
 6116   format(i4,1x,' eof cloud one day error ',2(f10.1,i10))
        stop3
      endif
      rewind icloud
      call hdrchk(icloud, mcld, xorg, yorg, nox, noy, nlayer)
      go to 115
c
  416 continue
      if (.not.l1day) then
        write(6,5016) time,ndate,ttim,iidat
        write(8,5016) time,ndate,ttim,iidat
        write(ierrlg,5117) 1148,time,ndate,ttim,iidat
 5016   format(' ERROR eof on water ',2(f10.1,i10))
 5117   format(i4,1x,' ERROR eof on water ',2(f10.1,i10))
        stop4
      endif
      knteof=knteof+1
      if (knteof.gt.10) then
        write(6,6016) time,ndate,ttim,iidat
        write(8,6016) time,ndate,ttim,iidat
        write(ierrlg,6117) 1149,time,ndate,ttim,iidat
 6016   format(' eof water one day error ',2(f10.1,i10))
 6117   format(i4,1x,' eof water one day error ',2(f10.1,i10))
        stop3
      endif
      rewind iuh2o
      call hdrchk(iuh2o, mhum, xorg, yorg, nox, noy, nlayer)
      go to 117
c
  429 continue
      if (.not.l1day) then
        write(6,5028) time,ndate,ttim,iidat
        write(8,5028) time,ndate,ttim,iidat
        write(ierrlg,5128) 1150,time,ndate,ttim,iidat
 5028   format(' ERROR eof on kv ',2(f10.1,i10))
 5128   format(i4,1x,' ERROR eof on kv ',2(f10.1,i10))
        stop4
      endif
      knteof=knteof+1
      if (knteof.gt.10) then
        write(6,6028) time,ndate,ttim,iidat
        write(8,6028) time,ndate,ttim,iidat
        write(ierrlg,6128) 1151,time,ndate,ttim,iidat
 6028   format(' eof kv one day error ',2(f10.1,i10))
 6128   format(i4,1x,' eof kv one day error ',2(f10.1,i10))
        stop3
      endif
      rewind ikv
      call hdrchk(ikv, mkv, xorg, yorg, nox, noy, nlayer)
      go to 228
c
      end
