      subroutine vertwd (time,ndate,idebug)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: vertwd.f,v $
c  Revision 1.3  1999/12/21  19:28:50  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.2  1994/02/10  21:02:32  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c...    routines called:
c...            none
c...    called by:
c...            aaamain
c
c     this routine uses the same idebug value as update
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comuam.cmd'
      include 'comd3.cmd'
      include 'advec.cmd'
      dimension dddt(mxz),dhdt(mxz),div(mxz),w(mxz)
c
c  bit 13 (4096's) of idebug turns on debugs in update and vertwd
c
      idiag = and(idebug,4096)
c
      if (idiag .gt. 0) then
        write(*,*) ' calculate divergence'
      endif
      noxm1=nox-1
      noym1=noy-1
      noxp1=nox+1
      noyp1=noy+1
c
c     loop through grid
c
      do 301 j=1,noy
        do 300 i=1,nox
c
c     establish indicies
c
          ip1=i+1
          jp1=j+1
          im1=i-1
          jm1=j-1
          i2=i
          j2=j
          if (i .gt. 1) then
            ii1 = i - 1
          else
            ii1 = i
          endif
          if (j .gt. 1) then
            jj1 = j - 1
          else
            jj1 = j
          endif
c
c     loop through layers
c
          do 200 k=1,nlayer
c
c     upstream differencing
c
            i1=im1
            j1=jm1
            if (lstagr) then
              uchk = .5*(u(i,j,k) + u(ii1,j,k))
              vchk = .5*(v(i,j,k) + v(i,jj1,k))
            else
              uchk = u(i,j,k)
              vchk = v(i,j,k)
            endif
            if (uchk.lt.0.0) i1=ip1
            if (vchk.lt.0.0) j1=jp1
c
c     inflow boundaries, set indicies equal
c
            if (i1.eq.0 .or. i1.eq.noxp1) i1=i2
            if (j1.eq.0 .or. j1.eq.noyp1) j1=j2
c
c     total derivative of h(k) - upstream spatial differencing
c     total derivative of depth(k) - upstream differencing
c     divergence, centered differnecing, except at boundary
c
            phpt=(hnew(i,j,k)-hold(i,j,k))/datadt
            vphpxy =abs(uchk)*(h(i2,j,k)-h(i1,j,k))/deltax(j)
     &            +abs(vchk)*(h(i,j2,k)-h(i,j1,k))/deltay
            dhdt(k)=phpt+vphpxy
            dddt(k)=dhdt(k)
            if (k.gt.1) dddt(k)=dhdt(k)-dhdt(k-1)
c
            if (lstagr) then
c
              if (j.eq.1) then
                dy=0.
              else
                dy=(v(i,j,k)-v(i,jm1,k))/deltay
              endif
c
              if (i.eq.1) then
                dx=0.
              else
                dx=(u(i,j,k)-u(im1,j,k))/deltax(j)
              endif
c
            else
c
              if (j.eq.1) then
                dy=(v(i,2,k)-v(i,1,k))/deltay
              else if (j.eq.noy) then
                dy=(v(i,noy,k)-v(i,noym1,k))/deltay
              else
                dy=(v(i,jp1,k)-v(i,jm1,k))/(2.0*deltay)
              endif
c
              if (i.eq.1) then
                dx=(u(2,j,k)-u(1,j,k))/deltax(j)
              else if (i.eq.nox) then
                dx=(u(nox,j,k)-u(noxm1,j,k))/deltax(j)
              else
                dx=(u(ip1,j,k)-u(im1,j,k))/(2.0*deltax(j))
              endif
c
            endif
c
            div(k)=dx+dy
  200     continue
c
c     first calculate w(k) from div(k)
c
c     note: curvature term = v * tan(phi) / a
c
          if (lstagr) then
            vchk = .5*(v(i,j,1)+v(i,jj1,1))
          else
            vchk = v(i,j,1)
          endif
          w(1)=-div(1)*depth(i,j,1)+vchk*tphioa(j)*depth(i,j,1)
          do 320 k=2,nlayer
            if (lstagr) then
              vchk = .5*(v(i,j,k)+v(i,jj1,k))
            else
              vchk = v(i,j,k)
            endif
            w(k)=w(k-1)-div(k)*depth(i,j,k)+vchk*tphioa(j)*depth(i,j,k)
  320     continue
c
c     entrainment and diluation variables for cell (i,j)
c
          do 330 k=1,nlayer
            eta(i,j,k)=(dhdt(k)-w(k))
            dilut(i,j,k)=dddt(k)
  330     continue
  300   continue
  301 continue
c
      return
      end
