C      uamvbinr.f
c      based on uamvascii.f
c      CONVERTS ASCII UAM-V FILES TO BINARY
C
C
      include 'uamvbinr.inc'

      CHARACTER*80 InName,OutName,ErrName
      CHARACTER*10 IFILE

      WRITE (*,100) 'ENTER FILE TYPE TO BE CONVERTED: '
      READ (*,102) IFILE
      WRITE (*,100) 'ENTER ASCII INPUT FILE TO BE CONVERTED: '
      READ (*,102) InName
      WRITE (*,100) 'ENTER NAME OF BINARY OUTPUT FILE: '
      READ (*,102) OutName
      WRITE (*,100) 'ENTER NAME FOR DIAGNOSTIC FILE: '
      READ (*,102) ErrName

      write(*,100) 'ENTER NOX, NOY, and NOZ: '
      read(*,*) nox, noy, nlayer


      if (nox .gt. mxx .or. noy .gt. mxy) then
        write(*,*) 'Maximum region dimension exceeded.'
        write(*,*) 'Max x by y size is ', mxx, ' by ', mxy
        stop
      endif


  100 FORMAT ($A)
  101 FORMAT (I4)
  102 FORMAT (A)
 
      OPEN (InNum,FILE=InName,STATUS='OLD')
      OPEN (OutNum,FILE=OutName,FORM='UNFORMATTED')
      OPEN (ErrNum,FILE=ErrName)
 
      IDONE=0
      IF (IFILE .EQ. 'WIND      ')      THEN 
          CALL MDFBIN (IFILE)
      ELSE IF (IFILE .EQ. 'HEIGHT    ') THEN 
          CALL MIXHTBIN (IFILE)
      ELSE IF (IFILE .EQ. 'TEMPERATUR') THEN 
          CALL ITEMPBIN (IFILE)
      ELSE IF (IFILE .EQ. 'H2O       ') THEN 
          CALL IUH2OBIN (IFILE)
      ELSE IF (IFILE .EQ. 'SURFACE   ') THEN 
          CALL ISURFBIN (IFILE)
      ELSE IF (IFILE .EQ. 'TERRAIN   ') THEN 
          CALL ITERRBIN (IFILE)
      ELSE IF (IFILE .EQ. 'VDIFFUSION') THEN 
          CALL IKVBIN (IFILE)
      ELSE IF (IFILE .EQ. 'INSTANT   ') THEN
          CALL OUTCCBIN(IFILE)
      ELSE IF (IFILE .EQ. 'FINSTANT  ') THEN
          CALL OUTFCBIN(IFILE)
      ELSE IF (IFILE .EQ. 'FAVERAGE  ') THEN
          CALL OUTFABIN(IFILE)
      ELSE
          WRITE (*,1111) IFILE
          WRITE (*,1112)
          STOP
      ENDIF

 1111 FORMAT ('UNKNOWN FILE TYPE ',A)
 1112 FORMAT ('VALID FILE TYPES ARE:',/,
     & 'WIND  ',/,
     & 'HEIGHT',/,
     & 'TEMPERATURE',/,
     & 'H2O',/,
     & 'SURFACE',/,
     & 'TERRAIN',/,
     & 'VDIFFUSION',/,
     & 'INSTANT',/,
     & 'FINSTANT',/,
     & 'FAVERAGE',/,
     X 'RERUN THE PROGRAM WITH ONE OF THE ABOVE NAMES')

      WRITE(*,1113) InName
 1113 FORMAT ('COMPLETED CONVERSION FOR FILE ',A)

      close(InNum)
      close(OutNum)
      close(ErrNum)

      STOP
      END
